SystemOrganization addCategory: #Nautilus!
SystemOrganization addCategory: #'Nautilus-Help'!
SystemOrganization addCategory: #'Nautilus-History'!
SystemOrganization addCategory: #'Nautilus-MCBindings'!
SystemOrganization addCategory: #'Nautilus-MorphTreeWidget-Extension'!
SystemOrganization addCategory: #'Nautilus-Tests'!
SystemOrganization addCategory: #'Nautilus-Widgets'!

!String class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:07'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #string! !

!Morph class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:07'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #morph! !

TransformWithLayoutMorph subclass: #TransformWithLayoutMorphForMultipleEditors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!TransformWithLayoutMorphForMultipleEditors commentStamp: '<historical>' prior: 0!
A TransformWithLayoutMorphExpander is a layout which expand its submorph.

I am designed for having only one submorph !!

I am really specific to the multi source code widget!

!TransformWithLayoutMorphForMultipleEditors methodsFor: 'geometry' stamp: 'BenjaminVanRyseghem 8/5/2012 16:23'!
bounds: newBounds
	| oldExtent newExtent |
	oldExtent := self extent.
	newExtent := newBounds extent.
	(oldExtent dotProduct: oldExtent) <= (newExtent dotProduct: newExtent) ifTrue:[
		"We're growing. First move then resize."
		self position: newBounds topLeft; extent: newExtent.
		self updateSubMorph: newBounds.
	] ifFalse:[
		"We're shrinking. First resize then move."
		self extent: newExtent; position: newBounds topLeft.
	].! !

!TransformWithLayoutMorphForMultipleEditors methodsFor: 'geometry' stamp: 'BenjaminVanRyseghem 8/5/2012 18:16'!
updateSubMorph: newBounds
	| submorph delta |
	
	delta := StandardFonts codeFont height *2 + 10.
	self submorphs ifEmpty: [ ^ self ].
	submorph := self submorphs first.
	submorph submorphs ifEmpty: [ ^ self ].
	
	submorph height < newBounds height 
		ifTrue: [ 
			" Growing "
			submorph height: newBounds height ].
	submorph submorphs last height > newBounds height 
		ifTrue: [ | height |
			" Shrinking "
			height := submorph submorphs allButLast inject: 0 into: [:sum :e | e height + sum ].
			height := height + ( newBounds height ).
			submorph height: height ]! !

PanelMorph subclass: #MultipleMethodsEditor
	instanceVariableNames: 'buttonsContainer container current editors lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!MultipleMethodsEditor commentStamp: '<historical>' prior: 0!
A MultipleMethodsEditor is a widget to edit multiple methods in one widget!

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/6/2012 17:59'!
addAllButton
	
	buttonsContainer addMorph: self newAllButton! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/6/2012 18:13'!
addButtons
	editors
		doWithIndex: [ :e :i | 
			| button |
			(i == 1)
				ifTrue: [ 
					button := self newButtonFor: e label: 'current']
				ifFalse: [ 
					button := self newButtonFor: e label: (i-1) printString .
					button setBalloonText: e balloonText ].
			buttonsContainer addMorph: button ]! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/5/2012 21:41'!
addEditor: anEditor

	editors addFirst: anEditor.
	anEditor 
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	
	anEditor when: #vScroll send: #scrollFromEditor: to: self.

	current := anEditor.
	self updateScroller! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/5/2012 22:04'!
addHFill
	buttonsContainer
		addMorph:
			(Morph new
				hResizing: #spaceFill;
				height: 0;
				yourself)! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'IgorStasenko 12/19/2012 18:02'!
addSplitterBetween: e and: below to: panel at: newCumulatedHeight
	| splitter |
	splitter := ProportionalSplitterMorph new
		beSplitsTopAndBottom;
		yourself.
	splitter
		addLeftOrTop: e;
		addRightOrBottom: below.
	panel
		addMorph: splitter
		fullFrame: ((0 @ newCumulatedHeight corner: 1 @ newCumulatedHeight) asLayoutFrame 
						topOffset: -2 ;
						bottomOffset: 2)! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'CamilloBruni 9/17/2012 21:18'!
giveFocusToDefault

	self hasSingleElement ifTrue: [ ^ self ].
	buttonsContainer submorphs copy reversed second model action! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/5/2012 19:47'!
hasMultipleElements

	^ editors size > 1! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/5/2012 19:47'!
hasSingleElement

	^ editors size = 1! !

!MultipleMethodsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/6/2012 00:56'!
initialize
	"Initialization code for MultipleMethodsEditor"

	super initialize.
	self changeProportionalLayout.
	self color: Color white.
	lock := false.
	buttonsContainer := PanelMorph new
							changeTableLayout;
							listDirection: #rightToLeft;
							hResizing: #spaceFill;
							vResizing: #spaceFill;
							yourself.
							
	editors := OrderedCollection new.
	container := self newProportionalPanelMorph.
					
	self updateLayoutForSingle! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'IgorStasenko 12/20/2012 14:43'!
layoutFor: i startingAt: cumulatedHeight finishingAt: newCumulatedHeight

	^ (0 @ cumulatedHeight corner: 1 @ newCumulatedHeight) asLayoutFrame
		topOffset: (i == 1 ifTrue: [ 0 ] ifFalse: [ 2 ]);
		bottomOffset: (i == editors size ifTrue: [ 0 ] ifFalse: [ -2 ])! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/6/2012 18:00'!
newAllButton
	
	| model |
	model := MultipleMethodsEditorAllButtonModel on: self.
	
	^ PluggableButtonMorph
			on: model
			getState: #state
			action: #action
			label: #label! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/6/2012 18:06'!
newButtonFor: e label: label
	| model |

	model := MultipleMethodsEditorButtonModel
		on: self
		label: label
		target: e.
		
	^ PluggableButtonMorph
		on: model
		getState: #state
		action: #action
		label: #label! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/6/2012 18:01'!
newButtonFor: e value: buttonValue label: label
	| model |

	model := MultipleMethodsEditorButtonModel
		on: self
		value: buttonValue
		label: label
		target: e.
		
	^ PluggableButtonMorph
		on: model
		getState: #state
		action: #action
		label: #label! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/5/2012 22:04'!
newProportionalPanelMorph
	| panel |
	panel := PanelMorph new
		color: Color white;
		changeProportionalLayout;
		yourself.
	^ panel! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/5/2012 21:49'!
newScrollPaneWithScroller: scroller target: target
	| pane |
	
	pane := GeneralScrollPane new
						removeAllMorphs;
						scroller: scroller;
						yourself.

	pane
		scrollTarget: target;
		addMorph: scroller;
		resizeScroller;
		hScrollbarShowNever.
		
	^ pane! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 00:55'!
removeEditor: anEditor

	editors remove: anEditor.
	current = anEditor
		ifTrue: [ current := editors at: 1 ifAbsent:[ nil ]].

	self updateScroller! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 19:36'!
rgiveFocusToCurrent

	self hasSingleElement ifTrue: [ ^ self ].
	self setDefault.
	self updateLayoutForSingleWithButtons! !

!MultipleMethodsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/5/2012 21:40'!
scrollFromEditor: aValue
	
	self hasMultipleElements ifFalse: [ ^ self ].
	lock ifTrue: [ ^ self ].
	lock := true.

	aValue = 0
		ifTrue: [ container vScrollbar setValue: container vScrollbar value - 0.1 ].

	aValue = 1
		ifTrue: [ container vScrollbar setValue: container vScrollbar value + 0.1 ].
		
	lock := false! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:04'!
setCurrent: anEditor

	(editors includes: anEditor) ifFalse: [ ^ self ].
	current := anEditor! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 19:33'!
setDefault

	current := editors first! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:25'!
updateButtonsStateFrom: aModel

	(buttonsContainer submorphs last: (editors size+1)) do:[:e | 
		e model == aModel 
			ifFalse: [ e model setState: false ].
		e update: #state ]! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/6/2012 18:08'!
updateEditorsWith: firstHeight over: totalHeight into: panel
	| cumulatedHeight size |
	
	size := editors size.
	cumulatedHeight := 0.
	editors
		doWithIndex: [ :e :i | 
			| height newCumulatedHeight  |
			height := i == 1
				ifTrue: [ firstHeight ]
				ifFalse: [ 
					e vResizing: #rigid.
					e height ].
			newCumulatedHeight := cumulatedHeight + (height / totalHeight).
			panel addMorph: e fullFrame: (self layoutFor: i startingAt: cumulatedHeight finishingAt: newCumulatedHeight).
			i == size
				ifFalse: [ 
					| below |
					below := editors at: i + 1.
					self
						addSplitterBetween: e
						and: below
						to: panel
						at: newCumulatedHeight ].
			cumulatedHeight := newCumulatedHeight ]! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'IgorStasenko 12/19/2012 18:04'!
updateLayoutForMultiple

	self 
		addMorph: container
		fullFrame: (LayoutFrame identity
						bottomOffset: -25).
	self 
		addMorph: buttonsContainer
		fullFrame:  ((0@1 corner: 1@1) asLayoutFrame 
						topOffset: -25).! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'IgorStasenko 12/19/2012 18:04'!
updateLayoutForSingle

	current ifNil: [ ^ self ].
	self 
		addMorph: current
		fullFrame: LayoutFrame identity.
					
	current color: Color white.
! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'IgorStasenko 12/19/2012 18:05'!
updateLayoutForSingleWithButtons

	current ifNil: [ ^ self ].
	self 
		addMorph: current
		fullFrame: (LayoutFrame identity 
						topOffset: -25).
					
	self 
		addMorph: buttonsContainer
		fullFrame: ((0@1 corner: 1@1) asLayoutFrame 
						topOffset: -25).
	current color: Color white.
! !

!MultipleMethodsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/5/2012 21:41'!
updateScroller

	container removeAllMorphs.
	buttonsContainer removeAllMorphs.
	
	self hasSingleElement
		ifTrue: [ 
			self 
				updateScrollerWithOneElement;
				updateLayoutForSingle]
		ifFalse: [ 
			self 
				updateScrollerWithMultipleElements;
				updateLayoutForMultiple ].
	! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/6/2012 18:10'!
updateScrollerWithMultipleElements
	| size panel totalHeight delta scroller firstHeight |
	
	delta := editors second font height * 2 + 10.
	size := editors size.
	firstHeight := self height - delta.
	
	totalHeight := (editors allButFirst inject: 0 into: [ :s :e | s + e height ]) + firstHeight + ((size - 1) * 4).
	
	panel := self newProportionalPanelMorph.
	
	scroller := TransformWithLayoutMorphForMultipleEditors new.
	container := self newScrollPaneWithScroller: scroller target: panel.
	container scroller changeTableLayout.
	
	self updateEditorsWith: firstHeight over: totalHeight into: panel.

	self addAllButton.
	self addButtons.
	
	self addHFill.
	
	panel hResizing: #spaceFill.
	panel extent: 0 @ (totalHeight - delta)! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/6/2012 18:23'!
updateScrollerWithMultipleElementsWithoutButtons
	| size panel totalHeight delta scroller firstHeight |
	
	delta := editors second font height * 2 + 10.
	size := editors size.
	firstHeight := self height - delta.
	
	totalHeight := (editors allButFirst inject: 0 into: [ :s :e | s + e height ]) + firstHeight + ((size - 1) * 4).
	
	panel := self newProportionalPanelMorph.
	
	scroller := TransformWithLayoutMorphForMultipleEditors new.
	container := self newScrollPaneWithScroller: scroller target: panel.
	container scroller changeTableLayout.
	
	self updateEditorsWith: firstHeight over: totalHeight into: panel.
	
	panel hResizing: #spaceFill.
	panel extent: 0 @ (totalHeight - delta)! !

!MultipleMethodsEditor methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 8/5/2012 22:11'!
updateScrollerWithOneElement
		
	"container 
		addMorph: current
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))"! !

Model subclass: #AbstractWidget
	instanceVariableNames: 'model iconClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractWidget commentStamp: '<historical>' prior: 0!
AbstractWidget is an abstraction for the different widget which could be used to compose the Nautilus UI!

AbstractWidget subclass: #AbstractCategoryWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractCategoryWidget commentStamp: '<historical>' prior: 0!
AbstractCategoryWidget is an abstraction describing a widget used to manage categories!

!AbstractCategoryWidget methodsFor: 'item creation' stamp: ''!
buildCategoriesList

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
categoriesMenu: aMenuMorph shifted: aBoolean 
	
	^ self model categoriesMenu: aMenuMorph shifted: aBoolean ! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
categoriesSelection

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 5/9/2012 11:34'!
dragPassengersFor: item inMorph: dragSource 

	| transferType object |
	
	(dragSource isKindOf: PluggableListMorph) ifFalse: [^ nil ].
	transferType := self dragTransferTypeForMorph: dragSource.
	object := item originalObject.
	transferType == #getCategoryItem: ifTrue: [ ^ self selectedCategories ifEmpty: [ { object } ] ].
	^ nil! !

!AbstractCategoryWidget methodsFor: 'drag and drop' stamp: ''!
dropMethod: aCollectionOfMethods inARow: aRow

	self model dropMethod: aCollectionOfMethods inARow: aRow! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
keyPressedOnCategory: anEvent

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
label: aString

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/17/2012 16:57'!
okToChange

	^ self model okToChange! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
searchedElement: index

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
selectedCategories

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
selectedCategory

	^ self model selectedCategory! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
showInstance

	^ self model showInstance! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
takeKeyboardFocus

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'icon' stamp: ''!
thereIsNoIconsOnCategories! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
vScrollValue

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: ''!
vScrollValue: aNumber

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 5/9/2012 11:35'!
wantsDroppedMorph: transferMorph event: anEvent inMorph: destinationLM 
	"We are only interested in TransferMorphs as wrappers for             
	informations. If their content is really interesting for us, will             
	determined later in >>acceptDroppingMorph:event:."

	| srcType dstType |

	"only want drops on lists (not, for example, on pluggable texts)"
	(destinationLM isKindOf: PluggableListMorph) ifFalse: [ ^ false ].

	srcType := transferMorph dragTransferType.
	dstType := self dragTransferTypeForMorph: destinationLM.

	^ srcType == #getMethodItem: and: [ dstType == #getCategoryItem:]! !

AbstractCategoryWidget subclass: #CategoryWidget
	instanceVariableNames: 'categoriesList categoriesGroup categoriesSelection categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!CategoryWidget commentStamp: '<historical>' prior: 0!
CategoryWidget is the basic implementation of a wiget managing categories!

!CategoryWidget class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 4/6/2012 16:57'!
buildProtocolShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusProtocolShortcuts
		default: $b command
		do: [ :target | target fullBrowse ]
		description: 'Open a new browser on the selection'.
		
	(aBuilder shortcut: #restrictedBrowseClass)
		category: #NautilusProtocolShortcuts
		default: $b command shift
		do: [ :target | target restrictedBrowseClass ]
		description: 'Open a restricted browser'.

	(aBuilder shortcut: #addProtocolsInGroup)
		category: #NautilusProtocolShortcuts
		default: $e command
		do: [ :target | target addProtocolsInGroup ]
		description: 'Add the selected protocols in a group'.
		
	(aBuilder shortcut: #findMethod)
		category: #NautilusProtocolShortcuts
		default: $f command
		do: [ :target | target findMethod ]
		description: 'Find a method'.
	
	(aBuilder shortcut: #addCategory)
		category: #NautilusProtocolShortcuts
		default: $n command
		do: [ :target | target addCategory ]
		description: 'Add a new protocol'.
	
	(aBuilder shortcut: #renameCategory)
		category: #NautilusProtocolShortcuts
		default: $r command
		do: [ :target | target enableCategorySingleSelection ifTrue: [target renameCategory ]]
		description: 'Rename the selected protocol'.
	
	(aBuilder shortcut: #removeCategories)
		category: #NautilusProtocolShortcuts
		default: $x command
		do: [ :target | target removeCategories ]
		description: 'Remove the selected protocols'.! !

!CategoryWidget class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 15:33'!
categoriesMenu: aBuilder
	<nautilusGlobalProtocolMenu>
	| target |
	
	target := aBuilder model.
	(aBuilder item: #'Find Method...')
		keyText: 'f, m' if: Nautilus useOldStyleKeys not;
		keyText: 'f' if: Nautilus useOldStyleKeys;
		action: [ target findMethod ];
		order: 0;
		help: 'Search for a method by name'.
			
	(aBuilder item: #'Add protocol...')
		keyText: 'n, t' if: Nautilus useOldStyleKeys not;
		action: [ target addCategory ];
		order: 100;
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full')
		keyText: 'b, f' if: Nautilus useOldStyleKeys not;
		keyText: 'b' if: Nautilus useOldStyleKeys;
		action: [ target fullBrowse ];
		order: 200;
		withSeparatorAfter.
		
	(aBuilder item: #'Categorize all uncategorized')
		keyText: 'h, C' if: Nautilus useOldStyleKeys not;
		action: [ target categorizeAllUncategorizedMethods ];
		order: 1100.	
		
	(aBuilder item: #'Remove empty protocols')
		action: [ target removeEmptyCategories ];
		order: 1200;
		withSeparatorAfter.
		
	target selectedCategory ifNil: [ ^ target ].
	
	(aBuilder item: #'Rename...')
		keyText: 'r, m' if: Nautilus useOldStyleKeys not;
		keyText: 'r' if: Nautilus useOldStyleKeys;
		action: [ target renameCategory ];
		order: 1300;
		enabledBlock: [ target enableCategorySingleSelection ].	
		
	(aBuilder item: #'Remove...')
		keyText: 'x, m' if: Nautilus useOldStyleKeys not;
		keyText: 'x' if: Nautilus useOldStyleKeys;
		action: [ target removeCategories ];
		order: 1400;
		icon: (target iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'Add in group...')
		keyText: 'n, e, m' if: Nautilus useOldStyleKeys not;
		action: [ target addProtocolsInGroup ];
		order: 1500.
	
	(aBuilder item: #'File Out')
		action: [ target fileOutCategories ];
		order: 1600.! !

!CategoryWidget methodsFor: 'item creation' stamp: 'EstebanLorenzano 2/6/2013 16:56'!
buildCategoriesList

	^categoriesList := PluggableIconListMorph new
		basicWrapSelector: #categoryWrapper:;
		resetListSelector: #resetCategoriesListSelection;
		keystrokeSelector: #keyPressedOnCategory:;
		autoDeselect: true;
		getListSizeSelector: #categoryListSize;
		
		dropItemSelector: #dropMethod:inARow:;
		dragEnabled: true; dropEnabled: true;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		
		model: self;
		getIndexSelector: #selectedCategoryIndex;
		setIndexSelector: #selectedCategoryIndex:;
		getSelectionListSelector: #categorySelectionAt:;
		setSelectionListSelector: #categorySelectionAt:put:;
		getMenuSelector: #categoriesMenu:shifted:;
		beMultipleSelection;
		
		getListElementSelector: #getCategoryItem:;
		
		changed
	
! !

!CategoryWidget methodsFor: 'private' stamp: ''!
categoriesLabel

	^ self showInstance
		ifTrue: ['Instance protocols:' asText]
		ifFalse: ['Class protocols:' asText allBold ]! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
categoriesSelection

	^ categoriesSelection! !

!CategoryWidget methodsFor: 'private' stamp: ''!
categoryListSize

	^ self getCategories size! !

!CategoryWidget methodsFor: 'selection' stamp: ''!
categorySelectionAt: anIndex

	| elt |
	elt := self getCategories at: anIndex ifAbsent: [ nil ].
	^ categoriesSelection at: elt ifAbsent: [ false ].! !

!CategoryWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 5/7/2012 14:37'!
categorySelectionAt: anIndex put: aBoolean
	| elt |
	
	elt := self getCategories at: anIndex ifAbsent: [ nil ].
	categoriesSelection at: elt put: aBoolean.
	self model categorySelectionChanged.
	^ aBoolean! !

!CategoryWidget methodsFor: 'private' stamp: ''!
categoryWrapper: anItem
	| package class result |

	package := self model selectedPackage.
	class := self model selectedClass.
	result := anItem asMorph.
	anItem first == $*
		ifTrue: [ | item |
			item := anItem allButFirst asLowercase.
			((item = package name asLowercase) or: 
				[ (item beginsWith: package name asLowercase) and: [ (item at: (package name size +1)) =$-]])
				ifFalse: [ result := anItem asMorph color: self model extensionColor; yourself ]]
		ifFalse: [
			(package extendedClasses includes: class)
				ifTrue: [ result := anItem asMorph color: self model extensionColor; yourself ]].
	self model showInstance
		ifFalse: [ result emphasis: 1 ].
	^ result! !

!CategoryWidget methodsFor: 'private' stamp: ''!
deselectProtocol: aString

	categoriesSelection at: aString put: false! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
getCategories

	^ categories ifNil: [ categories := self loadCategories ].! !

!CategoryWidget methodsFor: 'private' stamp: ''!
getCategoryItem: anIndex

	^ self getCategories at: anIndex! !

!CategoryWidget methodsFor: 'private' stamp: ''!
hasFocus
	
	^ categoriesList hasKeyboardFocus! !

!CategoryWidget methodsFor: 'initialize-release' stamp: ''!
initialize

	super initialize.
	categoriesSelection := Dictionary new.! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/25/2012 11:12'!
keyPressedOnCategory: anEvent
	| aCharacter |

	aCharacter := anEvent keyCharacter.

	(aCharacter == self model class nextFocusKey) ifTrue: [ ^ self model giveFocusTo: self model methodWidget ].
	(aCharacter == self model class previousFocusKey) ifTrue: [ ^ self model giveFocusTo: self model classWidget ].
	! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/23/2012 18:54'!
label: aString

	"categoriesGroup label: aString"! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
loadCategories
	| class |
	class := self model selectedClass.
	class ifNil: [ ^ #() ].
	
	^ self model showGroups
		ifTrue: [ self loadGroupsCategoriesFor: class ]
		ifFalse: [ self loadPackagesCategoriesFor: class ]! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadCategoriesWithProtocols: protocols forClass: class
	| package result tmp |
	
	package := self model selectedPackage.
	result := OrderedCollection with: self model allLabel.
	tmp := #().
	tmp := protocols
		select: [ :each | 
			| item |
			each first = $*
				ifTrue: [ 
					item := each allButFirst asLowercase.
					item = package name asLowercase
						or: [ (item beginsWith: package name asLowercase) and: [ ((item at: package name size + 1) = $-) not ]]]
				ifFalse: [ false ]].
	result addAll: tmp sort.
	tmp := protocols reject: [ :e | tmp includes: e ].
	result addAll: tmp sort.
	^ result! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadGroupsCategoriesFor: class
	| env |
	
	env := model browsedEnvironment.
	^ env isSystem
		ifTrue: [ self loadGroupsCategoriesInSytemEnvironmentFor: class ]
		ifFalse: [ self loadGroupsCategoriesInARestrictedEnvironment: env for: class ]! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadGroupsCategoriesInARestrictedEnvironment: env for: class
	| group |
	
	group := self model selectedGroup.
	^ self loadCategoriesWithProtocols: ((group protocolsFor: class ) intersection: ( env protocolsFor: class )) forClass: class! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadGroupsCategoriesInSytemEnvironmentFor: class
	| group |

	group := self model selectedGroup.
	^ self loadCategoriesWithProtocols: (group protocolsFor: class ) forClass: class! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadPackagesCategoriesFor: class
	| env |
	
	env :=  self model browsedEnvironment.
	^env isSystem
		ifTrue: [ self loadPackagesCategoriesInSystemEnvironmentFor: class ]
		ifFalse: [ self loadPackagesCategoriesInARestrictedEnvironment: env for: class  ]! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadPackagesCategoriesInARestrictedEnvironment: env for: class
	| group |
	
	group := self model selectedGroup.
	^ self loadCategoriesWithProtocols: (model browsedEnvironment protocolsFor: class) forClass: class! !

!CategoryWidget methodsFor: 'private' stamp: ''!
loadPackagesCategoriesInSystemEnvironmentFor: class
	| group |
	
	group := self model selectedGroup.
	^ self loadCategoriesWithProtocols: class protocols forClass: class! !

!CategoryWidget methodsFor: 'initialize-release' stamp: ''!
model: aModel
	
	super model: aModel.
	self selectedCategory
		ifNotNil: [:cat | categoriesSelection at: cat put: true ]! !

!CategoryWidget methodsFor: 'selection' stamp: ''!
resetCategoriesListSelection

	categoriesSelection removeAll! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
resetCategoryCache

	categories := nil! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/27/2012 00:34'!
resetSelection

	self categoriesSelection removeAll! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
searchedElement: index

	categoriesList searchedElement: index! !

!CategoryWidget methodsFor: 'private' stamp: ''!
selectProtocol: aString

	categoriesSelection at: aString put: true! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
selectedCategories

	| associations |
	associations := self categoriesSelection associations select: [:assoc | assoc value == true ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!CategoryWidget methodsFor: 'selection' stamp: ''!
selectedCategoryIndex

	^ self getCategories indexOf: self selectedCategory ifAbsent: [ 0 ]! !

!CategoryWidget methodsFor: 'selection' stamp: 'CamilloBruni 10/4/2012 10:50'!
selectedCategoryIndex: anInteger

	| anObject |
	anObject := self getCategories at: anInteger ifAbsent: [ nil ].
	self model selectedCategory: anObject.
	
	self changed: #selectedCategoryIndex.
	self model categorySelectionChanged.
	self model changed: #currentHistoryIndex.! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
takeKeyboardFocus

	categoriesList takeKeyboardFocus! !

!CategoryWidget methodsFor: 'icon' stamp: ''!
thereIsNoIconsOnCategories! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
vScrollValue

	^ categoriesList scrollValue y! !

!CategoryWidget methodsFor: 'protocol' stamp: ''!
vScrollValue: aNumber

	^ categoriesList vScrollValue: aNumber! !

AbstractWidget subclass: #AbstractMethodWidget
	instanceVariableNames: ''
	classVariableNames: 'MethodsIconsCache'
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractMethodWidget commentStamp: '<historical>' prior: 0!
AbstractMethodWidget is an abstraction describing a widget used to manage methods!

!AbstractMethodWidget class methodsFor: 'icon' stamp: ''!
resetMethodsIconsCache

	MethodsIconsCache removeAll! !

!AbstractMethodWidget methodsFor: 'items creation' stamp: ''!
buildMethodsList

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'icon' stamp: ''!
buildUpAndDownArrowIcon: aMethod

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := IconicButton new 
				target: self model;
				actionSelector: #arrowUp:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleUp);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriden message';
				borderWidth: 0.
				
	down :=  IconicButton new 
				target: self model;
				actionSelector: #arrowDown:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleDown);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriding messages';
				borderWidth: 0.
				
	^ (container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself) -> {up. down}.! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/14/2012 11:56'!
deselectMethod: aMethod

	self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 5/9/2012 11:33'!
dragPassengersFor: item inMorph: dragSource 

	| transferType object |
	(dragSource isKindOf: PluggableListMorph) ifFalse: [^ nil ].
	transferType := self dragTransferTypeForMorph: dragSource.
	transferType == #getMethodItem: ifFalse: [ ^ nil ].
	object := item originalObject.

	^ self selectedMethods
		ifEmpty: [
			 (self getMethods includes: object)
				ifTrue: [ { object } ]
				ifFalse: [ "to test" self halt. ] ]! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
elementsMenu: aMenuMorph shifted: aBoolean 
	
	^ self model elementsMenu: aMenuMorph shifted: aBoolean ! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
getMethods

	^ self model getMethods! !

!AbstractMethodWidget methodsFor: 'initialize-release' stamp: ''!
initialize

	super initialize.
	MethodsIconsCache ifNil: [ MethodsIconsCache := WeakIdentityKeyDictionary new ]! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
keyPressedOnElement: anEvent 

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
label: aString

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 1/2/2013 13:10'!
methodIconFor: aMethod

	| actions result button action |
	button := nil.
	MethodsIconsCache
		at: aMethod
		ifPresent: [:icon | 
			icon isArray ifTrue: [ ^ self rebuildUpAndDownArrowIconFrom: icon].
			icon class == IconicButtonStateHolder ifFalse: [ ^ icon ].
			^ icon asIconTargetting: self model ].

	actions := AbstractMethodIconAction allSubclasses collect: [:class | class for: aMethod in: self model ].
	actions sort: [:a :b | a actionOrder < b actionOrder ].
	action := actions detect: [:each | each isActionHandled ] ifNone: [ self flag: 'should never happend' ]. 
	
	"actionIcon need to be invoked before actionStateToCache"
	button := action actionIcon.
	MethodsIconsCache at: aMethod put: action actionStateToCache.
	^ button! !

!AbstractMethodWidget methodsFor: 'icon' stamp: ''!
methodsIconsCache

	^ MethodsIconsCache! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
methodsSelection

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/17/2012 17:13'!
okToChange

	^ self model okToChange. ! !

!AbstractMethodWidget methodsFor: 'icon' stamp: ''!
rebuildIconicButtonFrom: icon

	^ IconicButton new 
		target: self model;
		actionSelector: icon actionSelector;
		arguments: icon arguments;
		labelGraphic: icon labelGraphic;
		color: icon color;
		helpText: icon helpText;
		extent: icon extent;
		borderWidth: icon borderWidth! !

!AbstractMethodWidget methodsFor: 'icon' stamp: ''!
rebuildUpAndDownArrowIconFrom: array

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := array first asIconTargetting: self model.
				
	down := array second asIconTargetting: self model.
				
	^ container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
removeAllFromMethodsIconsCache: aMethod

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/14/2012 11:57'!
selectMethod: aMethod

	self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
selectedMethod

	^ self model selectedMethod! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 19:41'!
selectedMethod: aMethod
	"I check if it's ok here to work better with the drag/drop mechanism"

	self model selectedMethod: aMethod! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
selectedMethods

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/4/2012 16:05'!
setIcon: icon for: method

	MethodsIconsCache at: method put: icon! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
showInstance

	^ self model showInstance! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
takeKeyboardFocus

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
vScrollValue

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: ''!
vScrollValue: aNumber

	^ self subclassResponsibility! !

AbstractMethodWidget subclass: #MethodWidget
	instanceVariableNames: 'methodsList methodsSelection methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodWidget commentStamp: '<historical>' prior: 0!
MethodWidget is the basic implementation of a wiget managing methods!

!MethodWidget class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 4/6/2012 16:57'!
buildMethodShortcutsOn: aBuilder
	<keymap>	

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusMethodShortcuts
		default: $b command
		do: [ :target | target fullBrowse ]
		description: 'Open a new browser on the selection'.
		
	(aBuilder shortcut: #restrictedBrowseClass)
		category: #NautilusMethodShortcuts
		default: $b command shift
		do: [ :target | target restrictedBrowseClass ]
		description: 'Open a restricted browser'.
		
	(aBuilder shortcut: #categorizeMethod)
		category: #NautilusMethodShortcuts
		default: $c command shift
		do: [ :target | target categorizeMethod ]
		description: 'Recategorize the selected methods'.
	
	(aBuilder shortcut: #addMethodsInGroup)
		category: #NautilusMethodShortcuts
		default: $e command
		do: [ :target | target addMethodsInGroup ]
		description: 'Add the selected methods in a group'.
	
	(aBuilder shortcut: #findMethod)
		category: #NautilusMethodShortcuts
		default: $f command
		do: [ :target | target findMethod ]
		description: 'Find a method'.
	
	(aBuilder shortcut: #methodHierarchy)
		category: #NautilusMethodShortcuts
		default: $i command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target methodHierarchy ]]
		description: 'Spawn selected method hierarchy'.
		
	(aBuilder shortcut: #generateTestMethodsAndFocus)
		category: #NautilusMethodShortcuts
		default: $j command
		do: [ :target | target generateTestMethodsAndFocus: true ]
		description: 'Generate test methods for the selected methods and jump to them'.
		
	(aBuilder shortcut: #generateTestMethods)
		category: #NautilusMethodShortcuts
		default: $j command shift
		do: [ :target | target generateTestMethodsAndFocus: false ]
		description: 'Generate test methods for the selected methods'.
		
	(aBuilder shortcut: #browseMessages)
		category: #NautilusMethodShortcuts
		default: $m command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target browseMessages ]]
		description: 'Browse implementors'.
	
	(aBuilder shortcut: #browseSendersOfMessages)
		category: #NautilusMethodShortcuts
		default: $n command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target browseSendersOfMessages ]]
		description: 'Browse senders'.
	
	(aBuilder shortcut: #runTestFor)
		category: #NautilusMethodShortcuts
		default: $t command
		do: [ :target | target runTestForMethods: target selectedMethods notifying: true]
		description: 'Run the selected test methods'.
		
	(aBuilder shortcut: #browseVersions)
		category: #NautilusMethodShortcuts
		default: $v command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target browseVersions ]]
		description: 'Browse version'.		
	
	(aBuilder shortcut: #removeMethods)
		category: #NautilusMethodShortcuts
		default: $x command
		do: [ :target | target removeMethods ]
		description: 'Remove the selected methods'.! !

!MethodWidget class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 15:28'!
elementsMenu: aBuilder
	<nautilusGlobalMethodMenu>
	| selectedMethods selectedMethod tmp target |
	target := aBuilder model.
	selectedMethods := target selectedMethods.
	selectedMethod := target selectedMethod.
	
	(aBuilder item: #'Find Method...')
		keyText: 'f, m' if: Nautilus useOldStyleKeys not;
		keyText: 'f' if: Nautilus useOldStyleKeys;
		action: [ target findMethod ];
		order: 0;
		help: 'Search for a method by name'.
	
	target selectedMethod ifNotNil: [ 
		(aBuilder item: #'ToggleBreakPoint')
			action: [ target toggleBreakPoint ];
			order: 199;
			label: (selectedMethod hasBreakpoint
					ifFalse: [ 'Add breakpoint']
					ifTrue: [ 'Remove breakpoint'] )].
		
	tmp := ((aBuilder item: #'Browse full')
		keyText: 'b, f' if: Nautilus useOldStyleKeys not;
		keyText: 'b' if: Nautilus useOldStyleKeys;
		action: [ target fullBrowse ];
		order: 200;
		yourself).
		
	target selectedMethod ifNil: [
		tmp withSeparatorAfter.
		 ^ target ].
	
	(aBuilder item: #'Generate test and jump')
		keyText: 'h, j' if: Nautilus useOldStyleKeys not;
		keyText: 'j' if: Nautilus useOldStyleKeys;
		action: [ target generateTestMethodsAndFocus: true ];
		order: 300.
		
	(aBuilder item: #'Generate test')
		keyText: 'h, J' if: Nautilus useOldStyleKeys not;
		keyText: 'J' if: Nautilus useOldStyleKeys;
		action: [ target generateTestMethodsAndFocus: false ];
		order: 400;
		withSeparatorAfter.
		
	(target selectedMethods allSatisfy: [:meth | meth isTestMethod ])
		ifTrue: [
			(aBuilder item: #'Run tests')
				keyText: 'j, m' if: Nautilus useOldStyleKeys not;
				keyText: 't' if: Nautilus useOldStyleKeys;
				action: [ target runTestForMethods: selectedMethods notifying: true ];
				order: 1000 ].
			
	target selectedMethod correspondingTestMethod notNil
		ifTrue: [
			(aBuilder item: #'Debug tests')
				keyText: 'd' if: Nautilus useOldStyleKeys not;
				action: [ target debugTest ];
				order: 1001 ].		
	
	(aBuilder item: #'Senders of...')
		keyText: 'b, n' if: Nautilus useOldStyleKeys not;
		keyText: 'n' if: Nautilus useOldStyleKeys;
		action: [ target browseSendersOfMessages ];
		order: 1100;
		enabledBlock: [ target enableMethodSingleSelection ].
		
	(aBuilder item: #'Implementors of...')
		keyText: 'b, m' if: Nautilus useOldStyleKeys not;
		keyText: 'm' if: Nautilus useOldStyleKeys;
		action: [ target browseMessages ];
		order: 1200;
		enabledBlock: [ target enableMethodSingleSelection ].
		
	(aBuilder item: #'Inheritance')
		keyText: 'b, i' if: Nautilus useOldStyleKeys not;
		keyText: 'i' if: Nautilus useOldStyleKeys;
		action: [ target methodHierarchy ];
		order: 1300;
		enabledBlock: [ target enableMethodSingleSelection ].
		
	(aBuilder item: #'Versions')
		keyText: 'b, v' if: Nautilus useOldStyleKeys not;
		keyText: 'v' if: Nautilus useOldStyleKeys;
		action: [ target browseVersions ];
		order: 1400;
		enabledBlock: [ target enableMethodSingleSelection ];
		withSeparatorAfter.
	
	(aBuilder item: #'Categorize method')
		keyText: 'm, m' if: Nautilus useOldStyleKeys not;
		action: [ target categorizeMethod ];
		order: 1500.
		
	(aBuilder item: #'Move to package...')
		action: [ target moveMethodToPackage ];
		order: 1600.
		
	(aBuilder item: #'Remove...')
		keyText: 'x, m' if: Nautilus useOldStyleKeys not;
		keyText: 'x' if: Nautilus useOldStyleKeys;
		action: [ target removeMethods ];
		order: 1700;
		icon: (target iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'Add in group...')
		keyText: 'n, e, m' if: Nautilus useOldStyleKeys not;
		action: [ target addMethodsInGroup ];
		order: 1800.
			
	(aBuilder item: #'File Out')
		action: [ target fileOutMethods ];
		order: 1900! !

!MethodWidget methodsFor: 'item creation' stamp: 'EstebanLorenzano 2/6/2013 17:13'!
buildMethodsList
	
	methodsList :=  PluggableIconListMorph new
						basicWrapSelector: #methodWrapper:;
						keystrokeSelector: #keyPressedOnElement:; 
						getIconSelector: #methodIconFor:;
						resetListSelector: #resetMethodsListSelection;
						getListSizeSelector: #methodListSize;
						autoDeselect: true;
						dragEnabled: true; 
						hResizing: #spaceFill;
						vResizing: #spaceFill;
						
						model: self;
						getIndexSelector: #selectedMethodIndex;
						setIndexSelector: #selectedMethodIndex:;
						getSelectionListSelector: #methodSelectionAt:;
						setSelectionListSelector: #methodSelectionAt:put:;
						getMenuSelector: #elementsMenu:shifted:;
						beMultipleSelection.

		Nautilus populateMethodList
			ifTrue: [ methodsList getListElementSelector: #getMethodItem: ]
			ifFalse: [ methodsList basicGetListElementSelector: #getMethodItem: ].	
					
		^ methodsList.! !

!MethodWidget methodsFor: 'private' stamp: ''!
deselectMethod: aMethod

	methodsSelection at: aMethod put: false! !

!MethodWidget methodsFor: 'private' stamp: ''!
getMethodItem: anIndex
	
	^ self getMethods at: anIndex! !

!MethodWidget methodsFor: 'protocol' stamp: 'SeanDeNigris 7/7/2012 21:03'!
getMethods

	^ methods ifNil: [ methods := self loadMethods ].! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/14/2012 13:10'!
hasFocus

	^ methodsList hasKeyboardFocus! !

!MethodWidget methodsFor: 'private' stamp: ''!
initialize

	super initialize.
	methodsSelection := Dictionary new.! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/25/2012 11:15'!
keyPressedOnElement: anEvent
	| aCharacter |
	
	aCharacter := anEvent keyCharacter.

	aCharacter == self model class nextFocusKey ifTrue: [ ^ self model giveFocusTo: self model sourceTextArea ].	
	aCharacter == self model class previousFocusKey ifTrue: [ ^ self model giveFocusTo: self model categoryWidget ].
! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/23/2012 18:57'!
label: aString

	"methodsGroup label: aString"! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 14:34'!
loadMethods

	^ self model showGroups
		ifTrue: [ self model selectedCategories
					ifEmpty: [ self model methodsForCategoryInGroup: self model allLabel ]
					ifNotEmpty: [:cat | self model methodsForCategoriesInGroup: cat ]]
		ifFalse: [
			self model selectedCategories
				ifEmpty: [ self model methodsForCategory: self model allLabel ]
				ifNotEmpty: [:cat | self model methodsForCategories: cat ]]! !

!MethodWidget methodsFor: 'private' stamp: ''!
methodListSize
	
	^ self getMethods size! !

!MethodWidget methodsFor: 'selection' stamp: ''!
methodSelectionAt: anIndex

	| elt assoc |
	elt := self getMethods at: anIndex ifAbsent: [ ^ false ].
	
	(methodsSelection keys identityIncludes: elt) ifFalse: [ ^ false].
	
	assoc := methodsSelection associationAt: elt ifAbsent: [ ^ false ].
	assoc key selector = elt selector 
		ifTrue: [ ^ assoc value ]
		ifFalse: [ ^ false ]! !

!MethodWidget methodsFor: 'selection' stamp: ''!
methodSelectionAt: anIndex put: aBoolean

	| element |
	element := self getMethods at: anIndex ifAbsent: [ ^ self ].
	methodsSelection at: element put: aBoolean.! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/14/2013 08:21'!
methodWrapper: anItem
	| package selector result emphasis |
	
	selector := anItem selector.
	package := self model selectedPackage.
	result := selector asMorph.
	emphasis := 0.
	anItem protocol asString first = $*
		ifTrue: [ | item |
			item := anItem protocol allButFirst asLowercase.
			((item = package name asLowercase) or: 
				[ (item beginsWith: package name asLowercase) and: [( item at: (package name size +1)) =$-]])
				ifFalse: [ result := selector asMorph color: self model extensionColor ; yourself ]]
		ifFalse: [ 
			(package extendedClasses includes: anItem methodClass)
				ifTrue: [  result := selector asMorph color: self model extensionColor ; yourself ]].
	
	anItem isFromTrait
		ifTrue: [ 
			| trait |
			trait := anItem origin.
			selector := selector, ' (', trait name ,')'.
			result := selector asMorph.
			emphasis := emphasis + 2 ].
	self model showInstance
		ifFalse: [ emphasis := emphasis + 1 ].
	^ result emphasis: emphasis.! !

!MethodWidget methodsFor: 'private' stamp: ''!
methodsLabel

	^ self showInstance
		ifTrue: ['Instance methods' asText ]
		ifFalse: ['Class methods' asText allBold ]! !

!MethodWidget methodsFor: 'protocol' stamp: ''!
methodsSelection

	^ methodsSelection! !

!MethodWidget methodsFor: 'protocol' stamp: ''!
removeAllFromMethodsIconsCache: aMethod

	self methodsIconsCache keys do: [:method | 
		" for overrides "
		method selector = aMethod selector
			ifTrue: [ MethodsIconsCache removeKey: method ifAbsent: [ ]]].! !

!MethodWidget methodsFor: 'testing' stamp: ''!
resetMethodCache

	methods := nil! !

!MethodWidget methodsFor: 'selection' stamp: ''!
resetMethodsListSelection

	methodsSelection removeAll! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/27/2012 23:02'!
resetSelection

	self methodsSelection removeAll! !

!MethodWidget methodsFor: 'private' stamp: ''!
selectMethod: aMethod

	methodsSelection at: aMethod put: true! !

!MethodWidget methodsFor: 'selection' stamp: ''!
selectedMethodIndex

	^ self getMethods identityIndexOf: self selectedMethod ifAbsent: [ 0 ].! !

!MethodWidget methodsFor: 'selection' stamp: ''!
selectedMethodIndex: anInteger

	| aMethod |
	aMethod :=  self getMethods at: anInteger ifAbsent: [ nil ].
	self selectedMethod: aMethod.

	self changed: #selectedMethodIndex.! !

!MethodWidget methodsFor: 'selection' stamp: ''!
selectedMethods

	| associations |
	associations := self methodsSelection associations select: [:assoc | assoc value == true ] thenCollect: [:assoc | assoc key ].
	^ associations reject: [:each | each isNil ]! !

!MethodWidget methodsFor: 'private' stamp: ''!
takeKeyboardFocus

	methodsList takeKeyboardFocus! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/14/2012 12:17'!
updateList

	self update: #getMethodItem:! !

!MethodWidget methodsFor: 'protocol' stamp: ''!
vScrollValue

	^ methodsList scrollValue y! !

!MethodWidget methodsFor: 'protocol' stamp: ''!
vScrollValue: aNumber

	^ methodsList vScrollValue: aNumber! !

AbstractWidget subclass: #AbstractPackageWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractPackageWidget commentStamp: '<historical>' prior: 0!
AbstractPackageWidget is an abstraction describing a widget used to manage packages!

AbstractPackageWidget subclass: #PackageWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!PackageWidget commentStamp: '<historical>' prior: 0!
PackageWidget is the basic implementation of a wiget managing packages!

!AbstractWidget class methodsFor: 'instance creation' stamp: ''!
model: model

	^ self new
		model: model;
		yourself! !

!AbstractWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 5/9/2012 11:34'!
dragTransferTypeForMorph: dragSource 

	^(dragSource isKindOf: PluggableListMorph)
		ifTrue: [ dragSource getListElementSelector ]! !

!AbstractWidget methodsFor: 'accessing' stamp: ''!
iconClass

	^ self model iconClass! !

!AbstractWidget methodsFor: 'accessing' stamp: ''!
iconClass: anObject
	
	iconClass := anObject! !

!AbstractWidget methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!AbstractWidget methodsFor: 'accessing' stamp: ''!
model: anObject
	
	model := anObject.
	anObject addDependent: self.! !

!AbstractWidget methodsFor: 'update' stamp: ''!
update: aSymbol

	self changed: aSymbol! !

Model subclass: #MultipleMethodsEditorAllButtonModel
	instanceVariableNames: 'model state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!MultipleMethodsEditorAllButtonModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/6/2012 18:00'!
on: aModel

	^ self new
		model: aModel;
		yourself! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:24'!
action

	self model 
		updateScrollerWithMultipleElementsWithoutButtons;
		updateLayoutForMultiple.
	state := true.
	self changed: #state.
	self model updateButtonsStateFrom: self! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:22'!
initialize
	"Initialization code for MultipleMethodsEditorAllButtonModel"

	super initialize.

	state := true.! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 17:58'!
label

	^ 'All'! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/6/2012 18:00'!
model
	^ model! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/6/2012 18:00'!
model: anObject
	model := anObject! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:22'!
setState: aBoolean

	state := aBoolean! !

!MultipleMethodsEditorAllButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:18'!
state

	^ state! !

Model subclass: #MultipleMethodsEditorButtonModel
	instanceVariableNames: 'label model state target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!MultipleMethodsEditorButtonModel commentStamp: '<historical>' prior: 0!
A MultipleMethodsEditorButtonModel is a ButtonModel created for MultipleMethodsEditor!

!MultipleMethodsEditorButtonModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/6/2012 18:07'!
on: aScroller label: label target: target

	^ self new
		model: aScroller;
		label: label;
		target: target;
		yourself! !

!MultipleMethodsEditorButtonModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 8/6/2012 18:04'!
on: aScroller value: value label: label target: target

	^ self new
		model: aScroller;
		vScrollValue: value;
		label: label;
		target: target;
		yourself! !

!MultipleMethodsEditorButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:17'!
action

	self model ifNil: [ ^ self ].
	self target ifNil: [ ^ self ].
	
	self target vScrollValue: 0.
	self model setCurrent: self target.
	self model updateLayoutForSingleWithButtons.
	state := true.
	self changed: #state.
	self model updateButtonsStateFrom: self! !

!MultipleMethodsEditorButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:18'!
initialize
	"Initialization code for MultipleMethodsEditorButtonModel"

	super initialize.

	state := false! !

!MultipleMethodsEditorButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/5/2012 20:01'!
label

	^ label 
		ifNil: [ '' ]
		ifNotNil: [:l | l ]! !

!MultipleMethodsEditorButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/5/2012 19:59'!
label: anObject
	label := anObject! !

!MultipleMethodsEditorButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/6/2012 18:02'!
model

	^ model! !

!MultipleMethodsEditorButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/6/2012 18:02'!
model: anObject

	model := anObject! !

!MultipleMethodsEditorButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:26'!
setState: aBoolean 

	state := aBoolean! !

!MultipleMethodsEditorButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/6/2012 18:18'!
state

	^ state! !

!MultipleMethodsEditorButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/5/2012 21:42'!
target
	^ target! !

!MultipleMethodsEditorButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/5/2012 21:42'!
target: anObject
	target := anObject! !

!PluggableListMorph methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 5/9/2012 11:28'!
getListElementSelector

	^ getListElementSelector! !

!Announcement class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:06'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #announcement! !

CustomHelp subclass: #NautilusHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Help'!

!NautilusHelp class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/6/2013 14:42'!
bookName

	^ 'Nautilus'.! !

!NautilusHelp class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/6/2013 14:51'!
contextMenus

	^ HelpTopic
		title: 'Adding to context menus'
		contents: 'On the class-side of your object, create a method that:
	1. takes one argument (a PragmaMenuAndShortcutRegistration).
	2. Begins with the pragma for whichever menu you want to extend (see AbstractNautilusUI "menu pragmas" protocol)
	
	For example, to extend the menu for the method list pane:
		methodMenu: aBuilder
			<nautilusGlobalMethodMenu>
			
	To see existing examples in your image, browse senders of that pragma'! !

!NautilusHelp class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/6/2013 14:46'!
pages

	^ #(contextMenus).
! !

!Behavior methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 7/13/2012 14:12'!
realClass

	^ self! !

!IconicButton methodsFor: '*Nautilus' stamp: ''!
graphicalMorph

		^ graphicalMorph! !

!IconicButton methodsFor: '*Nautilus' stamp: ''!
graphicalMorph: aMorph
	self addMorph: aMorph.
	aMorph lock.! !

!IconicButton methodsFor: '*Nautilus' stamp: ''!
labelGraphic

		^ graphicalMorph image! !

AbstractTool subclass: #AbstractNautilusUI
	instanceVariableNames: 'model window hierarchyClass cachedHierarchy sourceTextArea firstColumn secondColumn groupsSelection packagesSelection classesSelection list list2 sourceCodePanel commentTextArea currentDisplayChoice sourceTextAreaLimit sourceCodeContainer list2Elements listElements shouldUpdateTitle testSemaphore sourceTextAreas multipleMethodsEditor contentSelection'
	classVariableNames: 'ClassesIconsCache GroupsIconsCache Icon NextFocusKey PackagesIconsCache PreviousFocusKey'
	poolDictionaries: ''
	category: 'Nautilus'!

!AbstractNautilusUI commentStamp: '<historical>' prior: 0!
An AbstractNautilusUI is an abstraction of the UI handling packages and classes.

Instance Variables
	cachedHierarchy:		<Object>
	classesSelection:		<Object>
	commentButton:		<Object>
	commentTextArea:		<Object>
	currentDisplayChoice:		<Object>
	firstColumn:		<Object>
	groupsSelection:		<Object>
	hierarchyClass:		<Object>
	list:		<Object>
	list2:		<Object>
	model:		<Object>
	packagesSelection:		<Object>
	secondColumn:		<Object>
	sourceCodeContainer:		<Object>
	sourceCodePanel:		<Object>
	sourceTextArea:		<Object>
	sourceTextAreaLimit:		<Object>
	window:		<Object>!

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'EstebanLorenzano 1/30/2013 14:22'!
buildAddGroupsShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #newGroupAndBrowseForPackage)
		category: #NautilusGlobalShortcuts
		default: $n command  ,$g command 
		do: [ :target | target addPackagesAsGroupsAndBrowse ]
		description: 'Create a new group and browse'.
			
	(aBuilder shortcut: #newGroupForPackage)
		category: #NautilusGlobalShortcuts
		default: $n command  , $g shift command 
		do: [ :target | target addPackagesAsGroups ]
		description: 'Create a new group'.

	(aBuilder shortcut: #addInGroupPackage)
		category: #NautilusGlobalShortcuts
		default: $n command , $e command, $p command 
		do: [ :target | target addPackagesInGroup ]
		description: 'Add the selected packages in a group'.
		
	(aBuilder shortcut: #addInGroupMethod)
		category: #NautilusGlobalShortcuts
		default: $n command , $e command, $m command 
		do: [ :target | target addMethodsInGroup ]
		description: 'Add the selected methods in a group'.
		
	(aBuilder shortcut: #addInGroupClass)
		category: #NautilusGlobalShortcuts
		default: $n command , $e command, $c command 
		do: [ :target | target addClassesInGroup ]
		description: 'Add the selected classes in a group'.	
		
	(aBuilder shortcut: #addMatchingAndBrowse)
		category: #NautilusGlobalShortcuts
		default: $n command , $m command 
		do: [ :target | target addMatchingPackagesInGroupsAndBrowse ]
		description: 'Add packages matching the selected package as groups and browse'.
		
	(aBuilder shortcut: #addInGroupMethod)
		category: #NautilusGlobalShortcuts
		default: $n command , $m command shift
		do: [ :target | target addMatchingPackagesInGroups ]
		description: 'Add packages matching the selected package as groups'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/28/2012 14:52'!
buildAddShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #newClass)
		category: #NautilusGlobalShortcuts
		default: $n command  ,$c command 
		do: [ :target | target addClass ]
		description: 'Create a new class'.
			
	(aBuilder shortcut: #newPackage)
		category: #NautilusGlobalShortcuts
		default: $n command  , $p command 
		do: [ :target | target addPackage ]
		description: 'Create a new package'.

	(aBuilder shortcut: #newProtocol)
		category: #NautilusGlobalShortcuts
		default: $n command , $t command 
		do: [ :target | target addCategory ]
		description: 'Create a new protocol'.
		
	(aBuilder shortcut: #newGroup)
		category: #NautilusGlobalShortcuts
		default: $n command , $g command 
		do: [ :target | target addNewGroup ]
		description: 'Create a new group'.
		
"	(aBuilder shortcut: #newMethod)
		category: #NautilusGlobalShortcuts
		default: $n command , $m command 
		do: [ :target | target addMethod ]
		description: 'Create a new method'."! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 16:33'!
buildAnalyzeSubMenu: aBuilder
	<contextMenu>
	<nautilusGlobalClassMenu>
	| target |
	
	target := aBuilder model.
	target selectedClass ifNil: [^target].

	(aBuilder item: #'Inst var references...')
		action: [target browseInstVarRefs];
		parent: #Analyze;
		order: 0.

	(aBuilder item: #'Inst var assignments...')
		action: [target browseInstVarDefs];
		parent: #Analyze;
		order: 100.

	(aBuilder item: #'Create inst var accessors')
		action: [target createInstVarAccessors];
		parent: #Analyze;
		enabledBlock: [ target selectedClass instVarNames isEmpty not ];
		order: 200;
		withSeparatorAfter.
	
	(aBuilder item: #'Create initializer with inst vars...')
		action: [ target createInitializerWithInstVars ];
		parent: #Analyze;
		order: 300;
		enabledBlock: [ target showInstance ].
	
	(aBuilder item: #'Generate initialize method')
		keyText: 'h, i' if: Nautilus useOldStyleKeys not;
		keyText: 'I' if: Nautilus useOldStyleKeys;
		action: [ target generateInitialize ];
		parent: #Analyze;
		order: 350.
		
	(aBuilder item: #'Force the generaton of the initialize method')
		keyText: 'h, k' if: Nautilus useOldStyleKeys not;
		keyText: 'K' if: Nautilus useOldStyleKeys;		
		action: [ target forceGenerateInitialize ];
		parent: #Analyze;
		order: 375;
		enabledBlock: [ target showInstance ];
		withSeparatorAfter.

	(aBuilder item: #'Class var refs...')
		action: [target browseClassVarRefs];
		parent: #Analyze;
		order: 400.
		
	(aBuilder item: #'Class refs...')
		keyText: 'b, N' if: Nautilus useOldStyleKeys not;
		keyText: 'N' if: Nautilus useOldStyleKeys;
		action: [target browseClassRefs];
		parent: #Analyze;
		order: 500.
		
	(aBuilder item: #'Browse comment versions...')
		action: [ target browseCommentVersionsOf: target selectedClass theNonMetaClass ];
		parent: #Analyze;
		order: 600;
		withSeparatorAfter.

	(target selectedClass inheritsFrom: SharedPool )
		ifTrue: [ 
			(aBuilder item: #'Shared Pool Users')
				action: [ target systemNavigation browseSharedPoolUsersOf: target selectedClass ];
				parent: #Analyze;
				enabledBlock: [ target enableSingleClassSelection ];
				order: 700].
				
	(aBuilder item: #'Unsent methods...')
		action: [target browseUnusedMethods.];
		parent: #Analyze;
		order: 800.
	
	(aBuilder item: #'Unreferenced inst vars...')
		action: [target showUnreferencedInstVars.];
		parent: #Analyze;
		order: 900.
		
	(aBuilder item: #'Unreferenced class vars...')
		action: [target showUnreferencedClassVars.];
		parent: #Analyze;
		order: 1000.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'EstebanLorenzano 1/30/2013 14:23'!
buildBrowseShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #browseSenders)
		category: #NautilusGlobalShortcuts
		default: $b command , $n command 
		do: [:target | target browseSendersOfMessages ]
		description: 'Browse senders of the selected method'.
		
	(aBuilder shortcut: #browseClassRefs)
		category: #NautilusGlobalShortcuts
		default: $b command, $n command shift
		do: [ :target | target browseClassRefs ]
		description: 'Browse class references'.

	(aBuilder shortcut: #browseImplementors)
		category: #NautilusGlobalShortcuts
		default: $b command , $m command 
		do: [:target | target browseMessages ]
		description: 'Browse implementors of the selected method'.
		
	"(aBuilder shortcut: #browseRestricted)
		category: #NautilusGlobalShortcuts
		default: $b command , $s command
		do: [:target | target restrictedBrowse ]
		description: 'Open a restricted browser'."
	
	(aBuilder shortcut: #browseRestrictedClass)
		category: #NautilusGlobalShortcuts
		default: $b command , $r command , $c command
		do: [:target | target restrictedBrowseClass ]
		description: 'Open a restricted browser on the selected class'.
	
	(aBuilder shortcut: #browseSuperclass)
		category: #NautilusGlobalShortcuts
		default: $b command , $s command shift
		do: [:target | target browseSuperclass ]
		description: 'Open a browser on the superclass of the selected class'.
		
	(aBuilder shortcut: #browseRestrictedPackage)
		category: #NautilusGlobalShortcuts
		default: $b command , $r command , $p command
		do: [:target | target restrictedBrowsePackage ]
		description: 'Open a restricted browser on the selected package'.
		
	(aBuilder shortcut: #browseRestrictedRegex)
		category: #NautilusGlobalShortcuts
		default: $b command , $r command , $r command
		do: [:target | target restrictedBrowsePackageRegex ]
		description: 'Open a restricted browser on a package regex'.
		
	(aBuilder shortcut: #browseRestrictedSuperclasses)
		category: #NautilusGlobalShortcuts
		default: $b command , $r command , $S shift command
		do: [:target | target restrictedBrowseSuperclasses ]
		description: 'Open a restricted browser the superclasses'.
		
	(aBuilder shortcut: #browseRestrictedSubclasses)
		category: #NautilusGlobalShortcuts
		default: $b command , $r command , $s command
		do: [:target | target restrictedBrowseSubclasses ]
		description: 'Open a restricted browser the subclasses'.
	
	(aBuilder shortcut: #browseInheritance)
		category: #NautilusGlobalShortcuts
		default: $b command , $i command 
		do: [:target | target methodHierarchy ]
		description: 'Open a restricted browser'.
		
	(aBuilder shortcut: #browseFull)
		category: #NautilusGlobalShortcuts
		default: $b command , $f command 
		do: [:target | target fullBrowse ]
		description: 'Open the same browser'.		
	
	(aBuilder shortcut: #browseVersion)
		category: #NautilusGlobalShortcuts
		default: $b command , $v command 
		do: [:target | target browseVersions ]
		description: 'Browse senders of the selected method'.
! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'CamilloBruni 9/14/2012 01:28'!
buildButtonsShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #showPackage)
		category: #NautilusGlobalShortcuts
		default: $t command  ,$p command
		do: [ :target | target showGroups: false ]
		description: 'Find a class'.
			
	(aBuilder shortcut: #showGroup)
		category: #NautilusGlobalShortcuts
		default: $t command  , $g command 
		do: [ :target | target showGroups: true ]
		description: 'Find a package'.
		
	(aBuilder shortcut: #showInstanceSide)
		category: #NautilusGlobalShortcuts
		default: $t command  ,$i command 
		do: [ :target | target showInstance: true ]
		description: 'Show instance side'.

	(aBuilder shortcut: #showClassSide)
		category: #NautilusGlobalShortcuts
		default: $t command  ,$c command 
		do: [ :target | target showInstance: false ]
		description: 'Show class side'.

	(aBuilder shortcut: #showHierarchy)
		category: #NautilusGlobalShortcuts
		default: $t command  ,$h command 
		do: [ :target | target showPackages: false ]
		description: 'Show Hierarchy'.
		
	(aBuilder shortcut: #showFlat)
		category: #NautilusGlobalShortcuts
		default: $t command  ,$f command 
		do: [ :target | target showPackages: true ]
		description: 'Show normal view'.
! !

!AbstractNautilusUI class methodsFor: 'shortcut-old' stamp: 'BenjaminVanRyseghem 4/6/2012 16:43'!
buildClassShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusClassShortcuts
		default: $b command
		do: [ :target | target fullBrowse ]
		description: 'Open a new browser on the selection'.
		
	(aBuilder shortcut: #restrictedBrowseClass)
		category: #NautilusClassShortcuts
		default: $b command shift
		do: [ :target | target restrictedBrowseClass ]
		description: 'Open a restricted browser'.

	(aBuilder shortcut: #copyClasses)
		category: #NautilusClassShortcuts
		default: $c command
		do: [ :target | target copyClasses ]
		description: 'Copy the selected classes'.
	
	(aBuilder shortcut: #addClassesInGroup)
		category: #NautilusClassShortcuts
		default: $e command
		do: [ :target | target addClassesInGroup ]
		description: 'Add the selected classes in a group'.
	
	(aBuilder shortcut: #findMethod)
		category: #NautilusClassShortcuts
		default: $f command
		do: [ :target | target findMethod ]
		description: 'Find a method'.
		
	(aBuilder shortcut: #findClass)
		category: #NautilusClassShortcuts
		default: $f command shift
		do: [ :target | target findClass ]
		description: 'Find a class'.
		
	(aBuilder shortcut: #generateInitialize)
		category: #NautilusClassShortcuts
		default: $i command shift
		do: [ :target | target generateInitialize ]
		description: 'Generate the initialize method'.
		
	(aBuilder shortcut: #createTestForSelectedClass)
		category: #NautilusClassShortcuts
		default: $j command
		do: [ :target | target enableSingleClassSelection ifTrue: [ target createTestForSelectedClass ]]
		description: 'Generate a test class for the selected class'.
		
	(aBuilder shortcut: #forceGenerateInitialize)
		category: #NautilusClassShortcuts
		default: $k command shift
		do: [ :target | target forceGenerateInitialize ]
		description: 'Regenerate the initialize method'.
		
	(aBuilder shortcut: #browseClassRefs)
		category: #NautilusClassShortcuts
		default: $n command shift
		do: [ :target | target browseClassRefs ]
		description: 'Browse class references'.
	
	(aBuilder shortcut: #addClass)
		category: #NautilusClassShortcuts
		default: $n command
		do: [ :target | target addClass ]
		description: 'Add a class'.
		
	(aBuilder shortcut: #renameClass)
		category: #NautilusClassShortcuts
		default: $r command
		do: [ :target | target enableSingleClassSelection ifTrue: [ target renameClass ]]
		description: 'Rename the selected class'.
		
	(aBuilder shortcut: #runClassTests)
		category: #NautilusClassShortcuts
		default: $t command
		do: [ :target | target runClassTests ]
		description: 'Run the tests for the selected class'.
		
	(aBuilder shortcut: #removeClasses)
		category: #NautilusClassShortcuts
		default: $x command
		do: [ :target | target removeClasses ]
		description: 'Remove the selected classes'.
		
	(aBuilder shortcut: #removeClassesFromGroup)
		category: #NautilusClassShortcuts
		default: $x command shift
		do: [ :target |
			(target showGroups and: [ target selectedGroup isReadOnly not ])
				ifTrue: [ target removeClassFromGroup ]]
		description: 'Remove the selected classes from the selected group'! !

!AbstractNautilusUI class methodsFor: 'shortcut-old' stamp: 'EstebanLorenzano 2/6/2013 16:41'!
buildCommentShortcutsOn: aBuilder
	<keymap>	

	self buildEditorCommentKeymappingsOldOn: aBuilder.
	
	(aBuilder shortcut: #runTest)
		category: #NautilusCommentShortcuts
		default: $t command
		do: [:target |
				(target selectedMethod isTestMethod and: [ target commentTextArea hasUnacceptedEdits not ])
					ifTrue: [ target runTestForAMethod: target selectedMethod notifying: true
				]]
		description: 'Run the current test method'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/24/2012 19:06'!
buildCopyShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #copyClass)
		category: #NautilusGlobalShortcuts
		default: $c command , $c command 
		do: [ :target | target copyClasses ]
		description: 'Copy the selected classes'.! !

!AbstractNautilusUI class methodsFor: 'shortcut-old' stamp: 'EstebanLorenzano 2/6/2013 16:41'!
buildEditorCommentKeymappingsOldOn: aBuilder

	(aBuilder shortcut: #selectAll) 
		category: #NautilusCommentShortcuts
		default: $a command
		do: [ :target | target commentTextArea handleEdit: [ target commentTextArea selectAll ] ].
		
	(aBuilder shortcut: #copySelection) 
		category: #NautilusCommentShortcuts
		default: $c command
		do: [ :target | target commentTextArea copySelection ].
		
	(aBuilder shortcut: #find) 
		category: #NautilusCommentShortcuts
		default: $f command
		do: [ :target | target commentTextArea find ].
		
	(aBuilder shortcut: #findAgain) 
		category: #NautilusCommentShortcuts
		default:  $g command
		do: [ :target | target commentTextArea findAgain ].
		
	(aBuilder shortcut: #setSearchString)
		category: #NautilusCommentShortcuts
		default: $h command
		do: [ :target | target commentTextArea setSearchString ].
		
	(aBuilder shortcut: #cancel) 
		category: #NautilusCommentShortcuts
		default: $l command
		do: [ :target | target commentTextArea cancel ].
		
	(aBuilder shortcut: #paste) 
		category: #NautilusCommentShortcuts
		default: $v command
		do: [ :target | target commentTextArea paste ].
		
	(aBuilder shortcut: #cut) 
		category: #NautilusCommentShortcuts
		default: $x command
		do: [ :target | target commentTextArea cut ].
				
	(aBuilder shortcut: #undo) 
		category: #NautilusCommentShortcuts
		default: $z command
		do: [ :target | target commentTextArea undo ].
		
	(aBuilder shortcut: #redo) 
		category: #NautilusCommentShortcuts
		default: $z command shift
		do: [ :target | target commentTextArea redo ].
	
	(aBuilder shortcut: #cursorHome)
		category: #NautilusCommentShortcuts
		default: Character home command
		do: [ :target :morph :event | target commentTextArea cursorHome: event ].
	
	(aBuilder shortcut: #cursorEnd)
		category: #NautilusCommentShortcuts
		default: Character end command
		do: [ :target :morph :event | target commentTextArea cursorEnd: event ].

	(aBuilder shortcut: #browseIt) 
		category: #NautilusCommentShortcuts
		default: $b command
		do: [ :target | target commentTextArea browseIt ].
				
	(aBuilder shortcut: #doIt) 
		category: #NautilusCommentShortcuts
		default: $d command
		do: [ :target | target commentTextArea doIt ].

	(aBuilder shortcut: #inspectIt) 
		category: #NautilusCommentShortcuts
		default: $i command
		do: [ :target | target commentTextArea inspectIt ].
		
	(aBuilder shortcut: #implementorsOfIt) 
		category: #NautilusCommentShortcuts
		default: $m command
		do: [ :target | target commentTextArea implementorsOfIt ].
		
	(aBuilder shortcut: #sendersOfIt)
		category: #NautilusCommentShortcuts
		default: $n command
		do: [ :target | target commentTextArea sendersOfIt ].

	(aBuilder shortcut: #printIt) 
		category: #NautilusCommentShortcuts
		default: $p command
		do: [ :target | target commentTextArea printIt ].! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 8/1/2012 19:13'!
buildEditorCommentKeymappingsOn: aBuilder

	(aBuilder shortcut: #selectAll) 
		category: #NautilusCommentShortcuts
		default: $a command
		do: [ :target | target commentTextArea handleEdit: [ target commentTextArea selectAll ] ].
		
	(aBuilder shortcut: #copySelection) 
		category: #NautilusCommentShortcuts
		default: $c command
		do: [ :target | target commentTextArea copySelection ].
		
	(aBuilder shortcut: #find) 
		category: #NautilusCommentShortcuts
		default: $f command, $f command
		do: [ :target | target commentTextArea find ].
		
	(aBuilder shortcut: #findAgain) 
		category: #NautilusCommentShortcuts
		default:  $f command, $g command
		do: [ :target | target commentTextArea findAgain ].
		
	(aBuilder shortcut: #setSearchString)
		category: #NautilusCommentShortcuts
		default: $h command
		do: [ :target | target commentTextArea setSearchString ].
		
	(aBuilder shortcut: #cancel) 
		category: #NautilusCommentShortcuts
		default: $l command
		do: [ :target | target commentTextArea cancel ].
		
	(aBuilder shortcut: #paste) 
		category: #NautilusCommentShortcuts
		default: $v command
		do: [ :target | target commentTextArea paste ].
		
	(aBuilder shortcut: #cut) 
		category: #NautilusCommentShortcuts
		default: $x command
		do: [ :target | target commentTextArea cut ].
				
	(aBuilder shortcut: #undo) 
		category: #NautilusCommentShortcuts
		default: $z command
		do: [ :target | target commentTextArea undo ].
		
	(aBuilder shortcut: #redo) 
		category: #NautilusCommentShortcuts
		default: $z command shift
		do: [ :target | target commentTextArea redo ].
	
	(aBuilder shortcut: #cursorHome)
		category: #NautilusCommentShortcuts
		default: Character home command
		do: [ :target :morph :event | target commentTextArea cursorHome: event ].
	
	(aBuilder shortcut: #cursorEnd)
		category: #NautilusCommentShortcuts
		default: Character end command
		do: [ :target :morph :event | target commentTextArea cursorEnd: event ].

	(aBuilder shortcut: #browseIt) 
		category: #NautilusCommentShortcuts
		default: $b command
		do: [ :target | target commentTextArea browseIt ].
				
	(aBuilder shortcut: #doIt) 
		category: #NautilusCommentShortcuts
		default: $d command
		do: [ :target | target commentTextArea doIt ].

	(aBuilder shortcut: #inspectIt) 
		category: #NautilusCommentShortcuts
		default: $i command
		do: [ :target | target commentTextArea inspectIt ].
		
	(aBuilder shortcut: #implementorsOfIt) 
		category: #NautilusCommentShortcuts
		default: $m command
		do: [ :target | target commentTextArea implementorsOfIt ].
		
	(aBuilder shortcut: #sendersOfIt)
		category: #NautilusCommentShortcuts
		default: $n command
		do: [ :target | target commentTextArea sendersOfIt ].

	(aBuilder shortcut: #printIt) 
		category: #NautilusCommentShortcuts
		default: $p command
		do: [ :target | target commentTextArea printIt ].! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/24/2012 19:10'!
buildEditorKeymappingsOn: aBuilder

	(aBuilder shortcut: #selectAll) 
		category: #NautilusSourceCodeShortcuts
		default: $a command
		do: [ :target | target sourceTextArea handleEdit: [ target sourceTextArea selectAll ] ].
		
	(aBuilder shortcut: #copySelection) 
		category: #NautilusSourceCodeShortcuts
		default: $c command
		do: [ :target | target sourceTextArea copySelection ].
		
	(aBuilder shortcut: #find) 
		category: #NautilusSourceCodeShortcuts
		default: $f command, $f command
		do: [ :target | target sourceTextArea find ].
		
	(aBuilder shortcut: #findAgain) 
		category: #NautilusSourceCodeShortcuts
		default:  $f command, $g command
		do: [ :target | target sourceTextArea findAgain ].
		
	(aBuilder shortcut: #setSearchString)
		category: #NautilusSourceCodeShortcuts
		default: $h command
		do: [ :target | target sourceTextArea setSearchString ].
		
	(aBuilder shortcut: #cancel) 
		category: #NautilusSourceCodeShortcuts
		default: $l command
		do: [ :target | target sourceTextArea cancel ].
		
	(aBuilder shortcut: #paste) 
		category: #NautilusSourceCodeShortcuts
		default: $v command
		do: [ :target | target sourceTextArea paste ].
		
	(aBuilder shortcut: #cut) 
		category: #NautilusSourceCodeShortcuts
		default: $x command
		do: [ :target | target sourceTextArea cut ].
				
	(aBuilder shortcut: #undo) 
		category: #NautilusSourceCodeShortcuts
		default: $z command
		do: [ :target | target sourceTextArea undo ].
		
	(aBuilder shortcut: #redo) 
		category: #NautilusSourceCodeShortcuts
		default: $z command shift
		do: [ :target | target sourceTextArea redo ].
	
	(aBuilder shortcut: #cursorHome)
		category: #NautilusSourceCodeShortcuts
		default: Character home command
		do: [ :target :morph :event | target sourceTextArea cursorHome: event ].
	
	(aBuilder shortcut: #cursorEnd)
		category: #NautilusSourceCodeShortcuts
		default: Character end command
		do: [ :target :morph :event | target sourceTextArea cursorEnd: event ].

	(aBuilder shortcut: #browseIt) 
		category: #NautilusSourceCodeShortcuts
		default: $b command
		do: [ :target | target sourceTextArea browseIt ].
				
	(aBuilder shortcut: #doIt) 
		category: #NautilusSourceCodeShortcuts
		default: $d command
		do: [ :target | target sourceTextArea doIt ].

	(aBuilder shortcut: #inspectIt) 
		category: #NautilusSourceCodeShortcuts
		default: $i command
		do: [ :target | target sourceTextArea inspectIt ].
		
	(aBuilder shortcut: #implementorsOfIt) 
		category: #NautilusSourceCodeShortcuts
		default: $m command
		do: [ :target | target sourceTextArea implementorsOfIt ].
		
	(aBuilder shortcut: #sendersOfIt)
		category: #NautilusSourceCodeShortcuts
		default: $n command
		do: [ :target | target sourceTextArea sendersOfIt ].

	(aBuilder shortcut: #printIt) 
		category: #NautilusSourceCodeShortcuts
		default: $p command
		do: [ :target | target sourceTextArea printIt ].! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'CamilloBruni 1/11/2013 14:07'!
buildExtraShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #openBrowser)
		category: #NautilusGlobalShortcuts
		default: $o command, $o command
		do: [:target| target fullBrowse ]
		description: 'Open a new browser'.
		
	
	(aBuilder shortcut: #openBrowserOnSubclass)
		category: #NautilusGlobalShortcuts
		default: $o command, $s command
		do: [:target| target openSubclass ]
		description: 'Open a new browser on a subclass'.
		
		
	(aBuilder shortcut: #openBrowserOnSuperclass)
		category: #NautilusGlobalShortcuts
		default: $o command, $s command shift
		do: [:target| target openSuperclass ]
		description: 'Open a new browser on a superclass'.
		
	(aBuilder shortcut: #openBrowserOnClass)
		category: #NautilusGlobalShortcuts
		default: $o command, $c command
		do: [:target| target openClass ]
		description: 'Open a new browser on a class'.
	! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'CamilloBruni 9/14/2012 01:31'!
buildFindShortcutsOn: aBuilder
<keymap>

	(aBuilder shortcut: #findClass)
		category: #NautilusGlobalShortcuts
		default: $f command , $c command 
		do: [ :target | target findClass ]
		description: 'Find a class'.
	
	(aBuilder shortcut: #findClassInHierarchy)
		category: #NautilusGlobalShortcuts
		default: $f command , $h command 
		do: [ :target | target findClassInHierarchy ]
		description: 'Find a class in the hierarchy'.
		
	(aBuilder shortcut: #findSuperclass)
		category: #NautilusGlobalShortcuts
		default: $f command , $S shift command 
		do: [ :target | target findSuperclass]
		description: 'Find a superclass'.
		
	(aBuilder shortcut: #findSubclass)
		category: #NautilusGlobalShortcuts
		default: $f command , $s command 
		do: [ :target | target findSubclass]
		description: 'Find a subclass'.
		
	(aBuilder shortcut: #findPackage)
		category: #NautilusGlobalShortcuts
		default: $f command  , $p command 
		do: [ :target | target findPackage ]
		description: 'Find a package'.
		
	(aBuilder shortcut: #findProtocol)
		category: #NautilusGlobalShortcuts
		default: $f command  , $t command 
		do: [ :target | target findProtocol ]
		description: 'Find a protocol'.
		
	(aBuilder shortcut: #findMethod)
		category: #NautilusGlobalShortcuts
		default: $f command , $m command 
		do: [ :target | target findMethod ]
		description: 'Find a method'.
	
	(aBuilder shortcut: #findRespondingMethod)
		category: #NautilusGlobalShortcuts
		default: $f command, $M shift command 
		do: [ :target | target findAllMethod ]
		description: 'Find methods instances of this class may respond to'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'CamilloBruni 10/4/2012 10:39'!
buildGotoNavigationShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #jumpToClass)
		category: #NautilusGlobalShortcuts
		default: $g command , $c command 
		do: [ :target | target giveFocusToClass ]
		description: 'Jump to the selected class'.
			
	(aBuilder shortcut: #jumpToPackage)
		category: #NautilusGlobalShortcuts
		default: $g command, $p command 
		do: [ :target | target giveFocusToPackage ]
		description: 'Jump to the selected package'.

	(aBuilder shortcut: #jumpToProtocol)
		category: #NautilusGlobalShortcuts
		default: $g command , $t command 
		do: [ :target | target giveFocusToProtocol ]
		description: 'Jump to the selected protocol'.
		
	(aBuilder shortcut: #jumpToMethod)
		category: #NautilusGlobalShortcuts
		default: $g command , $m command  
		do: [ :target | target giveFocusToMethod ]
		description: 'Jump to the selected method'.
		
	(aBuilder shortcut: #jumpToSourceCode)
		category: #NautilusGlobalShortcuts
		default: $g command , $s command  
		do: [ :target | target giveFocusToSourceCode ]
		description: 'Jump to the selected method'.
		
	(aBuilder shortcut: #jumpToTestClass)
		category: #NautilusGlobalShortcuts
		default: $g command , $j command , $c command
		do: [ :target | target createTestForSelectedClass ]
		description: 'Jump to test class'.! !

!AbstractNautilusUI class methodsFor: 'shortcut-old' stamp: 'CamilloBruni 10/7/2012 22:04'!
buildGroupShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusGroupShortcuts
		default: $b command
		do: [ :target | target fullBrowse ]
		description: 'Open a new browser on the current selection'.
		
	(aBuilder shortcut: #restrictedBrowseGroup)
		category: #NautilusGroupShortcuts
		default: $b command shift
		do: [ :target | target  restrictedBrowseGroups: target selectedGroups ]
		description: 'Open a browser on a restricted view'.
	
	(aBuilder shortcut: #findClass)
		category: #NautilusGroupShortcuts
		default: $f command
		do: [ :target | target findClass ]
		description: 'Find a class'.
		
	(aBuilder shortcut: #addNewGroup)
		category: #NautilusGroupShortcuts
		default: $n command
		do: [ :target | target addNewGroup ]
		description: 'Create a new group'.
	
	(aBuilder shortcut: #renameGroup)
		category: #NautilusGroupShortcuts
		default: $r command
		do: [ :target | target enableSingleMenuItems ifTrue:[ target renameGroup ]]
		description: 'Rename the selected group'.
	
	(aBuilder shortcut: #runTestsOfGroups)
		category: #NautilusGroupShortcuts
		default: $t command
		do: [ :target | target runTestsOfGroups: target selectedGroups notifying: true ]
		description: 'Run the tests of the selected groups'.
		
	(aBuilder shortcut: #removeGroups)
		category: #NautilusGroupShortcuts
		default: $x command
		do: [ :target | target removeGroups ]
		description: 'Remove the selected groups'.! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: ''!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!AbstractNautilusUI class methodsFor: 'shortcut-old' stamp: 'EstebanLorenzano 2/6/2013 17:58'!
buildPackageShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusPackageShortcuts
		default: $b command
		do: [ :target | target fullBrowse ]
		description: 'Open a new browser on the selection'.
		
	(aBuilder shortcut: #addPackagesInGroup)
		category: #NautilusPackageShortcuts
		default: $e command
		do: [ :target | target addPackagesInGroup ]
		description: 'Add the selected package in a group'.
		
	(aBuilder shortcut: #findClass)
		category: #NautilusPackageShortcuts
		default: $f command
		do: [ :target | target findClass ]
		description: 'Find a class'.
		
	(aBuilder shortcut: #findPackage)
		category: #NautilusPackageShortcuts
		default: $f command shift
		do: [ :target | target findPackage ]
		description: 'Find a package'.

	(aBuilder shortcut: #addPackagesAsGroupsAndBrowse)
		category: #NautilusPackageShortcuts
		default: $g command
		do: [ :target | target addPackagesAsGroupsAndBrowse ]
		description: 'Add the selected packages as groups and browse'.
	
	(aBuilder shortcut: #addPackagesAsGroups)
		category: #NautilusPackageShortcuts
		default: $g command shift
		do: [ :target | target addPackageAsGroupAndBrowse ]
		description: 'Add the selected packages as groups'.
	
	(aBuilder shortcut: #addMatchingPackagesInGroupsAndBrowse)
		category: #NautilusPackageShortcuts
		default: $m command shift
		do: [ :target | target addMatchingPackagesInGroupsAndBrowse ]
		description: 'Add packages matching the selected package as groups and browse'.
	
	(aBuilder shortcut: #addMatchingPackagesInGroups)
		category: #NautilusPackageShortcuts
		default: $m command
		do: [ :target | target addMatchingPackagesInGroups ]
		description: 'Add packages matching the selected package as groups'.
		
	(aBuilder shortcut: #addPackage)
		category: #NautilusPackageShortcuts
		default: $n command 
		do: [ :target | target addPackage ]
		description: 'Add a new package'.
	
	(aBuilder shortcut: #renamePackage)
		category: #NautilusPackageShortcuts
		default: $r command 
		do: [ :target | target enableSingleMenuItems ifTrue: [ target renamePackage ]]
		description: 'Rename the selected package'.	
	
	(aBuilder shortcut: #runPackagesTests)
		category: #NautilusPackageShortcuts
		default: $t command 
		do: [ :target | target runPackagesTestsNotifying: true ]
		description: 'Run the tests for the selected packages'.
	
	(aBuilder shortcut: #removePackages)
		category: #NautilusPackageShortcuts
		default: $x command 
		do: [ :target | target removePackages ]
		description: 'Remove the selected packages'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/24/2012 19:02'!
buildRecategorizeShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #recategorizeMethod)
		category: #NautilusGlobalShortcuts
		default: $m command , $m command 
		do: [ :target | target categorizeMethod ]
		description: 'Categorize the selected method'.
		
	(aBuilder shortcut: #recategorizeClass)
		category: #NautilusGlobalShortcuts
		default: $m command , $c command 
		do: [ :target | target moveInNewPackage ]
		description: 'Categorize the selected class'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/28/2012 15:16'!
buildRefactoringShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #generateInitialize)
		category: #NautilusGlobalShortcuts
		default: $h command, $i command 
		do: [ :target | target generateInitialize ]
		description: 'Generate the initialize method'.
		
	(aBuilder shortcut: #forceGenerateInitialize)
		category: #NautilusGlobalShortcuts
		default: $h command, $k command
		do: [ :target | target forceGenerateInitialize ]
		description: 'Regenerate the initialize method'.
		
	(aBuilder shortcut: #createTestForSelectedClass)
		category: #NautilusGlobalShortcuts
		default: $n command, $j command, $c command
		do: [ :target | target enableSingleClassSelection ifTrue: [ target createTestForSelectedClass ]]
		description: 'Generate a test class for the selected class'.
		
	(aBuilder shortcut: #generateTestAndJump)
		category: #NautilusGlobalShortcuts
		default: $h command, $j command
		do: [ :target | target generateTestMethodsAndFocus: true ]
		description: 'Generate test and jump'.
		
	(aBuilder shortcut: #generateTest)
		category: #NautilusGlobalShortcuts
		default: $h command, $j command shift
		do: [ :target | target generateTestMethodsAndFocus: false ]
		description: 'Generate test'.
		
	(aBuilder shortcut: #categorizeAllUncategorized)
		category: #NautilusGlobalShortcuts
		default: $h command, $c command shift
		do: [ :target | target categorizeAllUncategorizedMethods ]
		description: 'Categorize all uncategorized'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/28/2012 14:54'!
buildRemoveShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #removeClass)
		category: #NautilusGlobalShortcuts
		default: $x command  ,$c command 
		do: [ :target | target removeClasses ]
		description: 'Remove the selected classes'.
			
	(aBuilder shortcut: #removePackage)
		category: #NautilusGlobalShortcuts
		default: $x command  , $p command 
		do: [ :target | target removePackages ]
		description: 'Remove the selected packages'.

	(aBuilder shortcut: #removeProtocol)
		category: #NautilusGlobalShortcuts
		default: $x command , $t command 
		do: [ :target | target removeCategories ]
		description: 'Remove the selected protocols'.
		
	(aBuilder shortcut: #removeMethod)
		category: #NautilusGlobalShortcuts
		default: $x command , $m command 
		do: [ :target | target removeMethods ]
		description: 'Remove the selected methods'.
		
	(aBuilder shortcut: #removeGroups)
		category: #NautilusGlobalShortcuts
		default: $x command , $g command 
		do: [ :target | target removeGroups ]
		description: 'Remove the selected groups'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/28/2012 14:53'!
buildRenameShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #renameClass)
		category: #NautilusGlobalShortcuts
		default: $r command  ,$c command 
		do: [ :target | target renameClass ]
		description: 'Rename the selected class'.
			
	(aBuilder shortcut: #renamePackage)
		category: #NautilusGlobalShortcuts
		default: $r command  , $p command 
		do: [ :target | target renamePackage ]
		description: 'Rename the selected package'.

	(aBuilder shortcut: #renameProtocol)
		category: #NautilusGlobalShortcuts
		default: $r command , $t command 
		do: [ :target | target renameCategory ]
		description: 'Rename the selected protocol'.
		
	(aBuilder shortcut: #renameGroup)
		category: #NautilusGlobalShortcuts
		default: $r command , $g command 
		do: [ :target | target renameGroup ]
		description: 'Rename the selected group'.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/24/2012 18:05'!
buildRunTestKeymappingsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #runTestForClasses)
		category: #NautilusGlobalShortcuts
		default: $j command  ,$c command 
		do: [ :target | target runClassTests ]
		description: 'runTestFor the selected classes'.
			
	(aBuilder shortcut: #runTestForPackages)
		category: #NautilusGlobalShortcuts
		default: $j command  , $p command 
		do: [ :target | target runPackagesTestsNotifying: true ]
		description: 'runTestFor the selected packages'.
		
	(aBuilder shortcut: #runTestForGroups)
		category: #NautilusGlobalShortcuts
		default: $j command  , $g command 
		do: [ :target | target runTestsOfGroups: target selectedGroups notifying: true ]
		description: 'runTestFor the selected groups'.
		
	(aBuilder shortcut: #runTestForMethods)
		category: #NautilusGlobalShortcuts
		default: $j command , $m command 
		do: [ :target |  target runTestForMethods: target selectedMethods notifying: true ]
		description: 'runTestFor the selected methods'.! !

!AbstractNautilusUI class methodsFor: 'shortcut-old' stamp: 'EstebanLorenzano 2/6/2013 15:19'!
buildSourceCodeShortcutsOn: aBuilder
	<keymap>	

	self buildEditorKeymappingsOn: aBuilder.
	(aBuilder shortcut: #runTest)
		category: #NautilusSourceCodeShortcuts
		default: $j command, $m command
		do: [:target |
				(target selectedMethod isTestMethod and: [ target sourceTextArea hasUnacceptedEdits not ])
					ifTrue: [ target runTestForAMethod: target selectedMethod notifying: true
				]]
		description: 'Run the current test method'.
		
	"This is not working anyway"
	"(aBuilder shortcut: #findClass)
		category: #NautilusSourceCodeShortcuts
		default: $f command, $c command 
		do: [:target | target findClass ]
		description: 'Find class'."! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 15:01'!
classesFixMenu: aBuilder
	<contextMenu>
	<nautilusGlobalClassFixMenu>
	| target |
	target := aBuilder model.
	
	(aBuilder item: #'Find Method...')
		keyText: 'f, m' if: Nautilus useOldStyleKeys not;
		keyText: 'f' if: Nautilus useOldStyleKeys;
		action: [target findMethod];
		order: 100;
		help: 'Search for a method by selector'.
		
	(aBuilder item: #'Find Class...')
		keyText: 'f, c' if: Nautilus useOldStyleKeys not;
		keyText: 'F' if: Nautilus useOldStyleKeys;
		action: [ target findClass ];
		order: 200;
		help: 'Search for a method by selector'.
	
	(aBuilder item: #'Add Class...')
		keyText: 'n, c' if: Nautilus useOldStyleKeys not;
		keyText: 'n' if: Nautilus useOldStyleKeys;
		action: [ target addClass ];
		order: 400;
		help: 'Create a new class'.
	(aBuilder item: #'Add Trait...')
		action: [ target addTrait ];
		order: 500;
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full')
		keyText: 'b, f' if: Nautilus useOldStyleKeys not;
		keyText: 'b' if: Nautilus useOldStyleKeys;
		action: [target fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
classesIconsCache: anObject
	
		ClassesIconsCache := anObject! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 16:31'!
classesMenu: aBuilder
	<contextMenu>
	<nautilusGlobalClassMenu>
	| target |

	target := aBuilder model.
	target selectedClass ifNil: [^target].

	(aBuilder item: #'Rename...')
		keyText: 'r,c' if: Nautilus useOldStyleKeys not;
		keyText: 'r' if: Nautilus useOldStyleKeys;
		action: [ target renameClass ];
		enabledBlock: [ target selectedClasses size <= 1 ];
		order: -99;
		withSeparatorAfter.	
		
	(aBuilder item: #'Browse scoped')
		keyText: 'b, s' if: Nautilus useOldStyleKeys not;
		keyText: 'B' if: Nautilus useOldStyleKeys;
		action: [target restrictedBrowseClass];
		order: 1000;
		help: 'Open a browser on a restricted view'.
	
	(aBuilder item: #'Add in Group...')
		keyText: 'n, e, c' if: Nautilus useOldStyleKeys not;
		keyText: 'e' if: Nautilus useOldStyleKeys;
		action: [ target addClassesInGroup ];
		order: 1100;
		withSeparatorAfter.
	
	(target selectedClasses allSatisfy: [:each | each inheritsFrom: TestCase ])
		ifTrue:[	
			(aBuilder item:#'Run tests')
				keyText: 'j, c' if: Nautilus useOldStyleKeys not;
				keyText: 't' if: Nautilus useOldStyleKeys;
				action: [ target runClassTests ];
				order: 1200].
						
	(aBuilder item: #Analyze)
		enabledBlock: [ target selectedClasses size <= 1 ];
		order: 0;
		withSeparatorAfter.

	(aBuilder item: #'Jump to test class')
		keyText: 'g, j' if: Nautilus useOldStyleKeys not;
		keyText: 'j' if: Nautilus useOldStyleKeys;
		action: [ target createTestForSelectedClass ];
		enabledBlock: [ target selectedClasses size <= 1 ];
		order: 300;
		withSeparatorAfter.
		
		
	(aBuilder item: #'Move to package...')
		keyText: 'm, c' if: Nautilus useOldStyleKeys not;
		action: [ target moveInNewPackage ];
		order: 1400.	
			
	(aBuilder item: #'Copy...')
		keyText: 'c, c' if: Nautilus useOldStyleKeys not;
		keyText: 'c' if: Nautilus useOldStyleKeys;
		action: [ target copyClasses ];
		order: 1600.	
			
	(aBuilder item: #'Remove...')
		keyText: 'x, c' if: Nautilus useOldStyleKeys not;
		keyText: 'x' if: Nautilus useOldStyleKeys;
		action: [ target removeClasses ];
		icon: (target iconClass iconNamed: #removeIcon);
		order: 1700;
		withSeparatorAfter.
			
	(aBuilder item: #'File Out')
		action: [ target fileOutClass ];
		withSeparatorAfter;
		order: 1800.	

	target showGroups
		ifTrue: [
			target selectedGroup isReadOnly 
				ifFalse: [
					(aBuilder item: #'Remove from Group')
						keyText: 'X' if: Nautilus useOldStyleKeys not;
						action: [ target removeClassFromGroup ];
						order: 1900] ].! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 1/31/2013 18:46'!
debugMenu: aBuilder
	<contextMenu>
	<nautilusGlobalMethodMenu>
	<nautilusGlobalProtocolMenu>
	<nautilusGlobalClassMenu>
	<nautilusGlobalPackageMenu>
	<nautilusGlobalGroupMenu>
	
	| target |
	target := aBuilder model.
	(aBuilder item: #DebugMenu)
			order: 9999;
			label: 'DEBUG';
			help: 'Open a browser on a restricted view'.
			
	(aBuilder item: #'Reset icons caches')
			order: 0;
			action: [ 
				AbstractNautilusUI resetIconCaches.
				AbstractMethodWidget resetMethodsIconsCache ];
			parent: #DebugMenu;
			help: 'Open a browser on a restricted view'.
			
	(aBuilder item: #'Inspect me')
			order: 100;
			action: [ target inspect ];
			parent: #DebugMenu;
			help: 'Open a browser on a restricted view'.
			
	(aBuilder item: #'Inspect my model ')
			order: 200;
			action: [ target model inspect];
			parent: #DebugMenu;
			help: 'Open a browser on a restricted view'.! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 14:48'!
groupsFixMenu: aBuilder
	<contextMenu>
	<nautilusGlobalGroupFixMenu>
	| target |
	target := aBuilder model.
	(aBuilder item: #'Find Class...')
		keyText: 'f, c' if: Nautilus useOldStyleKeys not;
		keyText: 'f' if: Nautilus useOldStyleKeys;
		action: [target findClass];
		order: 0;
		help: 'Search for a class by name'.

	(aBuilder item: #'New group...')
		keyText: 'n, g' if: Nautilus useOldStyleKeys not;
		keyText: 'n' if: Nautilus useOldStyleKeys;
		action: [target addNewGroup];
		order: 100;
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full')
		keyText: 'b, f' if: Nautilus useOldStyleKeys not;
		keyText: 'b' if: Nautilus useOldStyleKeys;
		action: [target fullBrowse];
		order: 999.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
groupsIconsCache

		^ GroupsIconsCache! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
groupsIconsCache: anObject
	
		GroupsIconsCache := anObject! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 14:53'!
groupsMenu: aBuilder
	<contextMenu>
	<nautilusGlobalGroupMenu>
	| target |
	target := aBuilder model.
	target selectedGroup ifNil: [ ^ target ].
		
	(aBuilder item: #'Browse scoped')
		keyText: 'b, s' if: Nautilus useOldStyleKeys not;
		action: [ target restrictedBrowseGroups: target selectedGroups ];
		order: 1000;
		withSeparatorAfter.
		
	(aBuilder item: #'Run tests')
		keyText: 'j, g' if: Nautilus useOldStyleKeys not;
		keyText: 't' if: Nautilus useOldStyleKeys;
		action: [ target runTestsOfGroups: target selectedGroups notifying: true ];
		order: 1100.
				
	(aBuilder item: #'Merge groups')
		action: [target mergeGroups];
		enabledBlock: [ target selectedGroups size > 1];
		order: 1200.

	target selectedGroup isNil
		ifFalse: [
			target selectedGroup isReadOnly
				ifFalse: [
					(aBuilder item: #'Rename...')
						keyText: 'r, g' if: Nautilus useOldStyleKeys not;
						keyText: 'r' if: Nautilus useOldStyleKeys;
						action: [ target renameGroup ];
						enabledBlock: [ target selectedGroups size <= 1];
						order: 1300 ].
			target selectedGroup removable
				ifTrue: [
					(aBuilder item: #'Remove groups')
						keyText: 'x, g' if: Nautilus useOldStyleKeys not;
						keyText: 'x' if: Nautilus useOldStyleKeys;
						icon: (target iconClass iconNamed: #removeIcon);
						action: [target removeGroups];
						order: 1400 ] ]! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
icon

	^ Icon! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
icon: anObject
	
	Icon := anObject! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: ''!
iconClass

	^ NautilusIcons! !

!AbstractNautilusUI class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/25/2012 11:07'!
initialize
	" self initialize "

	ClassesIconsCache := WeakIdentityKeyDictionary new.
	GroupsIconsCache := WeakIdentityKeyDictionary new.
	PackagesIconsCache := WeakIdentityKeyDictionary new.
	
	Icon := self buildIcon.
	NextFocusKey := Character arrowRight.
	PreviousFocusKey := Character arrowLeft.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/24/2012 17:55'!
nextFocusKey

	^ NextFocusKey! !

!AbstractNautilusUI class methodsFor: 'instance creation' stamp: ''!
on: aNautilus

	^ self new model: aNautilus! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 14:39'!
packagesFixMenu: aBuilder
	<contextMenu>
	<nautilusGlobalPackageFixMenu>
	| target |
	target := aBuilder model.
	
	(aBuilder item: #'Find Class...')
		keyText: 'f, c' if: Nautilus useOldStyleKeys not;
		keyText: 'f' if: Nautilus useOldStyleKeys;
		action: [target findClass];
		order: 0;
		help: 'Search for a class by name'.
		
	(aBuilder item: #'Find Package...')
		keyText: 'f, p' if: Nautilus useOldStyleKeys not;
		keyText: 'F' if: Nautilus useOldStyleKeys;
		action: [ target findPackage ];
		order: 100;
		help: 'Search for a package by name';
		withSeparatorAfter.
		
	(aBuilder item: #'Add package...')
		keyText: 'n, p' if: Nautilus useOldStyleKeys not;
		keyText: 'n' if: Nautilus useOldStyleKeys;
		action: [target addPackage];
		order: 200;
		help: 'Add a package';
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full')
		keyText: 'b, f' if: Nautilus useOldStyleKeys not;
		keyText: 'b' if: Nautilus useOldStyleKeys;
		action: [target fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
packagesIconsCache

		^ PackagesIconsCache! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: ''!
packagesIconsCache: anObject
	
		PackagesIconsCache := anObject! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 16:20'!
packagesMenu: aBuilder
	<contextMenu>
	<nautilusGlobalPackageMenu>
	| package target |
	target := aBuilder model.

	(package := target selectedPackage) ifNil: [ ^ target ].
	
	(aBuilder item: #'Browse scoped')
		keyText: 'b, s' if: Nautilus useOldStyleKeys not;
		action: [ target restrictedBrowsePackage ];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
						
	(aBuilder item: #'Rename...')
		keyText: 'r, p' if: Nautilus useOldStyleKeys not;
		keyText: 'r' if: Nautilus useOldStyleKeys;
		action: [target renamePackage];
		order: 1100;
		help: 'Rename a package';
		enabledBlock: [ target selectedPackages size < 2 ].
		
	(aBuilder item: #'Remove...')
		keyText: 'x, p' if: Nautilus useOldStyleKeys not;
		keyText: 'x' if: Nautilus useOldStyleKeys;
		action: [target removePackages ];
		order: 1200;
		help: 'Remove a package';
		icon: (target iconClass iconNamed: #removeIcon).
		
	(aBuilder item: #'Run tests...')
		keyText: 'j, p' if: Nautilus useOldStyleKeys not;
		keyText: 't' if: Nautilus useOldStyleKeys;
		action: [target runPackagesTestsNotifying: true ];
		enabled: (package classes anySatisfy: [:e | e inheritsFrom: TestCase ]);
		order: 1250;
		help: 'Run tests';
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [target fileOutPackage];
		order: 1300;
		help: 'File out a package';
		withSeparatorAfter.
	
	target selectedPackages size > 1
		ifTrue: [
			(aBuilder item: #'Add as Groups & Browse')
				keyText: 'n, g' if: Nautilus useOldStyleKeys not;
				action: [ target addPackagesAsGroupsAndBrowse ];
				order: 1400;
				help: 'Create a group based on the current package and browse it'.

			(aBuilder item: #'Add as Groups')
				keyText: 'n, G' if: Nautilus useOldStyleKeys not;
				action: [ target addPackagesAsGroups ];
				order: 1600;
				help: 'Create a group based on the current package'.

			(aBuilder item: #'Add as Group')
				action: [target addPackageAsGroup];
				order: 1700;
				help: 'Create a group based on the current package'.	
					]
		ifFalse: [
			(aBuilder item: #'Add as Group & Browse')
				keyText: 'n, g' if: Nautilus useOldStyleKeys not;
				keyText: 'G' if: Nautilus useOldStyleKeys;
				action: [ target addPackageAsGroupAndBrowse ];
				order: 1500;
				help: 'Create a group based on the current package and browse it'.
				
			(aBuilder item: #'Add as Group')
				keyText: 'n, G' if: Nautilus useOldStyleKeys not;
				action: [target addPackageAsGroup];
				order: 1700;
				help: 'Create a group based on the current package' ].			
				
	(aBuilder item: #'Add Matching Packages as Groups and Browse')
		keyText: 'n, m' if: Nautilus useOldStyleKeys not;
		keyText: 'M' if: Nautilus useOldStyleKeys;
		action: [ target addMatchingPackagesInGroupsAndBrowse ];
		order: 1800.
	
	(aBuilder item: #'Add in Group...')
		keyText: 'n, e, p' if: Nautilus useOldStyleKeys not;
		action: [target addPackagesInGroup];
		order: 1900;
		help: 'Add current package in a group';
		withSeparatorAfter.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/25/2012 11:08'!
previousFocusKey

	^ PreviousFocusKey! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: 'EstebanLorenzano 2/4/2013 17:54'!
resetClassesIconsCache

	ClassesIconsCache removeAll.
! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: ''!
resetIcon

	Icon := nil! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: ''!
resetIconCaches

	ClassesIconsCache removeAll.
	GroupsIconsCache removeAll.
	PackagesIconsCache removeAll.! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/1/2013 10:59'!
shiftedSourceCodeMenu: aBuilder
	<contextMenu>
	<nautilusGlobalSourceCodeMenu>
	| donorMenu items |
	
	items := OrderedCollection new.
	donorMenu := SmalltalkEditor shiftedYellowButtonMenu.
	donorMenu submorphs doWithIndex: [:each :index |
		(each isKindOf: MenuLineMorph)
			ifTrue: [ items last withSeparatorAfter ]
			ifFalse: [
				items add: ((aBuilder item: each contents asSymbol)
								keyText: each keyText;
								selector: each selector;
								target: each target;
								parent: #'Extended search...';
								arguments: each arguments;
								order: (index*100)).
				each icon ifNotNil: [:ic | items last icon: ic ]]].
	(items last: 2) doWithIndex: [:e :i | e order: (9998 + i) ]! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'MarcusDenker 2/15/2013 14:03'!
sourceCodeMenu: aBuilder
	<contextMenu>
	<nautilusGlobalSourceCodeMenu>
	
	| donorMenu items |
	items := OrderedCollection new.
	donorMenu := SmalltalkEditor yellowButtonMenu.
	donorMenu submorphs doWithIndex: [:each :index |
		(each isKindOf: MenuLineMorph)
			ifTrue: [ items last withSeparatorAfter ]
			ifFalse: [
				items add: ((aBuilder item: each contents asSymbol)
								keyText: each keyText;
								selector: each selector;
								target: each target;
								arguments: each arguments;
								order: (index*100)).
				each icon ifNotNil: [:ic | items last icon: ic ]]].
	(items last: 2) doWithIndex: [:e :i | e order: (9998 + i) ].
	
	(aBuilder item: #'Lock this text area')
			selector: #lockTextArea;
			target: aBuilder model;
			order: 0.! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'EstebanLorenzano 2/6/2013 15:20'!
sourceCodeMenuExtra: aBuilder
	<contextMenu>
	<nautilusGlobalSourceCodeMenu>
	| target method |
	target := aBuilder model.
	target selectedClass ifNil: [ ^ self ].
	method := target selectedMethod.
	((target selectedClass inheritsFrom: TestCase) and: [ method notNil and: [ method selector beginsWith: 'test' ]])
		ifTrue: [
			(aBuilder item: #'Run Test')
					order: 1;
					keyText: 'j, m' if: Nautilus useOldStyleKeys not;
					action: #runTestForAMethod:notifying:;
					arguments: { target selectedMethod. true };
					enabledBlock: [ target sourceTextArea hasUnacceptedEdits not ];
					withSeparatorAfter ].! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: ''!
aGroupHasBeenAdded: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: ''!
aGroupHasBeenRegistered: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: ''!
aGroupHasBeenRemoved: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	(self groupsManager =  anAnnouncement holder)
		ifTrue: [ 
			self selectedGroup = anAnnouncement group
				ifTrue: [ self selectedGroup: nil ].
			self updateGroupView.
			self update ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: ''!
aGroupHasBeenRenamed: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: ''!
aGroupHasBeenUnregistered: anAnnouncement

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: ''!
aKeyHasBeenPressed: aKey

	self announcer announce: (NautilusKeyPressed key: aKey )! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: ''!
addAll: aWindow
	
	self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
addCategory
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2012 12:05'!
addClass

	self selectedPackage ifNotNil: [:package | self addClassIn: package ]! !

!AbstractNautilusUI methodsFor: 'group' stamp: ''!
addClassesInGroup

	self selectedClasses ifNotNil: [:classes | self addClassesInGroup: classes ].! !

!AbstractNautilusUI methodsFor: 'group' stamp: ''!
addClassesInGroup: aCollection

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementsToAdd: ((aCollection collect: #theNonMetaClass) asSet asArray sort: [:a :b | a name < b name]))
		open! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
addComment: aText notifying: aController

	self selectedClass
		ifNil: [
			self selectedPackage
				ifNotNil: [:package | 
					"commentTextArea update: #clearUserEdits.
					package comment: aText"]]
		ifNotNil: [:class |
			commentTextArea update: #clearUserEdits.
			class comment: aText ]! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 1/24/2013 18:19'!
addMatchingPackagesInGroups

	self selectedPackage
		ifNotNil: [:package || separatorIndex firstPartOfTheName packages |
			separatorIndex := package name indexOf: $- ifAbsent: [ package name size + 1].
			firstPartOfTheName := package name copyFrom: 1 to: (separatorIndex - 1) .
			packages := self model packages select: [:each | each name beginsWith: firstPartOfTheName ].
			[ ^ self addPackagesAsGroups: packages ]
			on: GroupsAlreadyExists
			do: [:ex | 
				self alertGroupExisting: ex groupName.
				^ nil ]].
	^ nil! !

!AbstractNautilusUI methodsFor: 'group' stamp: ''!
addMatchingPackagesInGroupsAndBrowse

	( self addMatchingPackagesInGroups )
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/6/2012 17:32'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	"super addModelItemsToWindowMenu: aMenu."
	SystemBrowser addRegistryMenuItemsTo: aMenu inAccountOf: self model.

	aMenu addLine;
		add: 'Nautilus Plugins Manager'
		target: NautilusPluginManager new
		action: #openInWorld.
		
	aMenu
		add: 'Shortcuts description'
		target: self
		action: #openShortcutDescription.! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 1/24/2013 21:03'!
addNewGroup

	[ self groupsManager createAnEmptyStaticGroup ]
	on: GroupAlreadyExists 
	do:[ :ex | self alertGroupExisting: ex ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
addPackage

	| package |
	package := self addPackageBasedOn: self selectedPackage.
	package ifNotNil: [
			self selectedPackage: package.
			self updatePackageViewAndMove ]! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 1/24/2013 18:06'!
addPackageAsGroup

	^ [ self addPackagesAsGroup: self selectedPackages ]
		on: GroupAlreadyExists 
		do: [:ex | 
			self alertGroupExisting: ex groupName.
			^ nil ]! !

!AbstractNautilusUI methodsFor: 'group' stamp: ''!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]
		ifNil: [
			| group |
			group := self model class groupsManager groups detect: [:each | each name = self selectedPackage name] ifNone: [ nil ].
			group ifNotNil: [ 
				self selectedGroup: group.
				self showGroups: true ]]! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 1/24/2013 18:17'!
addPackagesAsGroups

	[ self addPackagesAsGroups: self selectedPackages ]
	on: GroupAlreadyExists 
	do: [:ex | self alertGroupExisting: ex groupName ]! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 4/6/2012 16:45'!
addPackagesAsGroupsAndBrowse

	(self addPackagesAsGroups: self selectedPackages)
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 4/6/2012 16:45'!
addPackagesInGroup
	
	self addPackagesInGroup: self selectedPackages! !

!AbstractNautilusUI methodsFor: 'group' stamp: ''!
addPackagesInGroup: aCollection
	
	aCollection
		ifNotEmpty: [:packages || classes |
			classes := packages gather: [:package | package classes ].
			(DialogGroupAdder new
				groups:	self groupsManager;
				elementsToAdd: (self model classes intersection: classes))
				open]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
addSubclassesOf: aClass in: result withIndex: index

	| classes |
	classes := aClass subclasses "self selectedPackage
					ifNil: [ {} ]
					ifNotNil: [:p | aClass subclasses intersection: p classes ]".

	classes do: [:each |
		result at: each put: index.
		self addSubclassesOf: each theNonMetaClass in: result withIndex: index + 1 ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes intersection |

	classes := aClass subclasses" intersection: self shownClasses".
	
	classes := classes intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result at: each put: index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
addTrait

	self selectedPackage ifNotNil: [:package | self addTraitIn: package ]
	
	" No need of update, announcements will do the job "! !

!AbstractNautilusUI methodsFor: 'annotation pane' stamp: ''!
annotationSeparator
	"Answer the separator to be used between annotations"

	^ '  '! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: ''!
announce: anAnnouncement

	^ self model announce: anAnnouncement! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: ''!
announcer

	^ self model announcer! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: ''!
arrowDown: aMethod

	| methods methodsNames index |
	methods := aMethod methodClass allSubclasses gather: [:each | each methodDict values ].
	methods := methods select: [:each | each selector = aMethod selector ].
	methods size = 1
		 ifTrue: [ ^ self model class openOnMethod: methods first ].
	methodsNames := methods collect: [:each | each methodClass name, '>>#', each selector ].
	index := UIManager default chooseFrom: methodsNames.
	index = 0 ifTrue: [ ^ self ].
	^ self model class openOnMethod: (methods at: index)
	! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: ''!
arrowUp: aMethod

	| newMethod |
	newMethod := aMethod methodClass superclass lookupSelector: aMethod selector.
	self model class openOnMethod: newMethod! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
asYetUnclassifiedString

	^ ClassOrganizer default! !

!AbstractNautilusUI methodsFor: 'dispatch' stamp: 'CamilloBruni 10/7/2012 23:27'!
basicRenameClass: aClass

	self renameClass: aClass! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/11/2013 13:36'!
browseClass: aClass
	
	self showGroups: false.
	self selectedPackage: aClass package.
	self selectedClass: aClass.
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseClassRefs
	
	self browseClassRefsOf: self selectedClass.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseClassVarRefs

	self browseClassVarRefsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
browseClassVars

	| cls |
	self selectedClass ifNil: [ 
		self changed: #isAClassSelected.
		^ self ].
	cls := self selectedClass theNonMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [ self systemNavigation browseClassVarRefs: cls ].
		
	! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseInstVarDefs 

	self browseInstVarDefsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseInstVarRefs 

	self browseInstVarRefsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
browseInstVars

	| cls |
	cls := self selectedClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [ 
			self systemNavigation browseInstVarRefs: cls ].
	self changed: #isAClassSelected! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseMessages

	self browseMessagesFrom: self selectedMethod selector! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 6/26/2012 23:52'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self selectedMethod ifNotNil: [:met | 
		self browseSendersOfMessagesFrom: met selector ]! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/11/2013 13:35'!
browseSuperclass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [ :class |
			self browseSuperclassOf: class ]! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/11/2013 13:35'!
browseSuperclassOf: class
	^ self browseClass: class superclass! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseUnusedMethods
	
	self browseUnusedMethodsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."

	self browseVersionsFrom: self selectedMethod! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
browsedEnvironment

	^ self model browsedEnvironment! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: ''!
buildBottomPlugins
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: ''!
buildBrowseClassVarsButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: #browseClassVars;
					stateSelector: #isAClassSelected ;
					onImage: (self iconClass iconNamed: #classVarsSelectedIcon);
					offImage: (self iconClass iconNamed: #classVarsUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #classVarsPressedIcon);	
					extent: 24@24;
					helpText: 'Show class variables';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: ''!
buildBrowseInstVarsButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: #browseInstVars;
					stateSelector: #isAClassSelected ;
					onImage: (self iconClass iconNamed: #instVarsSelectedIcon);
					offImage: (self iconClass iconNamed: #instVarsUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #instVarsPressedIcon);	
					extent: 24@24;
					helpText: 'Show instance variables';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/6/2012 00:52'!
buildCodePane
		
	"The following method fills up sourceTextArea variable"
	self buildNewSourceTextArea.
	
	multipleMethodsEditor := MultipleMethodsEditor new.

	multipleMethodsEditor 
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addEditor: sourceTextArea.
			
	^ multipleMethodsEditor! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: ''!
buildCodePanelWithComment

	self model commentPosition == #right
		ifTrue: [ self buildCodePanelWithCommentOnRight ].
	self model commentPosition == #bottom
		ifTrue: [ self buildCodePanelWithCommentOnBottom ].
	self model commentPosition == #left
		ifTrue: [ self buildCodePanelWithCommentOnLeft ].
	self model commentPosition == #top
		ifTrue: [ self buildCodePanelWithCommentOnTop ].! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'StephaneDucasse 12/19/2012 15:47'!
buildCodePanelWithCommentOnBottom
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new beSplitsTopAndBottom.
	delta := 2.

	splitter addLeftOrTop: multipleMethodsEditor.
	splitter addRightOrBottom: commentTextArea.

	sourceCodePanel
		addMorph: multipleMethodsEditor
		fullFrame: ( (0@0 corner: 1@0.5) asLayoutFrame 
						bottomOffset: delta negated).
	sourceCodePanel
		addMorph: splitter
		fullFrame: ( (0@0.5 corner: 1@0.5) asLayoutFrame
						topLeftOffset: 0@(delta negated) ; bottomRightOffset: 0@delta).
	sourceCodePanel 
		addMorph: commentTextArea
		fullFrame: ( (0@0.5 corner: 1@1) asLayoutFrame
						topLeftOffset: (0@delta)).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'StephaneDucasse 12/19/2012 15:49'!
buildCodePanelWithCommentOnLeft
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new.
	delta := 2.

	splitter addLeftOrTop: commentTextArea.
	splitter addRightOrBottom: multipleMethodsEditor.

	sourceCodePanel
		addMorph: commentTextArea
		fullFrame: ( (0@0 corner: 0.5@1) asLayoutFrame 
						bottomRightOffset: (delta negated)@0).
	sourceCodePanel
		addMorph: splitter
		fullFrame:  ((0.5@0 corner: 0.5@1) asLayoutFrame 
						topLeftOffset: (delta negated)@0;  bottomRightOffset: delta@0).
	sourceCodePanel 
		addMorph: multipleMethodsEditor
		fullFrame: ( (0.5@0 corner: 1@1) asLayoutFrame 
						topLeftOffset: (delta@0)).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'StephaneDucasse 12/19/2012 15:53'!
buildCodePanelWithCommentOnRight
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new.
	delta := 2.

	splitter addLeftOrTop: multipleMethodsEditor.
	splitter addRightOrBottom: commentTextArea.

	sourceCodePanel
		addMorph: multipleMethodsEditor
		fullFrame: ( (0@0 corner: 0.5@1) asLayoutFrame
						  bottomRightOffset: (delta negated)@0).
	sourceCodePanel
		addMorph: splitter
		fullFrame: ( (0.5@0 corner: 0.5@1) asLayoutFrame
						topLeftOffset: (delta negated)@0 ; bottomRightOffset: delta@0).
	sourceCodePanel 
		addMorph: commentTextArea
		fullFrame: ( (0.5@0 corner: 1@1) asLayoutFrame
						topLeftOffset: delta@0 ; bottomRightOffset: 0@0).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'StephaneDucasse 12/19/2012 15:54'!
buildCodePanelWithCommentOnTop
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new beSplitsTopAndBottom.
	delta := 2.

	splitter addLeftOrTop: commentTextArea.
	splitter addRightOrBottom: multipleMethodsEditor.

	sourceCodePanel
		addMorph: commentTextArea
		fullFrame: ( (0@0 corner: 1@0.5) asLayoutFrame
						 bottomRightOffset: 0@(delta negated)).
	sourceCodePanel
		addMorph: splitter
		fullFrame: ( (0@0.5 corner: 1@0.5) asLayoutFrame
						topLeftOffset: 0@(delta negated) ; bottomRightOffset: 0@delta).
	sourceCodePanel 
		addMorph: multipleMethodsEditor
		fullFrame:  ((0@0.5 corner: 1@1) asLayoutFrame
						topLeftOffset: (0@delta )).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'StephaneDucasse 12/19/2012 15:56'!
buildCodePanelWithoutComment

	sourceCodePanel 
				addMorph: multipleMethodsEditor
				fullFrame: LayoutFrame identity! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'EstebanLorenzano 1/30/2013 14:40'!
buildCommentButton
	| button |
	
	button := (PluggableButtonMorph
		on: self 
		getState: #commentButtonState
		action: #commentButtonAction
		label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap.
		
	self setShortcuts: #NautilusCommentShortcuts to: button.
	button submorphs first
		on: #doubleClick
		send: #toggleShowFullComment
		to: self;
		on: #mouseDown
		send: #mouseDown:
		to: button;
		on: #mouseMove
		send: #mouseMove:
		to: button;
		on: #mouseEnter
		send: #mouseEnter:
		to: button;
		on: #mouseLeave
		send: #mouseLeave:
		to: button;
		on: #mouseUp
		send: #mouseUp:
		to: button.
		
	^ button! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 8/1/2012 19:13'!
buildCommentPane

	commentTextArea := PluggableTextMorph
							on: self
							text: #getComments
							accept: #addComment:notifying:
							readSelection: nil
							menu: #codePaneMenu:shifted:.
				
	commentTextArea color: Color white.
	commentTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	
	self setCommentShorcutsTo: commentTextArea.	
	commentTextArea spaceFillWeight: 1.

	^ commentTextArea! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'EstebanLorenzano 2/6/2013 17:34'!
buildFirstColumn: aWindow
		
	| buttons |
	buttons := PanelMorph new.

	self setShortcuts: #NautilusPackageShortcuts to: buttons.
		
	buttons 
		changeProportionalLayout;
		addMorph: self buildGroupsButton
		fullFrame: ( (	0@0 corner: 0.5@0 ) asLayoutFrame
						bottomRightOffset: (-2)@25 );
		addMorph: self buildToggleButton
		fullFrame: ((	0.5@0 corner: 1@0 ) asLayoutFrame
						topLeftOffset: 2@0 ; bottomRightOffset: 0@25 );
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: 25;
		yourself.
		
	^ firstColumn := PanelMorph new
		changeProportionalLayout;
		addMorph: self buildList
		fullFrame: ( LayoutFrame identity bottomOffset: -25);
		addMorph: buttons
		fullFrame: ( (0@1 corner: 1@1 ) asLayoutFrame topOffset: -25);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildGetterFor: aString

	^ aString withFirstCharacterDownshifted,'
	
	^ ', aString! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildGroupHierarchyFor: aGroup

	| coll1 |
	aGroup ifNil: [ ^ IdentityDictionary new ].
	self browsedEnvironment isSystem
		ifTrue: [ coll1 := aGroup classes ]
		ifFalse:[ coll1 := aGroup classes intersection: self model classes ].
	
	^ self buildHierarchyForClasses: coll1! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'EstebanLorenzano 1/30/2013 14:43'!
buildGroupsButton
	| button |
	button := (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap.
	self setShortcuts: #NautilusGroupShortcuts to: button.
	^ button! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildHierarchyFor: aClass

	^ self buildHierarchyForClasses: aClass withAllSuperclasses, aClass allSubclasses! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildHierarchyForClasses: aCollection

	| result classes |
	result := IdentityDictionary new.
	classes := (aCollection collect: #theNonMetaClass) asSet.
	classes do: [:class || level |
		level := OrderedCollection with: class.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level add: superClass beforeIndex: 1 ]].
		level addFirst: 'whatever you want here'.
		result at: class put: level ].
	^ result! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildHierarchyForClasses: aCollection fromPackage: aPackage

	| result classes |
	result := IdentityDictionary new.
	classes := aCollection asSet.
	classes do: [:class || level |
		level := OrderedCollection with: class.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level add: superClass beforeIndex: 1 ]].
		(aPackage definedClasses includes: class)
			ifTrue: [ level addFirst: ' ']
			ifFalse: [ level addFirst: ''].
		result at: class put: level ].
	^ result! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
buildInitializeCodeFor: aClass 
	
	^ String streamContents: [:str | str << 'initialize';cr.
		str tab << '"Initialization code for '<<aClass name<<'"';cr;cr.
		str tab << 'super initialize.';cr.
		aClass instVarNames sort do: [:name | str cr tab << name << ' := nil.' ]].
	! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildInitializerFor: aVariableList

	^ String streamContents: [ :stream|
		aVariableList 
			do: [ :varName|	stream << varName << ': ' << varName]
			separatedBy: [ stream << ' ' ].
		stream cr cr tab << '^ self new'; cr.
		aVariableList do: [ :varName|
			stream tab tab << varName << ': ' << varName << ';'; cr].
		stream tab tab << 'yourself']! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 12/20/2012 12:27'!
buildInstanceButton

	^ (CheckboxMorph
		on: self 
		selected: #instanceButtonState 
		changeSelected: #instanceButtonAction)
		getLabelSelector: #instanceButtonLabel;
		labelClickable: true;
		 hResizing: #spaceFill; 
		vResizing: #shrinkWrap;
		yourself
	"^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap"! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: ''!
buildLeftPlugins

	| left |
	left := self model plugins select: [:each | each position = #left ].! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'EstebanLorenzano 1/30/2013 14:44'!
buildList

	list := PluggableIconListMorph new
				basicWrapSelector: #listWrapper:;
				keystrokeSelector: #keyPressedOnList:shifted:;
				getIconSelector: #listIcon:;
				getListSizeSelector: #listSize;
				resetListSelector: #resetListSelection;
				autoDeselect: true;
				dropEnabled: true;
				doubleClickSelector: #doubleClick;
				dropItemSelector: #dropInList:inARow:;
				dragEnabled: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				
				model: self;
				getIndexSelector: #selected;
				setIndexSelector: #selected:;
				getSelectionListSelector: #listSelectionAt:;
				setSelectionListSelector: #listSelectionAt:put:;
				getMenuSelector: #menu:shifted:;
				beMultipleSelection;
				
				basicGetListElementSelector: #listElement:.
				
	self setShortcuts: #NautilusPackageShortcuts to: list.
	
	list
		hResizing: #spaceFill;
		vResizing: #spaceFill.	
	^ list! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'EstebanLorenzano 1/30/2013 14:45'!
buildList2

	list2 := PluggableIconListMorph new
				basicWrapSelector: #listWrapper2:;
				keystrokeSelector: #keyPressedOnList2:shifted:;
				getIconSelector: #listIcon2:;
				getListSizeSelector: #listSize2;
				
				resetListSelector: #resetListSelection2;
				autoDeselect: true;
				dropEnabled: true;
				dropItemSelector: #dropInList2:inARow:;
				doubleClickSelector: #doubleClick2;
				dragEnabled: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				
				model: self;
				getIndexSelector: #selected2;
				setIndexSelector: #selected2:;
				getSelectionListSelector: #listSelection2At:;
				setSelectionListSelector: #listSelection2At:put:;
				getMenuSelector: #menu2:shifted:;
				beMultipleSelection;
				
				getListElementSelector: #listElement2:.
						
	self setShortcuts: #NautilusClassShortcuts to: list2.					
						
	^ list2! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/8/2013 16:23'!
buildNewSourceTextArea

	sourceTextArea := self textMorphClass
				on: self
				text: #sourceCodeFrom:
				accept: #compileSource:notifying:
				readSelection: #contentsSelectionFrom:
				menu: #sourceCodeMenu:shifted:.
				
	sourceTextArea
		askBeforeDiscardingEdits: true;
		color: Color white;
		lockSelector: #lockTextArea:from:;
		canLockChangeSelector: #canChangeLockFor:;
		vResizing: #spaceFill;
		hResizing: #spaceFill; 
		font: StandardFonts codeFont;
		spaceFillWeight: 3;
		on: #keyStroke send: #keyStroke:fromSourceCodeMorph: to: self;
		warningLimit: self warningLimit.
		
	self setSourceCodeShorcutsTo: sourceTextArea.
		
	sourceTextAreaLimit := sourceTextArea warningLimit.
	
	sourceTextArea warningLimit: -1.

	sourceTextAreas addFirst: (sourceTextArea -> nil).
	
	^ sourceTextArea ! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildPackageHierarchyFor: aPackage
	| classes |
	classes := aPackage classes collect: #theNonMetaClass.
	self browsedEnvironment isSystem
		ifFalse: [ classes := classes intersection: self browsedEnvironment classes ].

	^ self buildHierarchyForClasses: classes fromPackage: aPackage! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: ''!
buildRightPlugins

	| right |
	right := self model plugins select: [:each | each position = #right ].! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'StephaneDucasse 12/19/2012 16:04'!
buildSecondColumn: aWindow

	| buttons |
	buttons := PanelMorph new.
	buttons 
		changeProportionalLayout;
		addMorph: self buildInstanceButton
		fullFrame: ( (0@0 corner: 0.5@0 ) asLayoutFrame bottomRightOffset: -2@25 );
		addMorph: self buildCommentButton
		fullFrame: ((	0.5@0 corner: 1@0 ) asLayoutFrame
						topLeftOffset: 2@0 ; 
						bottomRightOffset: 0@25 );
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: 25;
		yourself.
		
	^ secondColumn :=  PanelMorph new
						changeProportionalLayout;
						addMorph: self buildList2
						fullFrame: (LayoutFrame identity
										bottomOffset: -25);
						addMorph: buttons
						fullFrame: ( (0@1 corner: 1@1 ) asLayoutFrame topOffset: -25);
						hResizing: #spaceFill;
						vResizing: #spaceFill;
						yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: ''!
buildSeparator

	^ Morph new height: 2; width: 0; color: Color transparent.
"	^ ImageMorph new newForm: (self iconClass iconNamed: #separatorIcon) "! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
buildSetUpCodeFor: aClass 
	
	^ String streamContents: [:str | str << 'setUp';cr.
		str tab << '"Setting up code for '<<aClass name<<'"';cr;cr.
		aClass instVarNames sort do: [:name | str cr tab << name << ' := nil.' ]].
	! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildSetterFor: aString

	^ aString withFirstCharacterDownshifted, ': anObject
	
	', aString, ' := anObject'! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: ''!
buildSwitchToByteCodeButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: # switchToByteCodeButton;
					stateSelector: #showByteCode ;
					onImage: (self iconClass iconNamed: #byteCodeSelectedIcon);
					offImage: (self iconClass iconNamed: #byteCodeUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #byteCodePressedIcon);	
					extent: 24@24;
					helpText: 'Show byteCode';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: ''!
buildSwitchToDecompileButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: # switchToDecompileButton;
					stateSelector: #showDecompile ;
					onImage: (self iconClass iconNamed: #decompileSelectedIcon);
					offImage: (self iconClass iconNamed: #decompileUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #decompilePressedIcon);	
					extent: 24@24;
					helpText: 'Show decompiled method';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: ''!
buildSwitchToSourceCodeButton
	
	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: # switchToSourceCodeButton;
					stateSelector: #showSource ;
					onImage: (self iconClass iconNamed: #sourceSelectedIcon);
					offImage: (self iconClass iconNamed: #sourceUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #sourcePressedIcon);	
					extent: 24@24;
					state: #on;
					helpText: 'Show source code';
					yourself.! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
buildTabbedNameOf: anElement
			
	| tab result size |
	
	tab := '   '.
	size := cachedHierarchy 
						at: anElement 
						ifPresent: [:p | p size - 2 ]
						ifAbsent: [ 0 ].
	
	result := String new: (size * (tab size)) streamContents: [ :s|
		1 to: size do: [:i | s nextPutAll: tab ]].

	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			( anElement package = package)
				ifTrue: [ (result, anElement name) asStringMorph ]
				ifFalse: [ (result , anElement name",' (', anElement package name,')'")asStringMorph color: self extensionColor;yourself]]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
buildTearDownCodeFor: aClass 
	
	^ String streamContents: [:str | str << 'tearDown';cr.
		str tab << '"Tearing down code for '<<aClass name<<'"';cr;cr.
		aClass instVarNames sort do: [:name | str cr tab << name << ' := nil.' ]].
	! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: ''!
buildTestClassDefinitionFrom: aClass

	^ 'TestCase subclass: ', (self buildTestClassNameFrom: aClass) printString, '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''',(self buildTestPackageNameFrom:aClass),''''! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: ''!
buildTestClassNameFrom: aClass
	
	^ (aClass name asString,'Test') asSymbol! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: ''!
buildTestPackageNameFrom:aClass

	^ aClass package name asString, '-Tests' ! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: ''!
buildTextAreaButtonsColumn: aWindow

	| column |
	column := PanelMorph new.
	column 
		changeTableLayout;
		listDirection: #topToBottom.
		
		{	self buildSwitchToSourceCodeButton.
			self buildSwitchToByteCodeButton.
			self buildSwitchToDecompileButton.
			self buildSeparator.
			self buildBrowseInstVarsButton.
			self buildBrowseClassVarsButton} reverse do: [:each | column addMorph: each ].
	
	column 
		vResizing: #spaceFill;
		width: 24;
		hResizing: #rigid.
	
	^ column! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/23/2012 18:45'!
buildToggleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toggleButtonState
			action: #toggleButtonAction
			label: #toggleButtonLabel)
			getEnabledSelector: #toggleButtonEnabled;
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			enabled: (self model selectedClass notNil);
			yourself! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: ''!
buildTopPlugins
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
byteCodeSymbol

	^ #ByteCode! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/6/2012 01:23'!
canChangeLockFor: source

	^ source locked or: [ self selectedMethod isNil not ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 1/30/2013 22:07'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."
	self selectedClass ifNotNil: [ :aClass | | methods |
		self flag: 'TODO: why the heck do all  the methods.* methods return selectors??'.
		methods := aClass uncategorizedMethods collect: [ :selector| aClass >> selector ].
		MethodClassifier classifyAll: methods ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
categorizeMethod
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: ''!
categoryMenuBuilder

	^ PragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self categoryPragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
categoryPragma
	^'nautilusGlobalProtocolMenu'! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/13/2012 21:36'!
changed: aSymbol

	super changed: aSymbol.
	self announce: (NautilusChanged symbol: aSymbol)! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2012 18:57'!
changedLabels

	"firstColumn label: self labelText."
	"secondColumn label: self labelText2."! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'GuillermoPolito 8/3/2012 13:21'!
classAdded: anAnnouncement
	
	| class |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement classAdded.
	((self showGroups 
	and: [ self selectedGroup ifNil: [ ^ self ] ifNotNil: [:gp | gp elements includes: class ]]) 
	or: [ self selectedPackage = class package])
				ifTrue: [
					self updateClassView.
					self removeFromPackagesIconsCache: class package ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'GuillermoPolito 8/3/2012 13:21'!
classCommented: anAnnouncement
	" announcement handled when a class has been commented " 
	| aClass |

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].

	aClass := anAnnouncement classCommented.	
	(self getList2 includes: aClass)
		ifTrue: [ self removeFromClassesIconsCache: aClass ].
	
	((self selectedClass = aClass) and: [ self showComment ])
		ifTrue: [ self changed: #getComments ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 8/6/2012 19:55'!
classDefinitionModified: anAnnouncement 

	| class |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement newClassDefinition.
	((self showGroups 
	and: [  self selectedGroup notNil
	and: [ self selectedGroup elements includes: class ]]) 
	or: [ self getList2 includes: class ])
			ifTrue: [
			self updateClassView.
			self removeFromPackagesIconsCache: class package.
			sourceTextArea hasUnacceptedEdits 
				ifFalse: [ self changed: #sourceCodeFrom: ]].! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
classFixPragma
	^'nautilusGlobalClassFixMenu'! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/16/2013 00:29'!
classIconFor: aClass

	ClassesIconsCache 
		at: aClass 
		ifPresent: [:icon | 
			 icon class == IconicButtonStateHolder ifFalse: [ ^ icon ].
			^ icon asIconTargetting: self ].

	((aClass includesBehavior: (Smalltalk globals at: #TestCase ifAbsent: [ false ])) and: [ aClass isAbstract not ])
		ifTrue: [ | icon button |
			icon :=  self iconClass iconNamed: #testNotRun.

			aClass hasPassedTest ifTrue: [ icon :=  self iconClass iconNamed: #testGreen ].
			aClass hasFailedTest ifTrue: [ icon :=  self iconClass iconNamed: #testYellow ].
			aClass hasErrorTest ifTrue: [ icon :=  self iconClass iconNamed: #testRed ].
					
			button := IconicButton new 
						target: self;
						actionSelector: #runTestsOfClass:notifying:;
						arguments: { aClass. true };
						labelGraphic: icon ;
						color: Color transparent;
						extent: 12 @ 12;
						helpText: 'Run the tests';
						borderWidth: 0.
			 ClassesIconsCache at: aClass put: (IconicButtonStateHolder forNautilus: button).
			^ button ]
		ifFalse: [
			(aClass organization classComment isEmpty and: [ Nautilus emptyCommentWarning ])
				ifTrue: [| button |
					button := IconicButton new 
								target: self;
								actionSelector: #openCommentEditor:;
								arguments: { aClass };
								labelGraphic: (self iconClass iconNamed: #uncommentedClass) ;
								color: Color transparent;
								extent: 12 @ 12;
								helpText:'Edit the comment';
								borderWidth: 0.
					 ClassesIconsCache at: aClass put: (IconicButtonStateHolder forNautilus: button).
					^ button ]].

	^ ClassesIconsCache at: aClass put: (aClass nautilusIcon)! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/6/2013 16:02'!
classLabel

	^'Class' asText allBold asMorph lock! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: ''!
classMenuBuilder

	^ PragmaMenuBuilder withAllPragmaKeywords: {self classFixPragma. self classPragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
classPragma
	^'nautilusGlobalClassMenu'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'EstebanLorenzano 1/15/2013 16:32'!
classRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self selectedClass = anAnnouncement classRecategorized
		ifTrue: [ self updateBothView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/16/2013 15:18'!
classRemoved: anAnnouncement
	
	| class oldPackage |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement classRemoved.
	((self showGroups 
	and: [ self selectedGroup ifNil: [ ^self ] ifNotNil: [:gp | gp elements includes: class ]]) 
	or: [ self getList2 includes: class ])
			ifTrue: [
				self selectedClass = class
					ifTrue: [ self selectedClass: nil ].
				window isDisplayed ifFalse: [ ^ self ].
				oldPackage := RPackageOrganizer default packageNamed: (anAnnouncement categoryName).
				self removeFromPackagesIconsCache: oldPackage.
				self updateBothView ].
	! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'GuillermoPolito 8/3/2012 13:22'!
classRenamed: anAnnouncement
	
	| class |
	class := anAnnouncement classRenamed.
	window ifNil: [ ^ self].
	window isDisplayed ifFalse: [ ^ self ].
	((self showGroups 
	and: [ self selectedGroup elements includes: class ]) 
	or: [ self getList2 includes: class ])
			ifTrue: [ self updateClassView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'GuillermoPolito 8/3/2012 13:22'!
classReorganized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	anAnnouncement classReorganized = self selectedClass
		ifTrue: [ self update ].! !

!AbstractNautilusUI methodsFor: 'widget - class' stamp: ''!
classWidget

	^ list2! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: 'EstebanLorenzano 1/31/2013 19:24'!
classesMenu: aMenu shifted: aBoolean 

	^ aMenu addAllFrom: self classMenuBuilder menu.! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
clearUserEditFlag
	
	self changed: #clearUserEdits! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'CamilloBruni 9/21/2012 13:47'!
close

	window close! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'EstebanLorenzano 1/31/2013 19:24'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	| donorMenu |
	donorMenu := shifted
		ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
		ifFalse: [SmalltalkEditor yellowButtonMenu].
	^ aMenu addAllFrom: donorMenu! !

!AbstractNautilusUI methodsFor: 'browser compatibility' stamp: ''!
codeTextMorph

	^ sourceTextArea! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
commentButtonAction

	self toggleShowComment.! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
commentButtonLabel

	^ self commentLabel! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
commentButtonState

	^ self showComment! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
commentLabel

	^ 'Comments'! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/1/2012 19:10'!
commentTextArea

	^ commentTextArea! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
commonPragma
	^'nautilusGlobalCommonMenu'! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
compileAClassFrom: aString notifying: aController

	sourceTextArea update: #clearUserEdits.
	( self compileANewClassFrom: aString notifying: aController startingFrom: self selectedClass )
		ifNil: [^ sourceTextArea hasUnacceptedEdits: true. ]
		ifNotNil: [:class | 
			self selectedPackage: class package.
			self selectedClass: class.
			self showHierarchy
						ifTrue: [ self hierarchyClass: class ].
			self showGroups
				ifTrue: [ self updateClassView ]
				ifFalse: [ self updateBothView ]]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
compileSource: aText notifying: aController
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/8/2013 16:22'!
contentSelectionFor: aTextMorph

	aTextMorph ifLocked: [ ^ (1 to: 0) ].

	self selectedClass isNil
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [^ (1 to: self defaultMethodSource size) ]]].
	^ (1 to: 0)
! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
copyCategory: anObject toTheClass: aClass
	
	| originClass methods |
	originClass := self selectedClass.
	methods := originClass methodsInProtocol: anObject.
	methods do: [:meth | self copyMethod: meth toTheClass: aClass ].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/6/2012 16:33'!
copyClasses
	
	| association |
	self okToChange ifFalse: [^ self].
	association := self copyClasses: (self selectedClasses collect: [:e | e theNonMetaClass ]).
	association key
		ifTrue: [
			self selectedClass: association value.
			self updateClassView]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
copyMethod: aMethod toTheClass: aClass 
	| newMethod shouldBeInstall |
	
	aMethod realClass = aClass ifTrue: [ ^ self ].
	shouldBeInstall := aClass methodDict
						at: aMethod selector
						ifPresent: [:sel | 
							" here I have to fork to release the drag & drop "
							[ (self openDialogWouldYouInstall: sel into: aClass)
								ifTrue: [ 
									newMethod := aClass compile: aMethod sourceCode classified: aMethod category ]] fork.
							  ]
						ifAbsent: [ 
							newMethod := aClass compile: aMethod sourceCode classified: aMethod category]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
createInitializerWithInstVars
	"Create a default initializer on the class side for a chosen list of instance variables"

	self createInitializerWithInstVarsOf: (self showInstance ifTrue: [ self selectedClass theNonMetaClass ] ifFalse: [ self selectedClass theMetaClass ])! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
createInstVarAccessors

	self createInstVarAccessorsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: ''!
createTestForClass: aClass

	| definition testClass className |

	aClass ifNil: [ ^ nil ].
	(aClass inheritsFrom: TestCase) ifTrue: [ ^ nil ].
	aClass isMeta ifTrue: [ ^ nil ].

	className := self buildTestClassNameFrom: aClass.
	testClass := self class environment 
		at: className
		ifPresent: [:class | class ]
		ifAbsent: [ 
			definition := self buildTestClassDefinitionFrom: aClass.
			testClass := self 
				compileANewClassFrom: definition
				notifying: nil
				startingFrom: self selectedClass.
			self class environment at: className.
			testClass comment: (self generateCommentForTestClass: testClass from: aClass)].
	self showGroups: false.
	self selectedPackage: testClass package.
	self selectedClass: testClass.
	self updateBothView.
	^ testClass! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: ''!
createTestForSelectedClass

	self createTestForClass: self selectedClass! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
currentDisplayChoice

	^ currentDisplayChoice ifNil: [ currentDisplayChoice := self sourceCodeSymbol ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
currentDisplayChoice: aSymbol

	currentDisplayChoice := aSymbol.
	
	self changed: #showSource.
	self changed: #showByteCode.
	self changed: #showDecompile.
	self changed: #sourceCodeFrom:.
	self announce: (NautilusTextDisplayerChanged displayerSymbol: aSymbol)! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
decompileSymbol

	^ #Decompile! !

!AbstractNautilusUI methodsFor: 'annotation pane' stamp: ''!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
defaultMethodSource


	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
doItContext

	^ nil! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'CamilloBruni 10/4/2012 10:45'!
doItReceiver

	^ self selectedClass 
		ifNotNil: [:class | class theNonMetaClass ]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/23/2012 19:20'!
doubleClick

	self 
		ifGroups: [ self doubleClickOnGroup ]
		ifNot: [ self doubleClickOnPackage ]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/23/2012 19:21'!
doubleClick2

	self doubleClickOnClass! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: ''!
doubleClickOnClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [:class |
			self showGroups
				ifTrue: [ self model class openOnClass: class onGroup: self selectedGroup ]
				ifFalse: [ self model class openOnClass: class ]]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: ''!
doubleClickOnGroup

	self selectedGroup 
		ifNil: [ ^self ]
		ifNotNil:[:group | self model class openOnGroup: group ]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: ''!
doubleClickOnPackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package | self model class openOnPackage: package ]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 7/13/2012 14:32'!
dragPassengersFor: item inMorph: dragSource 
	| transferType object |
	
	object := item originalObject.

	(dragSource isKindOf: PluggableListMorph)
		ifFalse: [^ nil ].
	transferType := self dragTransferTypeForMorph: dragSource.
	transferType == #getCategoryItem:
		ifTrue: [ ^ self selectedCategories ifEmpty: [ { object } ] ].
	
	transferType == #listElement2:
			ifTrue: [ 
				self showGroups 
					ifTrue: [ self selectedGroup
								ifNil: [ ^ nil ]
								ifNotNil: [:g | g isFillable ifFalse: [ ^ nil ]]].
				
				^ self selectedClasses ifEmpty: [ { object } ]].

	transferType == #getMethodItem:
			ifFalse: [ ^ nil ].

	^ self selectedMethods
		ifEmpty: [
			 (self getMethods includes: object)
				ifTrue: [{ object }]
				ifFalse: [ nil ]]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 5/9/2012 11:28'!
dragTransferTypeForMorph: dragSource 

	^(dragSource isKindOf: PluggableListMorph)
		ifTrue: [ dragSource getListElementSelector ]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: ''!
dropInAClass: aCollection into: aClass

	aCollection do: [:anObject | 
		(anObject isBehavior)
			ifFalse: [
				(anObject isString or: [ anObject isSymbol ])
					ifTrue: ["category"
						ActiveHand shiftPressed
							ifTrue: [ self copyCategory: anObject toTheClass: aClass ]
							ifFalse: [ self moveCategory: anObject toTheClass: aClass ]]
					ifFalse: [
						"a method"
						ActiveHand shiftPressed
							ifTrue: [ self copyMethod: anObject toTheClass: aClass ]
							ifFalse: [ self moveMethod: anObject toTheClass: aClass autoRemove: false ]]]]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 7/13/2012 14:38'!
dropInAPackage: aCollection into: receiver 

	aCollection do:[:aClass |
		self showGroups
			ifTrue: [
				receiver addClasses: { aClass }.
				ActiveHand shiftPressed
					ifFalse: [ 
						self selectedGroup removeClass: aClass.
						self updateClassView ]]
			ifFalse: [
				aClass theNonMetaClass category: receiver name.
				ActiveHand shiftPressed
					ifTrue: [ 
						self selectedClass: nil.
						self updateClassView ]
					ifFalse:[
						self selectedPackage: receiver.
						self selectedClass: aClass.
						self updateBothView ]]]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 4/14/2012 13:31'!
dropInList2: aCollection inARow: aRow
	| receiver |

	receiver := self getList2 at: aRow.
	
	self showInstance not
		ifTrue: [ receiver := receiver theMetaClass ]
		ifFalse: [ receiver := receiver theNonMetaClass ].
	
	self dropInAClass: aCollection into: receiver! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 3/23/2012 19:55'!
dropInList: aCollection inARow: aRow
	| receiver |
	
	(aRow = 0) ifTrue: [ ^ self ].
	receiver := self getList at: aRow.
	( receiver isKindOf: Class )
		ifTrue: [ self selectedClass isMeta
					ifTrue: [ receiver := receiver theMetaClass ]
					ifFalse: [ receiver := receiver theNonMetaClass ]].
	
	self dropInAPackage: aCollection into: receiver! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
enableSingleClassSelection

	^ self selectedClasses size <= 1! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
enableSingleMenuItems

	^ self selectedItems size <= 1! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
extensionColor

	^ Color gray darker! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
fileOutClass
	"Print a description of the selected class onto a file whose name is the 
	category name followed by .st."

	self fileOutClasses: self selectedClasses! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
fileOutMethods
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
fileOutPackage

	self fileOutPackages: self selectedPackages! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 02:13'!
findClass
	"Search for a class from a pattern or from the recent list"
	self findClass: (SearchFacade classSearchInEnvironment: self browsedEnvironment).! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 01:35'!
findClass: aSearchInstance
	"select the class returned by the search block"
	| aClass recentList |
	self okToChange ifFalse: [^ self flashPackage ].
	aClass := aSearchInstance chooseFromOwner: self window.
	aClass ifNil: [^ self flashPackage].
	self showGroups: false.
	self selectedPackage: aClass package.
	self selectedClass: aClass.
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 01:49'!
findClassInHierarchy
	"Search for a subclass of the selected class from a pattern or from the recent list"
	
	self selectedClass ifNotNil: [ :class| 
		self findClass: (SearchFacade hierarchySearchFor: class theNonMetaClass)].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 6/27/2012 00:30'!
findPackage

	"Search for a package from a pattern or from the recent list"
	| foundPackage packagesList |
	self okToChange ifFalse: [^ self ].

	"packagesList := (self model recentClasses elements collect: [:each | each package name]) asSet asArray sort.

	foundPackage := self findPackageIn: packagesList.
	foundPackage ifNil: [ ^ self ].
	self selectedPackage = foundPackage ifTrue: [ ^ self ]."
	
	foundPackage := SearchFacade rPackageSearch chooseFromOwner: self window.
	
	self selectedPackage: foundPackage.
	self updatePackageViewAndMove.
! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 01:49'!
findSubclass
	"Search for a subclass of the selected class from a pattern or from the recent list"
	
	self selectedClass ifNotNil: [ :class| 
		self findClass: (SearchFacade subclassSearchFor: class theNonMetaClass)].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 01:48'!
findSuperclass
	"Search for a superclass of the selected class from a pattern or from the recent list"
	self selectedClass ifNotNil: [ :class| 
		self findClass: (SearchFacade superclassSearchFor: class theNonMetaClass)].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
flashPackage

	^ nil! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
forceGenerateInitialize

	self selectedClass ifNotNil: [:class || code index |
		(class isMeta not and: [class inheritsFrom: TestCase])
			ifTrue: [
				index := 34.
				code := self buildSetUpCodeFor: class.
				class compile: code classified: 'initialization'.
				code := self buildTearDownCodeFor: class.
				class compile: code classified: 'initialization'.
				self selectedMethod: (class>>#setUp) ]
			ifFalse: [
				index := 62.
				code := self buildInitializeCodeFor: class.
				class compile: code classified: 'initialization' .
				self selectedMethod: (class>>#initialize) ].
		self update.
		self giveFocusTo: sourceTextArea.
		sourceTextArea selectFrom: index+class name size to: index-1+class name size ].! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: ''!
forceSelectedMethod: aMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: ''!
forceSelection: anObject! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
fullBrowse
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: ''!
generateCommentForTestClass: testClass from: aClass

	^ String streamContents: [:stream || name |
			name := testClass name. 
			name first isVowel
				ifTrue: [ stream << 'An ']
				ifFalse:[ stream <<'A '].
			stream << name << ' is a test class for testing the behavior of '<< aClass name ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'MarcusDenker 9/17/2012 15:37'!
generateInitialize
	
	self selectedClass ifNotNil: [:class || code index category |
		category := 'initialize'.
		(class isMeta not and: [class inheritsFrom: TestCase])
			ifTrue: [
				index := 34.
				(class includesSelector:  #setUp) 
					ifFalse: [
						code := self buildSetUpCodeFor: class.
						class compile: code classified: category ].
				(class includesSelector: #tearDown) 
					ifFalse: [
						code := self buildTearDownCodeFor: class.
						class compile: code classified: category ].
				self selectedMethod: (class>>#setUp) 
				]
			ifFalse: [
				index := 62.
				(class includesSelector: #initialize) 
					ifFalse: [
						code := self buildInitializeCodeFor: class.
						class compile: code classified: category ].
				self selectedMethod: (class>>#initialize) ].
		self update.
		self giveFocusTo: sourceTextArea.
		sourceTextArea selectFrom: index+class name size to: index-1+class name size ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getClassHierarchy2

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getClassesList

	^ self model classes! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
getComments

	^ self selectedClass
		ifNil: [
			self selectedPackage
				ifNil: [ '' ]
				ifNotNil: [:package | '' "package comment" ]]
		ifNotNil: [:class | class comment ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'CamilloBruni 10/4/2012 10:46'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [ {} ]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getGroupsKeyList
	| env |
	env := self browsedEnvironment.
	^ env isSystem
		ifTrue: [ self groupsManager groups ]
		ifFalse: [ self groupsManager groups select: [:g | (g classes intersection: self model classes) isEmpty not ]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getGroupsValuesList

	^ self selectedGroup 
		ifNil: [{}]
		ifNotNil: [:group | group classes ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getList

	^ listElements ifNil: [ listElements := self loadList ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getList2

	^ list2Elements ifNil: [ list2Elements := self loadList2 ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getPackagesList
	^ self model packages sort: [:a :b | a name <= b name ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
giveFocusTo: aMorph

	self hasFocus ifTrue: [aMorph takeKeyboardFocus]! !

!AbstractNautilusUI methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/22/2012 17:57'!
giveFocusToPackage

	self giveFocusTo: list! !

!AbstractNautilusUI methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/22/2012 18:01'!
giveFocusToSourceCode

	self giveFocusTo: sourceTextArea ! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
groupFixPragma
	^'nautilusGlobalGroupFixMenu'! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'CamilloBruni 10/7/2012 22:04'!
groupIconFor: aGroup
	| icon |
	GroupsIconsCache 
		at: aGroup 
		ifPresent: [:ic | 
			 ic class == IconicButtonStateHolder ifFalse: [ ^ ic ].
			^ ic asIconTargetting: self ].
	
	icon := IconicButton new 
				target: self;
				actionSelector: #restrictedBrowseGroups:;
				arguments: {{aGroup}};
				labelGraphic: (self iconClass iconNamed: #groupIcon);
				color: Color transparent;
				extent: 15 @ 16;
				helpText: 'Browse restricted environment';
				borderWidth: 0. 
				
	GroupsIconsCache
		at: aGroup
		put: (IconicButtonStateHolder forNautilus: icon).
	^ icon! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: ''!
groupMenuBuilder

	^ PragmaMenuBuilder withAllPragmaKeywords: {self groupFixPragma. self groupPragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
groupPragma
	^'nautilusGlobalGroupMenu'! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
groupsButtonAction

	self toggleShowGroups! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
groupsButtonLabel

	^ 
		self showGroups
			ifTrue: [ self packageLabel ]
			ifFalse: [ self groupsLabel ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
groupsButtonState

	^ false! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
groupsLabel

	^ 'Groups'! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
groupsManager

	^ self model groupsManager! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: 'EstebanLorenzano 1/31/2013 19:24'!
groupsMenu: aMenu shifted: aBoolean 
	" Morphic's menus are filled up when pragma's one are returned from a method, so I have to substitute the morphic menu by the pragma one "
	
	^ aMenu addAllFrom: (self groupMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 4/18/2012 13:16'!
guessTypeForName: aString

	^ nil! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
hierarchyClass

	^ hierarchyClass! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
hierarchyClass: aClass

	hierarchyClass := aClass.
	self setCachedHierarchyClass: aClass! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/8/2013 16:35'!
highlight: autoSelectString
	| first |

	first := sourceTextArea getText findString: autoSelectString.
	contentSelection := first to: first+autoSelectString size-1.
	self changed: #sourceCodeFrom:! !

!AbstractNautilusUI methodsFor: 'icon' stamp: ''!
iconClass

	^ self class iconClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/8/2013 16:30'!
initialize

	super initialize.
	cachedHierarchy := IdentityDictionary new.
	groupsSelection := Dictionary new.
	packagesSelection := Dictionary new.
	classesSelection := Dictionary new.
	shouldUpdateTitle := true.
	testSemaphore := Semaphore new.
	sourceTextAreas := OrderedCollection new.
	contentSelection := nil.! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
instanceButtonAction

	self toggleShowInstance! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'EstebanLorenzano 1/25/2013 18:22'!
instanceButtonLabel
	| hasMethods label |
	
	hasMethods := false.
	self selectedClass ifNotNil: [:class | 
		hasMethods := class theMetaClass methodDict notEmpty ].

	label := 'Class side' asMorph.	
	hasMethods 
		ifTrue: [ label emphasis: 1 ]
		ifFalse: [ label emphasis: 2 ].
	
	^ label! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 12/20/2012 12:40'!
instanceButtonState

	^ "false" self showInstance not! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/25/2012 18:00'!
instanceLabel

	^'Instance' asMorph! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
isAClassSelected

	^ self selectedClass notNil! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: ''!
keyPressedOnElement: anEvent

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source text events' stamp: ''!
keyStroke: anEvent fromSourceCodeMorph: aMorph
	
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
listElement2: anIndex

	^ self getList2 at: anIndex! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
listElement: anIndex

	^ self getList at: anIndex! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/23/2012 19:17'!
listIcon2: anItem

	^ self classIconFor: anItem
"	^ self 
		ifPackages: [ self classIconFor: anItem ]
		ifClasses: [ self packageIconFor: anItem ]"! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/23/2012 19:16'!
listIcon: anItem
	" I return the icon corresponding to anItem in the leftmost list "


	^ self showGroups
		ifTrue: [ self groupIconFor: anItem ]
		ifFalse: [
			" if I do not show groups, I have to know if I show packages or classes "
			self packageIconFor: anItem"
			self 
				ifPackages: [ self packageIconFor: anItem ]
				ifClasses: [ self classIconFor: anItem ]"]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/23/2012 19:57'!
listSelection

	^ self showGroups
		ifTrue: [ groupsSelection ]
		ifFalse: [ packagesSelection ]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/23/2012 19:57'!
listSelection2

	^ classesSelection! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: ''!
listSelection2At: anIndex

	| elt |
	elt := self getList2 at: anIndex ifAbsent: [ ^false ].
	^ self listSelection2 at: elt ifAbsent: [ false ]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: ''!
listSelection2At: anIndex put: aBoolean

	| elt |
	aBoolean ifNil: [ ^ self ].
	elt := self getList2 at: anIndex ifAbsent: [ ^ self ].
	self listSelection2 at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 4/17/2012 16:44'!
listSelectionAt: anIndex

	| elt |
	elt := self getList at: anIndex ifAbsent: [ ^ false ].
	^ (self listSelection at: elt ifAbsent: [ false ]) == true! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: ''!
listSelectionAt: anIndex put: aBoolean

	| elt |
	elt := self getList at: anIndex ifAbsent: [ ^ self ].
	self listSelection at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
listSize

	^ self getList size.! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
listSize2

	^ self getList2 size.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2012 19:57'!
listWrapper2: anElement

	"anElement is a Class"
	^ self showHierarchy
			ifTrue: [ self buildTabbedNameOf: anElement ]
			ifFalse: [
				 self selectedPackage 
						ifNil: [anElement name]
						ifNotNil: [:package | 
							( anElement package = package)
								ifTrue: [ anElement name asStringMorph ]
								ifFalse: [ anElement name asStringMorph color: self extensionColor;yourself]]]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/23/2012 19:17'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ 
			anElement name
			"self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ self buildTabbedNameOf: anElement ]"]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2012 19:23'!
loadList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot:[ self getPackagesList ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2012 19:23'!
loadList2

	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			self showPackages
				ifTrue: [		
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifFalse: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b ]]]]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/6/2012 01:31'!
lockTextArea

	self selectedMethod isNil ifTrue: [ ^ self ].
	
	sourceTextArea lockFrom: self selectedMethod.
	self buildNewSourceTextArea.
	multipleMethodsEditor addEditor: sourceTextArea.
	self changed: #sourceCodeFrom:.! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/6/2012 00:49'!
lockTextArea: aBoolean from: source

	aBoolean
		ifTrue: [ self lockTextArea ]
		ifFalse: [ self unlockTextArea: source ].! !

!AbstractNautilusUI methodsFor: 'monticello announcements' stamp: ''!
mcPackageModified: anAnnouncement
	" handled when a package become dirty "
	
	| rpackages |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].

	rpackages := (NautilusMCBindings default rPackagesFor: anAnnouncement package).
	(self model packages includesAnyOf: rpackages )
		ifTrue: [ 
			rpackages do: [:rpackage | PackagesIconsCache removeKey: rpackage ifAbsent: []].
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'monticello announcements' stamp: 'MarcusDenker 7/6/2012 23:11'!
mcWorkingCopyCreated: anAnnouncement
	| package rpackage mcPackage |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	package := anAnnouncement package.
	package ifNil: [ ^ self ].
	rpackage := RPackageOrganizer default packageNamed: package name.
	(self model packages includes: rpackage)
		ifTrue: [ 
			PackagesIconsCache removeKey: rpackage  ifAbsent: [].
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'monticello announcements' stamp: 'EstebanLorenzano 5/21/2012 17:10'!
mcWorkingCopyDeleted: anAnnouncement
	| package rpackages |
	
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	package := anAnnouncement package.
	package ifNil: [ ^ self ].
	rpackages := NautilusMCBindings default rPackagesFor: package.
	rpackages ifNil: [ ^ self ].
	rpackages do: [:rpackage | 
		PackagesIconsCache removeKey: rpackage ifAbsent: []].
	self updatePackageView! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/23/2012 19:58'!
menu2: aMenu shifted: aBoolean 
	
	self classesMenu: aMenu shifted: aBoolean.
	^ aMenu! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/23/2012 19:58'!
menu: aMenu shifted: aBoolean 
	
	self showGroups
			ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
			ifFalse: [self packagesMenu: aMenu shifted: aBoolean].
	^ aMenu! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
mergeGroups

	| group |
	group := self mergeGroups: self selectedGroups.
	group
		ifNotNil: [ 
			self groupsManager addAGroup: group.
			self selectedGroup: group.
			self updateBothView]
! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
methodAdded: anAnnouncement

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self methodHierarchyFrom: self selectedMethod! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: ''!
methodMenuBuilder

	^ PragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self methodPragma} model: self! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
methodModified: anAnnouncement 
	
	^ self subclassResponsibility ! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
methodPragma
	^'nautilusGlobalMethodMenu'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
methodRecategorized: anAnnouncement
	
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
methodRemoved: anAnnouncement

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
methodsForCategories: aCollection

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
methodsForCategory: aCategory
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: ''!
methodsIconsCache

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/20/2012 15:04'!
model: anObject

	model := anObject.
	self registerToAnnouncements.
	model when: #historyChanged send: #historyChanged to: self.
	anObject selectedPackage ifNotNil: [:e | packagesSelection at: e put: true ].
	anObject selectedGroup ifNotNil: [:p | groupsSelection at: p put: true ].
	anObject selectedClass ifNotNil: [:p | classesSelection at: p put: true ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
moveCategory: anObject toTheClass: aClass
	
	| originClass methods |
	originClass := self selectedClass.
	methods := originClass methodsInProtocol: anObject.
	methods do: [:meth | self moveMethod: meth toTheClass: aClass autoRemove: true ].
	
	(originClass methodsInProtocol: anObject)
		ifEmpty: [ 
			originClass removeCategory: anObject.
			self selectedCategory: nil ].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
moveInNewPackage

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| item |
	self okToChange ifFalse: [^ self].

	item := self moveInNewPackage: (self selectedClasses collect: [:e | e theNonMetaClass ]).

	item ifNotNil: [ self selectedPackage: item ].
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
moveMethod: aMethod toTheClass: aClass autoRemove: autoRemove
	
	| newMethod shouldBeInstall |
	aMethod realClass = aClass ifTrue: [ ^ self ].
	shouldBeInstall := aClass methodDict
						at: aMethod selector
						ifPresent: [:sel | 
							" here I have to fork to release the drag & drop "
							[ (self openDialogWouldYouInstall: sel into: aClass)
								ifTrue: [ | originClass oldCategory |
									oldCategory := aMethod category.
									originClass := aMethod realClass.
									newMethod := aClass compile: aMethod sourceCode classified: oldCategory.
									self selectedMethod: nil.
									
									originClass removeSelector: aMethod selector.
									autoRemove
										ifTrue: [	( originClass methodsInProtocol:oldCategory )
												ifEmpty: [ originClass removeCategory: oldCategory ]]]] fork]
						ifAbsent: [ 
							 | originClass oldCategory |
							oldCategory := aMethod category.
							originClass := aMethod realClass.
							newMethod := aClass compile: aMethod sourceCode classified: oldCategory.
							self selectedMethod: nil.
							originClass removeSelector: aMethod selector.
							autoRemove
								ifTrue: [
									( originClass methodsInProtocol: oldCategory )
										ifEmpty: [ originClass removeCategory: oldCategory ]]]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
moveMethodToPackage
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: ''!
newGroupBoxMorph
	| morph |
 	morph := GroupboxMorph new.
	morph contentMorph
		layoutInset: (0@0 corner: 0@0);
		cellInset: 0.
	^ morph! !

!AbstractNautilusUI methodsFor: 'monticello announcements' stamp: ''!
newMCVersion: anAnnouncement

	| rpackage |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement version package correspondingRPackage.
	rpackage ifNil: [ ^ self ].
	( self model packages includes: rpackage )
		ifTrue: [ 
			self removeFromPackagesIconsCache: rpackage.
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
noMethodsString

	^ ClassOrganizer nullCategory! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 4/17/2012 17:24'!
okToChange

	sourceTextArea text asString trimBoth = sourceTextArea getText asString trimBoth ifTrue: [ ^ true ].
	sourceTextArea canDiscardEdits ifTrue: [^ true].
	sourceTextArea update: #wantToChange.  "Solicit cancel from view"
	^ sourceTextArea canDiscardEdits
! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
okToChangeBoth

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
okToChangeComment

	commentTextArea canDiscardEdits ifTrue: [^ true].
	commentTextArea update: #wantToChange.  "Solicit cancel from view"
	^ commentTextArea canDiscardEdits
! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	self changed:#sourceCodeFrom:.
	self setWindowTitle.! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/16/2013 00:24'!
openClass
	self openClass: self selectedClass! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/11/2013 14:12'!
openClass: aClass
	aClass ifNil: [ ^ self ].
	self open browseClass: aClass! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: ''!
openCommentEditor: aClass
	| newComment |

	newComment :=UITheme current 
						textEditorIn: window
						text: 'Enter a comment for the class ', aClass theNonMetaClass name,':'
						title: 'Comment Editor'
						entryText: aClass theNonMetaClass comment
						entryHeight: 300.
	newComment
		ifNotNil: [ aClass theNonMetaClass comment: newComment asString ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/17/2012 15:44'!
openDialogWouldYouInstall: aMethod into: aClass

	"open a dialog to ask user if he wants to override the existing method or not"
	^ UIManager default confirm: 'Are you sure you want to override the method ', aMethod selector, ' in ', aClass name label: 'Override' ! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/28/2012 15:18'!
openShortcutDescription

	KMDescription new
		categories: #(NautilusGlobalShortcuts "NautilusClassShortcuts NautilusSourceCodeShortcuts NautilusPackageShortcuts NautilusProtocolShortcuts NautilusMethodShortcuts") sort;
		openWithSpec! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/11/2013 14:13'!
openSubclass
	"Search for a superclass of the selected class from a pattern or from the recent list"

	self selectedClass ifNotNil: [ :class| | search |
		search := SearchFacade subclassSearchFor: class theNonMetaClass.
		self openClass: (search chooseFromOwner: self window) ].! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'CamilloBruni 1/11/2013 14:07'!
openSuperclass
	"Search for a superclass of the selected class from a pattern or from the recent list"

	self selectedClass ifNotNil: [ :class| 
		self openClass: class superclass ].! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
packageChanged: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].

	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 12/20/2012 15:06'!
packageCreated: anAnnouncement

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:23'!
packageFixPragma
	^ 'nautilusGlobalPackageFixMenu'! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/8/2013 16:43'!
packageIconFor: aPackage
	| mcpackage |
	
	PackagesIconsCache
		at: aPackage
		ifPresent: [:icon |
			 icon class == IconicButtonStateHolder ifFalse: [ ^ icon ].
			^ icon asIconTargetting: self ].

	aPackage classes isEmpty ifTrue: [^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #emptyPackageIcon) ].
	
	mcpackage := (NautilusMCBindings default mcPackageFor: aPackage).
	(mcpackage notNil and: [ mcpackage isDirty ])
		ifTrue: [ | icon |
			icon := IconicButton new 
						target: self;
						actionSelector: #saveDirtyPackages:;
						arguments: {{ aPackage }};
						labelGraphic: (aPackage definedClasses
											ifEmpty: [ (self iconClass iconNamed: #dirtyMonticelloPackageIcon) ]
											ifNotEmpty: [ (self iconClass iconNamed: #dirtyPackageIcon) ]);
						color: Color transparent;
						extent: 15 @ 16;
						helpText: 'Save the package';
						borderWidth: 0.
			 PackagesIconsCache at: aPackage put: (IconicButtonStateHolder forNautilus: icon).
			^ icon ].

	(mcpackage notNil and: [(mcpackage name = aPackage name ) and: [ aPackage definedClasses isEmpty]])
		ifTrue: [ ^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #monticelloPackage) ].

	^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #packageIcon)! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
packageLabel

	^'Packages'! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: ''!
packageMenuBuilder

	^ PragmaMenuBuilder withAllPragmaKeywords: {self packageFixPragma. self packagePragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:24'!
packagePragma
	^ 'nautilusGlobalPackageMenu'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
packageRenamed: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: ''!
packageUnregistred: anAnnouncement

	self showGroups not
		ifTrue: [ | package |
			package := anAnnouncement package.
			self selectedPackage = package
				ifTrue: [ self selectedPackage: nil ].
			packagesSelection at: package put: false.
			window isDisplayed ifFalse: [ ^ self ].
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: 'EstebanLorenzano 1/31/2013 19:24'!
packagesMenu: aMenu shifted: aBoolean 
	^ aMenu addAllFrom: (self packageMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
popUpTestsResult: aClass! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
putSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: sourceTextAreaLimit ]! !

!AbstractNautilusUI methodsFor: 'icon' stamp: ''!
rebuildIconicButtonFrom: icon

	^ IconicButton new 
		target: self;
		actionSelector: icon actionSelector;
		arguments: icon arguments;
		labelGraphic: icon labelGraphic;
		color: icon color;
		helpText: icon helpText;
		extent: icon extent;
		borderWidth: icon borderWidth! !

!AbstractNautilusUI methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 4/18/2012 13:16'!
receiverClass

	^ self selectedClass! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'EstebanLorenzano 11/2/2012 17:19'!
registerToAnnouncements
	self registerToSystemAnnouncements.
	(Smalltalk 
		at: #TestAnnouncer
		ifPresent: [ self registerToTestAnnouncements ]). 
	self registerToMCAnnouncements.		
	self registerToGroupAnnouncements. ! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'EstebanLorenzano 11/2/2012 17:19'!
registerToGroupAnnouncements
	GroupAnnouncer uniqueInstance weak
		on: AGroupHasBeenRegistered send: #aGroupHasBeenRegistered: to: self;
		on: AGroupHasBeenUnregistered send: #aGroupHasBeenUnregistered to: self;
		on: AGroupHasBeenAdded send: #aGroupHasBeenAdded: to: self;
		on: AGroupHasBeenRemoved send: #aGroupHasBeenRemoved: to: self;
		on: AGroupHasBeenRenamed send: #aGroupHasBeenRenamed: to: self! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'EstebanLorenzano 11/2/2012 17:19'!
registerToMCAnnouncements
	SystemAnnouncer uniqueInstance weak	
		on: MCVersionCreated send: #newMCVersion: to: self;
		on: MCPackageModified send: #mcPackageModified: to: self;
		on: MCWorkingCopyCreated send: #mcWorkingCopyCreated: to: self;
		on: MCWorkingCopyDeleted send: #mcWorkingCopyDeleted: to: self.
! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 12/20/2012 15:05'!
registerToSystemAnnouncements

	self browsedEnvironment packageOrganizer announcer weak
		on: RPackageCreated send: #packageCreated: to: self;
		on: RPackageUnregistered send: #packageUnregistred: to: self;
		on: RPackageRenamed send: #packageRenamed: to: self.
		
	SystemAnnouncer uniqueInstance weak
		on: ClassAdded send: #classAdded: to: self;
		on: ClassCommented send: #classCommented: to: self;
		on: ClassRecategorized send: #classRecategorized: to: self;
		on: ClassModifiedClassDefinition send: #classDefinitionModified: to: self;
		on: ClassRemoved send: #classRemoved: to: self;
		on: ClassRenamed send: #classRenamed: to: self;
		on: ClassReorganized send: #classReorganized: to: self;
		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRecategorized send: #methodRecategorized: to: self;
		on: MethodRemoved send: #methodRemoved: to: self;
		
		on: ProtocolAdded send: #classRecategorized: to: self;
		on: ProtocolRemoved send: #classRecategorized: to: self.
	! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'EstebanLorenzano 11/2/2012 17:20'!
registerToTestAnnouncements
	"Since Test classes can be absent (in production, for instance, I use non-global references)"
	(Smalltalk at: #TestAnnouncer) uniqueInstance weak
		on: (Smalltalk at: #TestCaseStarted) send: #testCaseStarted: to: self;
		on: (Smalltalk at: #TestSuiteEnded) send: #testRunned: to: self.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
removeClassFromGroup

	self selectedClasses do: [:class | 
		[ 	self groupsManager removeClass: class theNonMetaClass from: self selectedGroup.
			self updateClassView ] fork ].
	self 
		selectedClass: nil;
		updateClassView.! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: ''!
removeClassFromMethodsIconsCache: aClass

	self methodsIconsCache keys do: [:method | 
		" for overrides "
		method methodClass = aClass
			ifTrue: [ 
				self removeFromClassesIconsCache: aClass.
				self methodsIconsCache removeKey: method ifAbsent: [ ]]].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/23/2012 19:59'!
removeClasses
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| result scroll |
	self okToChange ifFalse: [^ false].
	scroll := list2 scrollValue y.
				
	result := self removeClasses: (self selectedClasses collect: #theNonMetaClass).

	result
		ifTrue: [	
			classesSelection removeAll.
			self selectedClass: nil ].
	list2 vScrollValue: scroll.
	^ result! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
removeEmptyCategories

	self okToChange ifFalse: [^ self].
	(self methodsForCategory: self selectedCategory) 
		ifEmpty: [ self selectedCategory: nil ].
		
	self removeEmptyCategoriesFrom: self selectedClass.
	
	self update.! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: ''!
removeFromClassesIconsCache: aClass
	" not used since the class's icons are always the same "
	
	ClassesIconsCache removeKey: aClass ifAbsent: [].
	self updateClassView.! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: ''!
removeFromGroupsIconsCache: aClass
	" not used since the groups's icons are always the same "


	GroupsIconsCache removeKey: aClass ifAbsent: [].! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: ''!
removeFromMethodsIconsCache: aMethod
	" if a test method has changed, we should reset the correspondng method "
	
	| corresponding |
	corresponding := aMethod correspondingMethods.
	corresponding do: [:each | self methodsIconsCache removeKey: each ifAbsent: []].
	self removeFromClassesIconsCache: aMethod methodClass.
	self methodsIconsCache removeKey: aMethod ifAbsent: [ ].! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: ''!
removeFromPackagesIconsCache: aPackage

	PackagesIconsCache removeKey: aPackage ifAbsent: [].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/6/2012 16:02'!
removeGroups

	self okToChange ifFalse: [ ^ self ].
	self selectedGroups
		ifNotEmpty:[:groups |
			groupsSelection removeAll.
			groups do: [:group | self groupsManager removeAGroupSilently: group ].
			self selectedGroup: nil].
		! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 6/22/2012 14:07'!
removePackages

	| names |
	self selectedPackages 
		ifNotEmpty: [:packages |
			names := packages collect: [:package | package name ].
			names := names joinUsing: String cr.
			(UIManager default confirm: ('Are you sure you want to delete the package(s) named ', String cr, names, ' and their classes ?'))
				ifTrue: [| scroll |
					packages do: [:package |
						package definedClasses do:[: classToRemove |
									classToRemove subclasses size > 0
									ifTrue: [ | message |
										message := 'Are you certain that you
want to REMOVE the class ', classToRemove name, '
from the system?'.
										(self confirm: 'class has subclasses: ' , message)
										ifFalse: [^ false]].
									classToRemove removeFromSystem ].
						self browsedEnvironment packageOrganizer unregisterPackage: package ].
					scroll := list scrollValue y .
					self selectedPackage: nil.
					self updatePackageView.
					list vScrollValue: scroll ]]! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'EstebanLorenzano 2/19/2013 14:43'!
removeShortcuts: groupSymbol from: aMorph
	Nautilus useOldStyleKeys ifFalse: [ ^self ].
	
	(aMorph kmDispatcher includesKeymapCategory: groupSymbol)
		ifTrue: [ 
			aMorph 
				detachKeymapCategory: groupSymbol
				targetting: self ]
! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
removeSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: -1 ]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/3/2012 18:16'!
removeTextArea: anArea

	self shouldBeImplemented! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
renameCategory
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'EstebanLorenzano 1/15/2013 17:07'!
renameClass

	self okToChange ifFalse: [ ^ self ].
	 self selectedClass ifNil: [ ^ self ].

	self basicRenameClass: self selectedClass theNonMetaClass.

	self changed: #sourceCodeFrom:.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
renameGroup

	| group newName |
	group := self selectedGroup.
	group ifNil: [ ^ self ].
	self groupsManager renameAGroup: group.
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'SeanDeNigris 2/5/2013 10:12'!
renamePackage

	self renamePackages: self selectedPackages.
	cachedHierarchy := self buildPackageHierarchyFor: self selectedPackage.
	self updatePackageView.
	! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'SeanDeNigris 2/5/2013 10:51'!
renamePackage: anRPackage

	| isCurrent |
	isCurrent := anRPackage = self selectedPackage.
	super renamePackage: anRPackage.	
	isCurrent ifTrue: [ self selectedPackage: anRPackage ].
	packagesSelection at: anRPackage put: true.! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/8/2013 16:22'!
resetContentsSelectionFrom: aTextMorph

	contentSelection at: aTextMorph put: (self contentSelectionFor: aTextMorph)! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
resetListSelection

	self listSelection removeAll.! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
resetListSelection2

	self listSelection2 removeAll.! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: ''!
resetSelections! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 6/28/2012 14:45'!
restrictedBrowse

	self showGroups ifTrue: [ ^ self restrictedBrowseGroup ].

	self selectedClass
		ifNil: [ self restrictedBrowsePackage ]
		ifNotNil: [ self restrictedBrowseClass ].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'MarcusDenker 1/17/2013 11:04'!
restrictedBrowseClass
	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [ :class |
			self restrictedBrowseClasses: {class} ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:02'!
restrictedBrowseClasses: classes

	| newEnvironment |
	newEnvironment := self browsedEnvironment forClasses: classes.
	self model class 
		openOnClass:self selectedClass 
		inEnvironment: newEnvironment ! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:04'!
restrictedBrowseGroup

	self restrictedBrowseGroups: self selectedGroups! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:03'!
restrictedBrowseGroups: aCollection

	aCollection
		ifNotEmpty: [:groups || elements newEnvironment |
			elements := groups gather: [:group | group elements].
			newEnvironment := self browsedEnvironment forClasses: (elements collect: #theNonMetaClass).
			self model class openOnGroup: groups first inEnvironment: newEnvironment ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:03'!
restrictedBrowseHierarchy

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [ :class |
			self restrictedBrowseClasses: (class withAllSuperclasses, class allSubclasses) ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:00'!
restrictedBrowsePackage

	self selectedPackages
		ifEmpty: [ ^ self ]
		ifNotEmpty: [:packages |
			^ self restrictedBrowsePackages: packages ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:30'!
restrictedBrowsePackageRegex
	| regex |
	
	regex := self selectedPackages
		ifEmpty: [ '' ]
		ifNotEmpty: [ :packages | 
			'^',(packages first name splitOn: $-) first , '-.*$'].
		
	regex := UIManager default request: 'Browse restricted on Packages matching:' regex: regex .
	regex ifNil: [ ^ self ].
	self restrictedBrowsePackages: (self browsedEnvironment packages select: [ :package| regex matches: package name ] )! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:00'!
restrictedBrowsePackages: packages
	| newEnvironment |
	newEnvironment := self browsedEnvironment forPackages: packages.
	 self model class 
		openOnPackage: self selectedPackage inEnvironment: newEnvironment! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:02'!
restrictedBrowseSubclasses

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [ :class |
			self restrictedBrowseClasses: class withAllSubclasses]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 10/7/2012 22:02'!
restrictedBrowseSuperclasses

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [ :class |
			self restrictedBrowseClasses: class withAllSuperclasses ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
rootsOf: aPackage

	| tmpList |
	 tmpList := aPackage definedClasses.
	self browsedEnvironment isSystem
		ifFalse: [ tmpList := self model classes intersection: tmpList ].
		
	^ tmpList select: [:each |
		(tmpList includes: (each superclass)) not]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
rootsOfGroup: aGroup

	| classes |
	self browsedEnvironment isSystem
		ifTrue: [ classes := aGroup elements ]
		ifFalse: [ classes := aGroup elements intersection: self model classes ].

	^ classes select: [:each |
		(classes includes: each superclass) not]! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: ''!
runClassTests

	self runClassTests: self selectedClasses notifying: true! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
runClassTests: aCollection notifying: aBoolean

	(aCollection allSatisfy: [:each | each inheritsFrom: TestCase ]) ifFalse: [ ^ self ].
	
	aCollection
		ifNotEmpty:[:classes | 
			classes do: [:class | self runTestsOfClass: class notifying: aBoolean ]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/20/2012 00:31'!
runPackagesTestsNotifying: aBoolean

	self selectedPackages
		ifNotNil: [:packages || classes label |
			packages size > 1
				ifTrue: [ label := 'Packages: ' ]
				ifFalse: [ label := 'Package: ' ].
			classes := packages gather: [:package | package definedClasses ].
			classes := classes select: [:class | class inheritsFrom: TestCase ].
			self runClassTests: classes notifying: false.
			aBoolean
				ifTrue: [ 
					| color |
					(classes anySatisfy:[:e  | e hasPassedTest ]) ifTrue: [ color :=  Color green ].
					(classes anySatisfy:[:e  | e hasFailedTest ]) ifTrue: [ color :=  Color yellow ].
					(classes anySatisfy:[:e  | e hasErrorTest ]) ifTrue: [ color :=  Color red ].
					self 
						notifyTitle: 'Test Finished'
						contents: label,((packages collect: #name) joinUsing: ', ')
						color: color ]].! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: ''!
runTestForAMethod: aMethod notifying: anObject

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/20/2012 00:03'!
runTestForMethods: aCollection notifying: aBoolean

	aCollection
		do: [ :each | 
			each isTestMethod
				ifTrue: [ self runTestForAMethod: each notifying: aBoolean ]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/16/2013 14:36'!
runTestsOfClass: aClass notifying: aBoolean
	| methods blockToEvaluate |

	methods := aClass methodDict values select: [ :method | method isTestMethod ] thenCollect: [:e | e selector ].

	blockToEvaluate := [ |result |
		result := (aClass addToSuite: TestSuite new fromMethods: methods) run.
		result updateResultsInHistory.
		ClassesIconsCache removeKey: aClass ifAbsent: [].
		testSemaphore signal. ].

	aBoolean 
		ifTrue: [ blockToEvaluate forkAt: Processor userBackgroundPriority ]
		ifFalse: [ blockToEvaluate value ].

	testSemaphore wait.
	
	aBoolean 
		ifTrue: [ 
			| color |
			aClass hasPassedTest ifTrue: [ color :=  Color green ].
			aClass hasFailedTest ifTrue: [ color :=  Color yellow ].
			aClass hasErrorTest ifTrue: [ color :=  Color red ].
			
			self 
				notifyTitle: 'Test Finished' 
				contents: 'Class: ', aClass name
				color: color ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
runTestsOfGroups: aCollection notifying: aBoolean
	
	| classes label |
	label := 'Group: '.
	aCollection size >1 ifTrue: [ label := 'Groups: '].
	classes := aCollection gather:[:each | each elements ].
	classes := classes select: [:class | class inheritsFrom: TestCase ].
	self runClassTests: classes notifying: false.
	aBoolean
		ifFalse: [ self
					notifyTitle: 'Test Finished'
					contents: label,((aCollection collect: #name) joinUsing: ', ') ]! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: ''!
saveDirtyPackages: aCollection 
	
	
	aCollection isEmptyOrNil ifTrue: [ ^ self ].
	aCollection do: [:package || workCopy browser wrap index |
		
		workCopy := MCWorkingCopy forPackage: (MCPackage named: package name).
		browser :=MCWorkingCopyBrowser new.
		browser
			show;
			workingCopy: workCopy.
		"wrap := MCDependentsWrapper with: workCopy model: browser.
		self halt.
		index := browser workingCopySelectionWrapper: wrap.
		browser workingCopyTreeMorph selectionIndex: index"]
	! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/23/2012 19:59'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self selectedPackage ].
				
	^self getList indexOf: item.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/23/2012 19:59'!
selected2
	| item |

	item := self selectedClass.
	self showInstance ifFalse: [ item ifNotNil: [item := item theNonMetaClass]].

	^self getList2 indexOf: item.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'CamilloBruni 10/4/2012 10:50'!
selected2: anInteger
	| selection |
	
	selection := self getList2 at: anInteger ifAbsent: [nil].
	
	self showInstance ifFalse: [selection ifNotNil: [selection := selection theMetaClass]].
	self selectedClassWithoutChangingSelection: selection.
	
	self changed: #selected2.
	self changed: #currentHistoryIndex.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'CamilloBruni 10/4/2012 10:50'!
selected: anInteger
	| selection |
	
	list2Elements := nil.
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroupWithoutChangingSelection: selection ]
		ifNot: [ self selectedPackageWithoutChangingSelection: selection ].
	
	self changed: #selected.
	self changed: #currentHistoryIndex.! !

!AbstractNautilusUI methodsFor: 'SmalltalkEditor compatibility' stamp: ''!
selectedBehavior

	^ self selectedClass! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: ''!
selectedCategory

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: ''!
selectedCategory: anObject

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/18/2012 09:43'!
selectedClass

	| class |
	class := self model selectedClass.
	(self model selectedCategory isNil and: [ self model selectedMethod isNil ])
		ifTrue: [ self setStylerClass: nil ]
		ifFalse: [ self setStylerClass: class ].
	^ class! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/18/2012 09:28'!
selectedClass: aClass 

	self okToChangeBoth
		ifTrue: [
			classesSelection removeAll.
			aClass ifNotNil: [ self giveFocusTo: list2 ].	
			self selectedClassWithoutChangingSelection: aClass. ]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
selectedClassComments

	^ self selectedClass
		ifNil: ['']
		ifNotNil: [:class| class comment]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
selectedClassDescription

	^ self selectedClass definition! !

!AbstractNautilusUI methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 4/18/2012 13:16'!
selectedClassOrMetaClass

	^ self selectedClass! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
selectedClassWithoutChangingSelection: aClass 
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
selectedClasses

	| associations |
	associations := classesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
selectedGroup
	
	^ self model selectedGroup! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
selectedGroup: anObject

	self okToChange
		ifTrue: [
			groupsSelection removeAll.
			anObject ifNotNil: [ self giveFocusTo: list ].
			groupsSelection at: anObject put: true.
			self selectedGroupWithoutChangingSelection: anObject ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
selectedGroupWithoutChangingSelection: anObject

	self okToChange
		ifTrue: [
			anObject ifNil: [ groupsSelection removeAll ].
			self model selectedGroup: anObject.
			groupsSelection at: anObject put: true.
			self selectedClass: nil.
			self updateClassView ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
selectedGroups

	| associations |
	associations := groupsSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
selectedItems

	| associations |
	associations := self listSelection associations select: [:assoc | assoc value ].
	^ associations collect: [:assoc | assoc key ].! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: ''!
selectedMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: ''!
selectedMethod: aMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
selectedMethodComments

	^ self selectedMethod comment! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
selectedMethodSource

	self selectedMethod
		ifNil: [ ^ '' ]
		ifNotNil: [:method |
			self showSource
				ifTrue: [	^ method sourceCode ].
			self showByteCode
				ifTrue: [	^ method symbolic asText].
			self showDecompile
				ifTrue: [	^  method decompileWithTemps decompileString asText makeSelectorBoldIn: method methodClass ].
			^ 'error']			! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
selectedPackage

	^ self model selectedPackage! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/23/2012 20:01'!
selectedPackage: aPackage
" Force package selection, not used by the lists "

	self okToChange
		ifTrue: [
			packagesSelection removeAll.
			packagesSelection at: aPackage put: true.
				
			aPackage ifNotNil: [ self giveFocusTo: list ].	
				
			self selectedPackageWithoutChangingSelection: aPackage]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
selectedPackageWithoutChangingSelection: aPackage

	self okToChange
		ifTrue: [| class |
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class package ~= aPackage]])
				ifTrue: [ self selectedClass: nil ].
			self model package: aPackage class: self selectedClass category: nil method: nil.
			packagesSelection at: aPackage put: true.
			self updateClassView.
			self update.
			self changed: #getComments.
			self changed: #sourceCodeFrom:]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
selectedPackageWithoutChangingSelectionInternally: aPackage

	self okToChange
		ifTrue: [| class |
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class package ~= aPackage]])
				ifTrue: [ self selectedClass: nil ].
			packagesSelection at: aPackage put: true.
			
			aPackage ifNotNil: [ self giveFocusTo: list ].
			
			self updateClassView.
			self update.
			self changed: #getComments.
			self changed: #sourceCodeFrom:]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
selectedPackages

	| associations |
	associations := packagesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
setCachedHierarchyClass: aClass

	cachedHierarchy := self buildHierarchyFor: aClass.! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: ''!
setClassShorcutsTo: aList

	aList attachKeymapCategory: #NautilusClassShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 8/1/2012 19:13'!
setCommentShorcutsTo: aList

	aList attachKeymapCategory: #NautilusCommentShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'EstebanLorenzano 2/6/2013 14:00'!
setGroupShorcutsTo: aList
	aList attachKeymapCategory: #NautilusGroupShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'EstebanLorenzano 2/6/2013 17:30'!
setShortcuts: groupSymbol to: aMorph
	aMorph 
		attachKeymapCategory: (	Nautilus useOldStyleKeys 
			ifTrue: [ groupSymbol ]
			ifFalse: [ #NautilusGlobalShortcuts ])
		targetting: self
! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'EstebanLorenzano 1/30/2013 14:37'!
setSourceCodeShorcutsTo: aList

	aList attachKeymapCategory: #NautilusSourceCodeShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
setStylerClass: aClass

	sourceTextArea
		ifNotNil: [ sourceTextArea classOrMetaClass: aClass ]! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 8/3/2012 16:18'!
setWindowTitle

	| title |
	shouldUpdateTitle ifFalse: [ ^ self ].
	title := self selectedClass 
				ifNil: [ self selectedPackage
							ifNil: [ self title ]
							ifNotNil: [: p | p name ]]
				ifNotNil: [:class |
					self selectedMethod
						ifNil: [ class name asString ]
						ifNotNil: [:method |
							String streamContents: [:s | s << method methodClass name asString<< '>>#'<< method selector ]]].
	self browsedEnvironment isSystem ifFalse: [ title := String streamContents: [:s | s << '--- ' << title << ' ---']].
	window title: title.! !

!AbstractNautilusUI methodsFor: 'Shout' stamp: ''!
shoutAboutToStyle: aPluggableShoutMorphOrView 

	^ aPluggableShoutMorphOrView == sourceTextArea! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
showByteCode

	^ self currentDisplayChoice = self byteCodeSymbol! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showComment

	^ self model showComment! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:48'!
showComment: aBoolean
	
	self okToChangeComment
		ifFalse: [ ^ self ].
	self model showComment: aBoolean.
	
	self updateCodePanel! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
showDecompile

	^ self currentDisplayChoice = self decompileSymbol! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showGroups

	^ self model showGroups! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/6/2013 17:43'!
showGroups: aBoolean

	self okToChange ifFalse: [ ^ self ].
	
	self setShortcuts: #NautilusClassShortcuts to: list2.
	
	aBoolean 
		ifTrue: [ 
			list enabled: true.
			self removeShortcuts: #NautilusPackageShortcuts from: list.
			self setShortcuts: #NautilusGroupShortcuts to: list ]
		ifFalse: [
			self removeShortcuts: #NautilusGroupShortcuts from: list.
			self setShortcuts: #NautilusPackageShortcuts to: list ].
		
	
	
	listElements := nil.
	self showPackages 
		ifFalse: [ self showPackagesSilently: true ].
	self selectedGroup
		ifNil: [ self selectedClass: nil ]
		ifNotNil: [:group |
			(group elements includes: self selectedClass)
				ifFalse: [ 
					list2Elements := nil.
					self selectedClass: nil ].
	aBoolean 
		ifTrue: [ 
			groupsSelection at: group put: true ]
		ifFalse: [ 
			packagesSelection at: self selectedPackage put: true ]].

	self model showGroups: aBoolean.
	self changed: #groupsButtonLabel.
	self changed: #toggleButtonLabel.
	self changedLabels.
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showGroupsSilently: aBoolean

	self model showGroups: aBoolean! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showHierarchy

	^ self model showHierarchy! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/22/2012 16:42'!
showHierarchy: aBoolean

	self model showHierarchy: aBoolean.
	listElements := nil.
	list2Elements := nil.
	aBoolean 
		ifTrue: [ self hierarchyClass: self selectedClass ].
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showInstance

	^ self model showInstance! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2013 14:27'!
showInstance: aBoolean

	self okToChange
		ifTrue:[
			self model showInstance: aBoolean.
			classesSelection removeAll.
			self selectedClass 
				ifNotNil: [:class | 
					aBoolean 
						ifTrue: [self selectedClass: class theNonMetaClass ]
						ifFalse: [self selectedClass: class theMetaClass ]].
			self update.
			self changed: #instanceButtonState.
			self changed: #instanceButtonLabel ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showPackages

	^  self model showPackages! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/22/2012 17:32'!
showPackages: aBoolean

	self okToChange
		ifTrue: [
			listElements := nil.
			list2Elements := nil.
			list enabled: aBoolean.
			aBoolean
				ifFalse: [| class |
					class := self selectedClass theNonMetaClass.
					classesSelection at: class put: true.
					self hierarchyClass: class .
					listElements := nil.
					list2Elements := nil.
					self showGroups
						ifTrue: [self showGroupsSilently: false]].
			listElements := nil.
			list2Elements := nil.
			self model showPackages: aBoolean.
			self changed: #groupsButtonLabel.
			self updateBothView.
			self changed: #toggleButtonState.
			self changed: #toggleButtonLabel.
			self changedLabels ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
showPackagesSilently: aBoolean

	self model showPackages: aBoolean.! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
showSource

	^ self currentDisplayChoice = self sourceCodeSymbol! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
showUnreferencedClassVars
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	self showUnreferencedClassVarsOf: self selectedClass.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: ''!
showUnreferencedInstVars
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"

	self showUnreferencedInstVarsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
sortClassesInCachedHierarchy: a b: b
	"Bullshitty name, Thanks Camillo"
	| index aa bb minSize|
	aa := cachedHierarchy at: a.
	bb := cachedHierarchy at: b.
	
	minSize := aa size min: bb size.
	
	1 to: minSize do: [ :i | |compare|
		compare := (aa at: i) name compare: (bb at: i) name.
		compare ~~ 2
			ifTrue: [  ^ compare == 1 ]].
	^  aa size < bb size! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: ''!
sourceCode

	self removeSourceTextAreaLimit.
	^self selectedClass isNil
		ifTrue: [ self defaultClassDescriptor]
		ifFalse:[ self selectedMethod isNil
				ifTrue: [ self selectedCategory notNil
						ifTrue: [ 
							self putSourceTextAreaLimit.
							self defaultMethodSource]
						ifFalse: [ self selectedClassDescription]]
				ifFalse: [ 
					self putSourceTextAreaLimit.
					self selectedMethodSource]].
		! !

!AbstractNautilusUI methodsFor: 'browser compatibility' stamp: ''!
sourceCode: aText 

	self okToChange
		ifTrue: [ 
			sourceTextArea setText: aText.
			sourceTextArea takeKeyboardFocus ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
sourceCodeContainer

	^ sourceCodeContainer! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/4/2012 01:07'!
sourceCodeFrom: aTextMorph

	aTextMorph ifLocked: [ ^ aTextMorph textMorph text ].

	^ self sourceCode! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: 'EstebanLorenzano 1/31/2013 19:24'!
sourceCodeMenu: aMenu shifted: shifted
	" Morphic's menus are filled up when pragma's one are returned from a method, so I have to substitute the morphic menu by the pragma one "
	
	^ aMenu addAllFrom: (self sourceCodeMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'menu builder' stamp: ''!
sourceCodeMenuBuilder

	^ PragmaMenuBuilder pragmaKeyword: self sourceCodePragma model: self! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/14/2012 17:33'!
sourceCodePanel

	^ sourceCodePanel! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'EstebanLorenzano 1/30/2013 17:30'!
sourceCodePragma
	^ 'nautilusGlobalSourceCodeMenu'! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
sourceCodeSymbol

	^ #SourceCode! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
sourceTextArea

	^ sourceTextArea! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
switchToByteCodeButton

	self okToChange ifTrue: [ self currentDisplayChoice: self byteCodeSymbol ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
switchToDecompileButton

	self okToChange ifTrue: [ self currentDisplayChoice: self decompileSymbol ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
switchToSourceCodeButton

	self okToChange ifTrue: [ self currentDisplayChoice: self sourceCodeSymbol ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
systemNavigation

	^ SystemNavigation new 
			browsedEnvironment: self browsedEnvironment;
			yourself! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: ''!
taskbarIcon

	^ self class icon! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/14/2012 12:17'!
testCaseStarted: anAnnouncement
	| class selector |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement testCase class.
	selector := anAnnouncement testSelector.
	self selectedClass = class
		ifTrue: [| method correspondingClass icon |
			icon := self iconClass iconNamed: #testNotRun.
			method := class methodNamed: selector.
			correspondingClass := class correspondingClass.
			self methodWidget 
				setIcon: icon for: method;
				updateList ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/16/2013 15:27'!
testRunned: anAnnouncement

	| collection class correspondingClass |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	class := anAnnouncement testResult.
	correspondingClass := anAnnouncement testResult correspondingClass.
	collection :=  self getList2.
	
	(collection includesAnyOf: {class. correspondingClass})
		ifTrue: [ 
			self removeClassFromMethodsIconsCache: class.
			self removeClassFromMethodsIconsCache: correspondingClass.
			self updateClassView.
			self update ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
textMorphClass

	^ PluggableTextMorphWithLimits! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
title

	^'Nautilus'! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: ''!
title: aString

	shouldUpdateTitle := false.
	window title: aString! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
toggleButtonAction

	self toggleButtonEnabled
		ifTrue: [ 
			self toggleShowPackages.
			self changed: #toggleButtonEnabled. ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
toggleButtonEnabled

	^ (self selectedClass ~~ nil or: [ self showPackages not ])! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
toggleButtonLabel

	^ self showPackages
		ifTrue: [ 'Hierarchy' ]
		ifFalse: [ 'Flat' ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: ''!
toggleButtonState

	^ self showPackages not! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/1/2012 19:46'!
toggleShowComment

	self showComment: self showComment not.
	self changed: #commentButtonState! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'StephaneDucasse 12/19/2012 16:04'!
toggleShowFullComment

	self showComment ifFalse: [ ^ self ].
	
	sourceCodePanel removeAllMorphs.
	sourceCodePanel 
		addMorph: self commentTextArea
		fullFrame: LayoutFrame identity! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
toggleShowGroups

	self showGroups: self showGroups not.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/22/2012 16:42'!
toggleShowHierarchy

	self showHierarchy: self showHierarchy not.
! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
toggleShowInstance
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
toggleShowPackages

	self showPackages: self showPackages not.! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 8/6/2012 00:53'!
unlockTextArea: source

	multipleMethodsEditor removeEditor: source! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: ''!
unregisterAPlugin: aPlugin

	self announcer unsubscribe: aPlugin! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: ''!
unregisterAllPlugins

	self announcer subscriptions reset! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/18/2012 18:57'!
update
	
	self subclassResponsibility ! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 15:06'!
updateBothView

	listElements := nil.
	list2Elements := nil.
	self changed: #listElement:.
	self changed: #listElement2:! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 15:06'!
updateClassView

	list2Elements := nil.
	self changed: #listElement2: ! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:48'!
updateCodePanel
	commentTextArea ifNil: [ self buildCommentPane ].
	sourceCodePanel removeAllMorphs.
	self model showComment
		ifTrue: [ self buildCodePanelWithComment ]
		ifFalse: [ self buildCodePanelWithoutComment ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 15:06'!
updateGroupView

	listElements := nil.
	self changed: #listElement:! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 15:06'!
updatePackageView
	| scroll |
	
	listElements := nil.
	scroll := list scrollValue y.
	self changed: #listElement:.
	list vScrollValue: scroll! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 15:06'!
updatePackageViewAndMove
			
	listElements := nil.
	self changed: #listElement:! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 15:06'!
updatePackageViewContent

	| vScrollValue |
	vScrollValue := list scrollValue y.
	listElements := nil.
	self changed: #listElement:.
	list vScrollValue: vScrollValue! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 5/9/2012 11:33'!
wantsDroppedMorph: transferMorph event: anEvent inMorph: destinationLM 
	"We are only interested in TransferMorphs as wrappers for             
	informations. If their content is really interesting for us, will             
	determined later in >>acceptDroppingMorph:event:."

	| srcType dstType |

	"only want drops on lists (not, for example, on pluggable texts)"
	(destinationLM isKindOf: PluggableListMorph) ifFalse: [^ false].

	srcType := transferMorph dragTransferType.
	dstType := self dragTransferTypeForMorph: destinationLM.

	srcType == #getMethodItem:
		ifTrue: [
			^ (dstType == #getCategoryItem: or: [ dstType == #listElement2: ])].

	srcType == #getCategoryItem:
		ifTrue: [ ^  dstType == #listElement2: ].
	
	(srcType == #listElement2: and: [ dstType = #listElement: ]) 
		ifTrue: [ 
			(destinationLM potentialDropItem isKindOf: PluggableListMorph)
				ifTrue: [ ^ true ].
			self showGroups
				ifTrue: [ | receiver |
					receiver := destinationLM potentialDropItem originalObject.
					^ receiver isFillable ]
				ifFalse: [ ^ true ]]
		ifFalse:[ ^ false ].

	^ false! !

!AbstractNautilusUI methodsFor: 'private' stamp: ''!
warningLimit
	
	^ self model 
		ifNil: [ 350 ]
		ifNotNil: [:mod | model warningLimit ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
window

	^ window! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: ''!
window: anObject

	window := anObject! !

AbstractNautilusUI subclass: #NautilusUI
	instanceVariableNames: 'categories categoryWidget methodWidget methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI commentStamp: '<historical>' prior: 0!
A UI for an instance of Nautilus!

!NautilusUI class methodsFor: 'keymapping' stamp: 'CamilloBruni 10/4/2012 11:13'!
buildHistoryShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #previous)
		category: #NautilusGlobalShortcuts
		default: $[ command 
		do: [:target| target previous ]
		description: 'Go back in the navigation history.'.
		
	(aBuilder shortcut: #next)
		category: #NautilusGlobalShortcuts
		default: $] command 
		do: [:target| target next ]
		description: 'Go forward in the navigation history'.
	! !

!NautilusUI class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/8/2012 13:11'!
initializeCache
	"self initializeCache"
	| collection instance |
	collection := Smalltalk allClassesAndTraits.
	instance := self new model: Nautilus new.
	
	collection
		do: [:cls | 
			instance classIconFor: cls.
			cls methodDict 
				do: [:m | instance methodWidget methodIconFor: m ]
				displayingProgress: [:m | 'Filing up cache for ', m dragAndDropPrint ]]
		displayingProgress: [:cls | 'Filing up cache for ', cls name ]! !

!NautilusUI methodsFor: 'displaying' stamp: 'EstebanLorenzano 1/30/2013 14:49'!
addAll: aWindow
			
	| column navigationRow topHeight middleHeight bottomMorph bottomHeight delta |
	delta := 0.
	bottomHeight := 0.
	middleHeight := 0.
	topHeight := 0.

	" reverse order in column ..."
	"column vResizing: #rigid."
	self buildTopPlugins ifNotNil: [:top |
		topHeight := top height.
		aWindow 
			addMorph: top
			fullFrame: ((0 @ 0 corner: 1 @ 0) asLayoutFrame bottomOffset: topHeight).
		delta := 4.
		topHeight := topHeight + delta.
		top color: Color transparent].
	
	"navigationRow := self buildNavigationRow: aWindow height: topHeight."

	self buildColumns: aWindow height: topHeight"+navigationRow".
	self setShortcuts: #NautilusSourceCodeShortcuts to: aWindow.
	
	self buildMiddlePlugins ifNotNil: [:middle |
		middleHeight := middle height+4.
		aWindow 
			addMorph: middle
			fullFrame: ((0 @ 0.5 corner: 1 @ 0.5) asLayoutFrame bottomOffset: middleHeight).
		middle color: Color transparent].
	
	sourceCodePanel := PanelMorph new.
	self setShortcuts: #NautilusSourceCodeShortcuts to: sourceCodePanel.
	sourceCodePanel changeProportionalLayout.
		
	sourceCodePanel 
		addMorph: self buildCodePane
		fullFrame: LayoutFrame identity.
		
	"self buildCommentPane."
	sourceCodePanel 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	sourceCodeContainer := PanelMorph new.
	self setShortcuts: #NautilusSourceCodeShortcuts to: sourceCodeContainer.
	sourceCodeContainer 
		changeTableLayout;
		listDirection: #leftToRight.

	{	sourceCodePanel.
		self buildTextAreaButtonsColumn: aWindow} reverse do: [:each | sourceCodeContainer addMorph: each].
	
	bottomMorph := self buildBottomPlugins.
	
	bottomMorph ifNotNil: [:bottom | bottomHeight := bottom height + 8].
	aWindow
		addMorph: sourceCodeContainer
		fullFrame: ( (0@0.5 corner: 1 @ 1) asLayoutFrame 
						topOffset: middleHeight;  bottomOffset: bottomHeight negated).
						
	bottomMorph ifNotNil: [:bottom |					
		aWindow				
			addMorph: bottom
			fullFrame: ((0 @ 1 corner: 1 @ 1) asLayoutFrame topOffset:  bottomHeight negated).
		bottom color: Color transparent]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/17/2012 21:17'!
addCategory
	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| newName |
	
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^ self].

	newName := self 
		addCategoryIn: self selectedClass 
		before: self selectedCategory.
	self resetCategoriesListSelection.
	categoryWidget selectProtocol: newName.
	self selectedCategory: newName.
	newName ifNil: [ ^ self ].
	self 
		update;
		giveFocusToSourceCode.! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 6/22/2012 17:00'!
addMethod
	
	self okToChange ifFalse: [ 
		sourceTextArea flash.
		^ self ].
	sourceTextArea setText: ''.
	self giveFocusTo: sourceTextArea.! !

!NautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 4/14/2012 12:17'!
addMethodsInGroup

	self selectedMethods ifNotNil: [:mthds | self addMethodsInGroup: mthds ]! !

!NautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 4/14/2012 12:10'!
addMethodsInGroup: aCollection

	(DialogGroupAdder new
		groups: self groupsManager;
		elementsToAdd: (aCollection sort: [:a :b | a name < b name]))
		open! !

!NautilusUI methodsFor: 'group' stamp: ''!
addProtocolsInGroup

	self selectedCategories ifNotNil: [:ctgrs | self addProtocolsInGroup: ctgrs ].! !

!NautilusUI methodsFor: 'group' stamp: ''!
addProtocolsInGroup: aCollection
	| class mthds |
	
	(class := self selectedClass) ifNil: [ ^ self ].
	
	mthds := self showGroups
				ifTrue: [ self methodsForCategoriesInGroup: aCollection ]
				ifFalse:[ self methodsForCategories: aCollection ].

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementsToAdd: (mthds sort: [:a :b | a name < b name]))
		open! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
allLabel

	^ '--- all ---'! !

!NautilusUI methodsFor: 'plugins display' stamp: 'EstebanLorenzano 1/30/2013 14:48'!
buildBottomPlugins

	| bottom container |
	bottom := self model plugins select: [:each | each position = #bottom ].
	bottom ifEmpty: [ ^ nil ].
	bottom size = 1 ifTrue: [ ^ bottom first display ].
	container := Morph new.
	self setShortcuts: #NautilusSourceCodeShortcuts to: container.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	bottom reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI methodsFor: 'tests' stamp: 'EstebanLorenzano 2/6/2013 17:01'!
buildCategoryWidget
	| categoriesList |
	
	categoriesList := categoryWidget buildCategoriesList.	
	
	self 
		setShortcuts: #NautilusProtocolShortcuts 
		to: categoriesList. 
	
	^categoriesList! !

!NautilusUI methodsFor: 'displaying' stamp: 'StephaneDucasse 12/19/2012 16:12'!
buildColumns: aWindow height: height
	| delta |		
	delta := StandardFonts defaultFont height + 10.
	aWindow 
		addMorph: (self buildFirstColumn: aWindow)
		fullFrame: ((0 @ 0 corner: 0.25 @ 0.5) asLayoutFrame 
						topOffset: height ).
						
	aWindow 
		addMorph: (self buildSecondColumn: aWindow)
		fullFrame: ((0.25 @ 0 corner: 0.5 @ 0.5) asLayoutFrame
						topOffset: height ).
						
	aWindow 
		addMorph: (self buildThirdColumn: aWindow)
		fullFrame: ( (0.5 @ 0 corner: 0.75 @ 0.5) asLayoutFrame
						topOffset: height ; bottomOffset: delta negated).
						
	aWindow 
		addMorph: (self buildFourthColumn: aWindow)
		fullFrame: ( (0.75 @ 0 corner: 1 @ 0.5) asLayoutFrame
						topOffset: height; bottomOffset: delta negated).
						
	aWindow
		addMorph: self buildNavigationList
		fullFrame: ((0.5 @ 0.5 corner: 1 @ 0.5) asLayoutFrame
						topOffset: delta negated ).! !

!NautilusUI methodsFor: 'displaying' stamp: ''!
buildFourthColumn: aWindow
		
	^ self buildMethodWidget! !

!NautilusUI methodsFor: 'widget - category' stamp: 'EstebanLorenzano 2/6/2013 17:12'!
buildMethodWidget
	| methodsList |
	
	methodsList := methodWidget buildMethodsList.	
	
	self 
		setShortcuts: #NautilusMethodShortcuts 
		to: methodsList. 
	
	^methodsList	
! !

!NautilusUI methodsFor: 'plugins display' stamp: 'EstebanLorenzano 1/30/2013 14:50'!
buildMiddlePlugins

	| middle container |
	middle := self model plugins select: [:each | each position = #middle ].
	middle ifEmpty: [ ^ nil ].
	middle size = 1 ifTrue: [ ^ middle first display ].
	container := Morph new.
	self setShortcuts: #NautilusSourceCodeShortcuts to: container.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	middle reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI methodsFor: 'items creation' stamp: 'EstebanLorenzano 1/30/2013 14:50'!
buildNavigationList
	| navigation |
	
	navigation := (DropListMorph
					on: self 
					list: #getHistoryList
					selected: #currentHistoryIndex
					changeSelected: #setHistory:)
					hResizing: #spaceFill;
					vResizing: #spaceFill;
					wrapSelector: #wrapHistory:;
					ghostText: 'History Navigator';
					yourself.
			
	self setShortcuts: #NautilusSourceCodeShortcuts to: navigation.
	
	^ navigation! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
buildTestSelectorFor: aMethod

	^ String streamContents: [:s || capitalize |
		capitalize := true.
		s << 'test'.
		aMethod selector do: [:c |
			c = $:
				ifTrue: [ capitalize := true ]
				ifFalse: [ capitalize
							ifTrue: [ 
								capitalize := false.
								s << c asUppercase. ]
							ifFalse:[ s << c ]]]]
			! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/2/2012 10:33'!
buildTestSuiteFor: aMethod

	^ TestSuite new
		addTest: (aMethod methodClass selector: aMethod selector);
		yourself! !

!NautilusUI methodsFor: 'displaying' stamp: ''!
buildThirdColumn: aWindow

	^ self buildCategoryWidget! !

!NautilusUI methodsFor: 'plugins display' stamp: ''!
buildTopPlugins

	| top container |
	top := self model plugins select: [:each | each position = #top ].
	top ifEmpty: [ ^ nil ].
	top size = 1 ifTrue: [ ^ top first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	top reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI methodsFor: 'tests' stamp: ''!
categoriesLabel

	^ categoryWidget categoriesLabel! !

!NautilusUI methodsFor: 'tests' stamp: ''!
categoriesMenu: aMenu shifted: b

	^ aMenu becomeForward: (self categoryMenuBuilder menu)! !

!NautilusUI methodsFor: 'tests' stamp: ''!
categoriesSelection

	^ categoryWidget categoriesSelection! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
categorizeMethod

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| aCollection aClass |
	self okToChange ifFalse: [^ self].
	(aCollection := self selectedMethods) ifEmpty: [^ self].
	(aClass := self selectedClass) ifNil: [^self].	

	self categorizeMethods: aCollection of: aClass from: aCollection first category.

	self update.! !

!NautilusUI methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 5/14/2012 12:17'!
categorySelectionChanged

	methodWidget 
		resetMethodCache;
		updateList.! !

!NautilusUI methodsFor: 'accessing' stamp: ''!
categoryWidget

	^ categoryWidget! !

!NautilusUI methodsFor: 'shortcuts from text morph' stamp: 'CamilloBruni 9/22/2012 20:12'!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController

	| category selector class scroll method|
	category := aCategory.
	class := self selectedClass ifNil: [ ^ Error signal: 'Should not happen!!' ].
	scroll := sourceTextArea scrollValue y.
	(category = self noMethodsString or: [ category = self allLabel ])
		ifTrue: [ category := self asYetUnclassifiedString ].
	
	"sourceTextArea update: #clearUserEdits."
	selector := self compileANewMethodInClass: class categorized: category from: aString notifyng: aController.
	
	selector ifNil: [ ^ sourceTextArea hasUnacceptedEdits: true ].
	method := (class methodNamed: selector).
	
	sourceTextArea update: #clearUserEdits.
	sourceTextArea vScrollValue: scroll.
	"self selectedCategory: cat."
	"methodsTree setSelectedNodeItem: method."
	( self selectedMethod notNil and: [(self selectedClass = class) and: [ self selectedMethod selector = selector]])
		ifFalse: [
			self selectedMethod: method.
			self update.
			sourceTextArea vScrollValue: scroll.]! !

!NautilusUI methodsFor: 'shortcuts from text morph' stamp: 'CamilloBruni 9/22/2012 19:48'!
compileSource: aText notifying: aController

	| source category method |
	
	source := aText asString.
	category := self selectedCategory.
	method := self selectedMethod.
	category ifNil: [ method ifNotNil: [ category := method protocol ]].
	
	(category isNil and: [ method isNil ])
		ifTrue: [ 
			source first isUppercase
				ifTrue: [ ^ self compileAClassFrom: source notifying: aController ].
			category := Categorizer default ]
		ifFalse: [
			((category = self allLabel) and: [ self selectedMethod notNil ])
				ifTrue: [ category := self selectedMethod protocol ]].
	
	self compileAMethodFromCategory: category withSource: source notifying: aController! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/8/2013 16:32'!
contentsSelectionFrom: aTextMorph 

	^ (contentSelection notNil and: [ aTextMorph == sourceTextArea  ])
		ifTrue: [ | result |
			result := contentSelection.
			contentSelection := nil.
			result ]
		ifFalse: [ self contentSelectionFor: aTextMorph ]! !

!NautilusUI methodsFor: 'history behavior' stamp: 'CamilloBruni 10/4/2012 10:49'!
currentHistoryIndex

	| index item |
	
	index := 1 min: self getHistoryList size.
	index = 0 ifTrue: [ ^ 0 ].
	
	item := (self getHistoryList at: index) key.
	self selectedClass = item selectedClass ifFalse: [ ^ 0 ].
	
	self selectedMethod ifNil: [ ^ 0 ].
	
	self selectedMethod selector = item selectedMethod
		ifTrue: [ ^ index ]
		ifFalse: [ ^ 0 ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/2/2012 10:48'!
debugTest
	| method |
	
	method := self selectedMethod.
	method correspondingTestMethod 
		ifNotNil: [:test | 
			self debugTest: test ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'FernandoOlivero 11/25/2012 22:13'!
debugTest: aMethod
	| context process |
	context := [ :value | 
	[ value run ]
		ensure: [ 
			UIManager default uiProcess == Processor activeProcess
				ifFalse: [ Processor activeProcess terminate ] ] ] asContext.
	context
		pop;
		push: (self buildTestSuiteFor: aMethod).
	[ context isNil or: [ context selector = aMethod selector ] ]
		whileFalse: [ 
			context := context selector = #setUp
				ifTrue: [ context quickStep ]
				ifFalse: [ context step ] ].
	context isNil
		ifTrue: [ ^ UIManager default inform: 'Unable to open debugger on #' , aMethod selector ].
	process := Process forContext: context priority: Processor userInterruptPriority.
	Smalltalk tools debugger
		openOn: process
		context: context
		label: 'Debug ' , aMethod methodClass name , '>>#' , aMethod selector
		contents: nil
		fullView: true! !

!NautilusUI methodsFor: 'remove me' stamp: 'BenjaminVanRyseghem 5/14/2012 12:07'!
decrementMethodsListIndex

	| index |
	methodWidget resetMethodsListSelection.
	index :=(methodWidget selectedMethodIndex - 1).
	index < 1 ifTrue: [ index := methodWidget methodListSize ]. 
	methodWidget selectedMethodIndex: index.
	sourceTextArea takeKeyboardFocus! !

!NautilusUI methodsFor: 'drag and drop' stamp: ''!
dropMethod: aCollectionOfMethods inARow: aRow

	| newProtocol |
	
	newProtocol := self getCategories at: aRow.
	aCollectionOfMethods do: [:aMethod | self move: aMethod from: aMethod category to: newProtocol isCopy: false ].
	self selectedMethod: nil! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
elementsMenu: aMenu shifted: b

	^ aMenu becomeForward: (self methodMenuBuilder menu)! !

!NautilusUI methodsFor: 'tests' stamp: ''!
enableCategorySingleSelection

	^ self selectedCategories size <= 1! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
enableMethodSingleSelection

	^ self selectedMethods size <= 1! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
fileOutCategories

	self fileOutCategories: self selectedCategories from: self selectedClass! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
fileOutMethods

	self fileOutMethods: self selectedMethods! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 01:24'!
findAllMethod
	"Search for a method in the lookup of the selected class"

	| foundMethod class |
	self okToChange ifFalse: [^ self flashPackage ].
	
	class := self selectedClass.
	class ifNil: [ ^ self ].
	
	foundMethod := (SearchFacade allMessageSearchFor: class) chooseFromOwner: self window.
	foundMethod ifNil: [^ self ].
	
	self showGroupsSilently: false.
	self categoryWidget resetSelection.
	self methodWidget resetSelection.
	self categoryWidget selectProtocol: foundMethod category.
 	self model package: class package class: class category: foundMethod protocol method: foundMethod.
	
	self updateBothView.
	self update.
	self changed: #sourceCodeFrom:! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
findMethod
	"Search for a method in the lookup of the selected class"

	| foundMethod class |
	self okToChange ifFalse: [^ self flashPackage ].
	
	class := self selectedClass.
	class ifNil: [ ^ self ].
	
	foundMethod := (SearchFacade messageSearchFor: class) chooseFromOwner: self window.
	foundMethod ifNil: [^ self ].
	
	self showGroupsSilently: false.
	self categoryWidget resetSelection.
	self methodWidget resetSelection.
	self categoryWidget selectProtocol: foundMethod category.
 	self model package: class package class: class category: foundMethod protocol method: foundMethod.
	
	self updateBothView.
	self update.
	self changed: #sourceCodeFrom:! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'CamilloBruni 9/14/2012 02:09'!
findProtocol
	"Search for a method in the lookup of the selected class"

	| foundProtocol class |
	
	class := self selectedClass.
	class ifNil: [ ^ self ].
	self okToChange ifFalse: [^ self flashPackage ].

	foundProtocol := (SearchFacade protocolSearchFor: class) chooseFromOwner: self window.
	foundProtocol ifNil: [^ self ].
		
	self showGroupsSilently: false.
	self categoryWidget resetSelection.
	self categoryWidget selectProtocol: foundProtocol.
 	self model package: class package class: class category: foundProtocol method: nil.
	
	self updateBothView.
	self update.
	self changed: #sourceCodeFrom:! !

!NautilusUI methodsFor: 'category-method methods' stamp: ''!
forceSelectedMethod: aMethod 
	
	self model package: self selectedPackage class: self selectedClass category: self selectedCategory method: aMethod.! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
forceSelection: aNode
 ! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
fullBrowse

	self model class 
		openOnPackage: self selectedPackage
		class: self selectedClass
		category: self selectedCategory
		method: self selectedMethod
		group: self selectedGroup
		showGroups: self showGroups
		showHierarchy: self showHierarchy
		showPackages: self showPackages
		showComment: self showComment 
		showInstance: self showInstance 
		showCategories: true
! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
generateSourceCodeForTestFrom: aMethod

	^ self buildTestSelectorFor: aMethod.! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 4/3/2012 17:49'!
generateTestMethodFor: aMethod

	"generate a test method for aMethod and return the generated method"
	| class |

	class := self model classes detect: [:e | e name = (aMethod methodClass name,'Test')] ifNone: [ self createTestForClass: aMethod methodClass ].
	class
		ifNotNil:[ 
			class compile: (self generateSourceCodeForTestFrom: aMethod) classified: 'tests-',aMethod category.
			^ class >> (self buildTestSelectorFor: aMethod) asSymbol ].
	^ nil! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
generateTestMethodsAndFocus: aBoolean

	"generate testing methods for the selected methods in the test class"
	"I assume the test class is named #{MyClassName}Test"
	| focus |
	self selectedMethods ifEmpty: [^ self].
	self selectedMethods reverse do: [:method | focus := self generateTestMethodFor: method ].
	focus ifNil: [ ^ self ].
	(aBoolean and: [ self okToChange ])
		ifTrue: [
			self showGroups: false.
			self selectedPackage: focus methodClass package.
			self selectedClass: focus methodClass.
			self selectedCategory: 'tests'.
			methodWidget selectMethod: focus.
			self selectedMethod: focus.
			self updateBothView ]! !

!NautilusUI methodsFor: 'tests' stamp: ''!
getCategories

	^ categoryWidget getCategories! !

!NautilusUI methodsFor: 'history behavior' stamp: ''!
getHistoryList

	^ self model historyEntries reversed! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
getMethods

	^ methodWidget getMethods! !

!NautilusUI methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/22/2012 17:58'!
giveFocusToClass

	self giveFocusTo: list2! !

!NautilusUI methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/22/2012 18:00'!
giveFocusToMethod

	self giveFocusTo: methodWidget! !

!NautilusUI methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/22/2012 17:59'!
giveFocusToProtocol

	self giveFocusTo: categoryWidget! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
hasFocus

	^ window hasKeyboardFocus or: 
		[ list hasKeyboardFocus or:
		[ list2 hasKeyboardFocus or: 
		[ categoryWidget hasFocus or:
		[ methodWidget hasFocus or:
		[ sourceTextArea hasKeyboardFocus ]]]]]! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
highlightCategory: aMethod.
		methodWidget resetMethodCache.
		aMethod 
			ifNil: [ categoryWidget searchedElement: categoryWidget selectedCategoryIndex ]
			ifNotNil: [ | category index |
				category := aMethod protocol.
				index := self getCategories indexOf: ( category ).
				categoryWidget searchedElement: index ]! !

!NautilusUI methodsFor: 'history behavior' stamp: 'CamilloBruni 10/4/2012 10:49'!
historyChanged

	self setWindowTitle.
	self changed: #getHistoryList.
	self changed: #currentHistoryIndex! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/18/2012 18:43'!
implementSelector

	| selection |
	
	selection := sourceTextArea selectedContents asString.
	selection ifEmpty: [ ^ sourceTextArea flash ].
	
	self implementSelector: selection findSelector! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'MarcusDenker 9/17/2012 15:34'!
implementSelector: aSelector
	| behavior method category head source |
	
	category := ClassOrganizer default.
	behavior := SearchFacade classSearch chooseFromOwner: self window.
	aSelector ifNil: [ ^ sourceTextArea flash ].
	behavior ifNil: [ ^ sourceTextArea flash ].
	
	(behavior includesSelector: aSelector)
		ifFalse: [ 
			head := (self signatureFor: aSelector).
			source := head,'

	^ self shouldBeImplemented'.
			method := behavior compile: source classified: category notifying: sourceTextArea ].

	method := (behavior methodNamed: aSelector).
	self showInstance: true.
	self showGroups: false.

	self model
		package: behavior package 
		class: behavior
		category: category
		method: method.
		
	self update.
	self updateBothView.
	self changed: #sourceCodeFrom:.
	self giveFocusTo: sourceTextArea.
	head
		ifNotNil: [ sourceTextArea selectFrom: head size + 4 to: source size ].! !

!NautilusUI methodsFor: 'remove me' stamp: ''!
incrementMethodsListIndex

	| index |
	methodWidget resetMethodsListSelection.
	index := (methodWidget selectedMethodIndex + 1).
	index > methodWidget getMethods size ifTrue: [ index := 1 ].
	methodWidget selectedMethodIndex: index.
	sourceTextArea takeKeyboardFocus ! !

!NautilusUI methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 5/14/2012 12:44'!
initialize
	"Initialization code for NautilusUI"

	super initialize.

	categoryWidget := CategoryWidget model: self.
	methodWidget := MethodWidget model: self.! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
keyPressedOnElement: anEvent

		^ self methodWidget keyPressedOnElement: anEvent! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 4/25/2012 11:11'!
keyPressedOnList2: anEvent shifted: aBoolean
	| aCharacter |

	aCharacter := anEvent keyCharacter.

	(aCharacter == self class nextFocusKey) ifTrue: [ ^ self giveFocusTo: categoryWidget ].
	(aCharacter == self class previousFocusKey) ifTrue: [ ^ self giveFocusTo: list ].! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 6/24/2012 17:55'!
keyPressedOnList: anEvent shifted: aBoolean
	| aCharacter |

	aCharacter := anEvent keyCharacter.
	
	(aCharacter == self class nextFocusKey) ifTrue: [ ^ self giveFocusTo: list2 ].
	(aCharacter == self class previousFocusKey) ifTrue: [ ^ self giveFocusTo: sourceTextArea ].! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/5/2012 14:38'!
keyStroke: anEvent fromSourceCodeMorph: aMorph
	"Here I received each key stroke in the source code text morph"

	| string |
	(self selectedMethod isNil and: [ self selectedCategory isNil ])
		ifTrue: [
			(sourceTextArea text isEmpty or: [ sourceTextArea text first isLowercase])
				ifTrue: [ self setStylerClass: self selectedClass ]
				ifFalse: [ self setStylerClass: nil ]].

	string := anEvent keyString.

	string = '<Ctrl-Cmd-right>'
		ifTrue: [ ^ self giveFocusTo: list ].
	
	string = '<Ctrl-Cmd-left>'
		ifTrue: [ ^ self giveFocusTo: methodWidget ].
	
	string =  '<Cmd-Shift-up>'
		ifTrue: [ ^ self decrementMethodsListIndex ].
	
	string =  '<Cmd-Shift-down>'
		ifTrue: [ ^ self incrementMethodsListIndex ].
		
	self aKeyHasBeenPressed: anEvent keyCharacter.
	! !

!NautilusUI methodsFor: 'tests' stamp: ''!
loadCategories
	
	^ self model selectedClass
		ifNil: [ {} ]
		ifNotNil: [:class | class protocols asOrderedCollection sort addFirst: self allLabel; yourself ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'EstebanLorenzano 1/25/2013 18:18'!
methodAdded: anAnnouncement
	
	| method |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	method := anAnnouncement method.
	(method methodClass = self selectedClass)
		ifTrue: [ 
			self resetMethodsListSelection.
			self removeAllFromMethodsIconsCache: method.
			self update.
			(method methodClass isMeta and: [ method methodClass methodDict size = 1 ])
				ifTrue: [ self changed: #instanceButtonLabel ] ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/16/2013 15:21'!
methodModified: anAnnouncement 
	| collection |

	window isNil ifTrue: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	collection := self getList2.
	
	(collection includes: anAnnouncement methodClass)
		ifTrue: [
			| method selectedMethod oldMethod |
			method := anAnnouncement newMethod.
			selectedMethod := self selectedMethod.
			self removeFromMethodsIconsCache: method.
			method isTestMethod
				ifTrue: [ "Should update class icon"
					ClassesIconsCache removeKey: method methodClass ifAbsent: []].
			self updateClassView.
			oldMethod := anAnnouncement oldMethod.
			(selectedMethod = oldMethod 
				or: [ 
					oldMethod hasBreakpoint 
					and: [ selectedMethod methodClass = oldMethod methodClass 
					and: [ selectedMethod selector = oldMethod selector ]]])
				ifTrue: [
					sourceTextArea hasUnacceptedEdits
						ifTrue: [ | sourceCode |
							sourceCode := sourceTextArea text.
							self forceSelectedMethod: method.
							self update.
							self highlightCategory: method.
							sourceTextArea setText: sourceCode.
							sourceTextArea hasEditingConflicts: true.
							sourceTextArea update: #codeChangedElsewhere ]
						ifFalse: [
							self selectedMethod: method.
							self update ]]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'GuillermoPolito 8/3/2012 13:23'!
methodRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	(anAnnouncement methodClass = self selectedClass)
		ifTrue: [ self update ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 2/16/2013 15:21'!
methodRemoved: anAnnouncement
	
	| method |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	method := anAnnouncement methodRemoved.
	(method methodClass = self selectedClass)
		ifTrue: [ 
			self selectedMethod = anAnnouncement methodRemoved
				ifTrue: [ self selectedMethod: nil ].
			self resetMethodsListSelection.
			self removeAllFromMethodsIconsCache: method.
			method isTestMethod
				ifTrue: [ "Should update class icon"
					ClassesIconsCache removeKey: method methodClass ifAbsent: [].
					self updateClassView ].
			self update.
			(method methodClass isMeta and: [ method methodClass methodDict isEmpty ])
				ifTrue: [ self changed: #instanceButtonLabel ] ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/17/2012 15:05'!
methodWidget

	^ methodWidget! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
methodsForCategories: aCollection

	^ aCollection gather: [:e | self methodsForCategory: e ]! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
methodsForCategoriesInGroup: aCollection

	| mthds |
	mthds := aCollection gather: [:e | self methodsForCategoryInGroup: e ].
	^ mthds sort: [:a :b | a selector < b selector ]! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
methodsForCategory: aCategory 
	| methds class env |
	
	class := self selectedClass.
	class ifNil: [ ^ #() ].
	env := self browsedEnvironment.
	methds := env isSystem
		ifTrue: [ self methodsInSystemEnvironmentForCategory: aCategory  in: class ]
		ifFalse: [ self methodsInARestrictedEnvironment: env forCategory: aCategory  in: class ].
	^ methds sort: [:a :b | a selector < b selector ].! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
methodsForCategoryInGroup: aCategory
	| class group env mthds |

	(class := self selectedClass) ifNil: [ ^ {} ].
	(group := self selectedGroup) ifNil: [ ^ {} ].
	env := self browsedEnvironment.
	mthds := env isSystem
		ifTrue: [
			aCategory = self allLabel
				ifTrue: [ (group methodsFor: class) asOrderedCollection ]
				ifFalse: [ (group methodsFor: class categorised: aCategory) asOrderedCollection ]]
		ifFalse: [
			aCategory = self allLabel
				ifTrue: [ (group methodsFor: class) asOrderedCollection select: [:e | env includesSelector: e selector in: class ]]
				ifFalse: [(group methodsFor: class categorised: aCategory) asOrderedCollection select: [:e | env includesSelector: e selector in: class ]]].
	^ mthds sort: [:a :b | a selector < b selector ]! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 4/17/2012 13:40'!
methodsIconsCache
	
	^ self methodWidget methodsIconsCache! !

!NautilusUI methodsFor: 'widget - method' stamp: 'IgorStasenko 8/30/2012 15:59'!
methodsInARestrictedEnvironment: env forCategory: aCategory  in: class
	| mthds selectors |
	
	aCategory = self allLabel
		ifTrue: [ ^ class methods asOrderedCollection select: [:e | env includesSelector: e selector in: class ]].
	selectors := env selectorsFor: aCategory in: class.
	mthds := OrderedCollection new.
	selectors do: [:s | mthds add: (class compiledMethodAt: s) ].
	^ mthds! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
methodsInSystemEnvironmentForCategory: aCategory  in: class
	
	aCategory = self allLabel
		ifTrue: [ ^ class methods asOrderedCollection ].
	
	^ (class methodsInProtocol: aCategory) asOrderedCollection! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
methodsLabel

	^ methodWidget methodsLabel! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
methodsSelection

	^ methodWidget methodsSelection! !

!NautilusUI methodsFor: 'drag and drop' stamp: ''!
move: item from: oldCategory to: newCategory isCopy: isCopy

	| category |
	category := newCategory.
	category = self allLabel
		ifTrue: [ category := self asYetUnclassifiedString ].
	isCopy
		ifFalse: [
			item methodClass organization
				classify: item selector
				under: category 
				suppressIfDefault: false.
			self selectedMethod: item ] ! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
moveMethodToPackage
	"Search for a package from a pattern or from the recent list"	
	
	| packagesList  |	
	self okToChange ifFalse: [^ self flashPackage ].
	packagesList := self model packages collect: [:each | each name ].
	
	self moveMethodsToPackage: self selectedMethods in: packagesList  from: self selectedPackage.

	self update.
		
! !

!NautilusUI methodsFor: 'history behavior' stamp: 'CamilloBruni 10/4/2012 11:19'!
next
	self model hasNext 
		ifFalse: [ ^ self ].
	"show the next item in history"
	self model next! !

!NautilusUI methodsFor: 'private' stamp: ''!
nextButtonState
	^ true! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
notifyTitle: title contents: contents

	 GrowlMorph 
				openWithLabel: title
				contents: contents! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 4/19/2012 23:39'!
notifyTitle: title contents: contents color: aColor

	 GrowlMorph 
				openWithLabel: title
				contents: contents
				color: aColor! !

!NautilusUI methodsFor: 'displaying' stamp: 'CamilloBruni 9/14/2012 00:56'!
open
	| focus |
	super open.
	window takeKeyboardFocus.
	focus := list.
	self selectedClass ifNotNil: [ focus := list2 ].
	self selectedCategory ifNotNil: [:cat |  
		categoryWidget selectProtocol: cat.
		methodWidget resetMethodCache.
		methodWidget update: #getMethodItem:.
		focus := categoryWidget ].
	self selectedMethod ifNotNil: [:meth | 
		methodWidget selectMethod: meth.
		focus := methodWidget ].
	self giveFocusTo: focus.
	! !

!NautilusUI methodsFor: 'history behavior' stamp: 'CamilloBruni 10/4/2012 11:33'!
previous
	self model hasPrevious 
		ifFalse: [ ^ self ].
	"show the previous item in the history"
	self model previous! !

!NautilusUI methodsFor: 'private' stamp: ''!
previousButtonState
	^ true! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
removeAllFromMethodsIconsCache: aMethod

	methodWidget removeAllFromMethodsIconsCache: aMethod! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
removeCategories

	self selectedClass 
		ifNotNil: [:class |
			self selectedCategories
				ifNotEmpty: [:items || removeACategory scroll |
					scroll := categoryWidget vScrollValue.
					removeACategory := false.
					items do: [:item || needToUpdate |
						needToUpdate := self removeCategory: item inClass: class.
						(needToUpdate and: [ removeACategory not ]) ifTrue: [ removeACategory := true].
						needToUpdate ifTrue: [ self update ]].

					removeACategory ifTrue: [ self selectedCategory: nil ].
					self update.
					categoryWidget vScrollValue: scroll. ]]! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
removeMethod: aMethod inClass: aClass
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "
	
	self okToChange ifFalse: [^ false].
	^ super removeMethod: aMethod inClass: aClass! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/14/2012 12:18'!
removeMethods

	self selectedClass 
		ifNotNil: [:class |
			self selectedMethods
				ifNotEmpty: [:items || scroll needToUpdate selectedMethodStillExists |
					scroll := methodWidget vScrollValue.
					needToUpdate := self removeMethods: items inClass: class.
					
					needToUpdate ifTrue: [ 
						self resetMethodsListSelection.
						methodWidget updateList ].
					
					(class methodDict values includes: self selectedMethod)
						ifFalse: [ self selectedMethod: nil ].
						
					self resetMethodsListSelection.
					methodWidget
						updateList;
						vScrollValue: scroll. ]]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'EstebanLorenzano 8/3/2012 15:16'!
removeNonLocalSelector: aSymbol
	| traits isAlias |
	traits := self selectedClassOrMetaClass traitsProvidingSelector: aSymbol.
	isAlias := self selectedClassOrMetaClass isLocalAliasSelector: aSymbol.
	isAlias
		ifTrue: [
			[traits size = 1] assert.
			self selectedClassOrMetaClass removeAlias: aSymbol of: traits first]
		ifFalse: [
			traits do: [:each |
				self selectedClassOrMetaClass addExclusionOf: aSymbol to: each ]]
	! !

!NautilusUI methodsFor: 'menus behavior' stamp: ''!
renameCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"

	| category newName vScroll |
	self okToChange ifFalse: [^ self].
	category := self selectedCategory.
	vScroll := categoryWidget vScrollValue.
	newName := self renameCategory: category from: self selectedClass.
	newName ifNil: [ ^ self ].
	categoryWidget deselectProtocol: category.
	self selectedCategory: newName.
	categoryWidget selectProtocol: newName.
	self update.
	categoryWidget vScrollValue: vScroll! !

!NautilusUI methodsFor: 'tests' stamp: ''!
resetCategoriesListSelection

	categoryWidget resetCategoriesListSelection! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 4/17/2012 15:05'!
resetMethodsListSelection

	methodWidget resetMethodsListSelection! !

!NautilusUI methodsFor: 'widget - method' stamp: ''!
resetSelections

	self resetListSelection.
	self resetListSelection2.
	self resetCategoriesListSelection.
	self resetMethodsListSelection.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/5/2012 23:53'!
runTestForAMethod: aMethod notifying: aBoolean
	
	self runTestForAMethod: aMethod notifying: aBoolean priority: Processor userBackgroundPriority! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 7/21/2012 16:00'!
runTestForAMethod: aMethod notifying: aBoolean priority: aPriority
	| testMethod testSemaphoreForMethod blockToEvaluate shouldAnnounce |
	
	testMethod := aMethod correspondingTestMethod.
	testSemaphoreForMethod := Semaphore new. 
	shouldAnnounce := aBoolean.
	testMethod ifNil: [ ^ self ].

	blockToEvaluate := [
		| vScroll testClass testResult |
		vScroll := methodWidget vScrollValue.
		
		testClass := testMethod methodClass.
		testResult := [ testClass run: testMethod selector ]
							on: Halt
							do: [ :e | 
								aBoolean
									ifTrue: [ 
										[ self runTestForAMethodWithAnHalt: aMethod ] fork.
										shouldAnnounce := false.
										TestAsserter classForTestResult new ]
									ifFalse: [
										TestAsserter classForTestResult new
											addFailure: (testClass selector: testMethod selector);
											yourself ]].
		testResult updateResultsInHistory.
		
		testSemaphoreForMethod signal.
						
		(aBoolean and: [testResult failures isEmpty not or: [ testResult errors isEmpty not ]])
			ifTrue: [ 
				testClass debug: testMethod selector ].
				
		ClassesIconsCache removeKey: aMethod methodClass ifAbsent: []. 
		WorldState addDeferredUIMessage: [ methodWidget vScrollValue: vScroll ]].
	
	aBoolean 
		ifTrue: [ blockToEvaluate forkAt: aPriority. ]
		ifFalse: [ blockToEvaluate value ].
	
	testSemaphoreForMethod wait.
	
	shouldAnnounce
		ifTrue: [| color |
			testMethod hasPassedTest ifTrue: [ color :=  Color green ].
			testMethod hasFailedTest ifTrue: [ color :=  Color yellow ].
			testMethod hasErrorTest ifTrue: [ color :=  Color red ].
			self
				notifyTitle: 'Test Finished' 
				contents: 'Method: ',testMethod methodClass asString, '>>#',testMethod selector asString
				color: color ].
	aBoolean ifFalse: [ testSemaphore signal ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/6/2012 00:00'!
runTestForAMethodWithAnHalt: aMethod
	| testMethod blockToEvaluate color vScroll testClass testResult  |
	
	testMethod := aMethod correspondingTestMethod.
	testMethod ifNil: [ ^ self ].

	vScroll := methodWidget vScrollValue.
	
	testClass := testMethod methodClass.
	testResult := testClass run: testMethod selector.
	testResult updateResultsInHistory.
		
	(testResult failures isEmpty not or: [ testResult errors isEmpty not ])
		ifTrue: [ 
			testClass debug: testMethod selector ].
	ClassesIconsCache removeKey: aMethod methodClass ifAbsent: []. 
	WorldState addDeferredUIMessage: [ methodWidget vScrollValue: vScroll ].
	
	aMethod hasPassedTest ifTrue: [ color :=  Color green ].
	aMethod hasFailedTest ifTrue: [ color :=  Color yellow ].
	aMethod hasErrorTest ifTrue: [ color :=  Color red ].

	self
		notifyTitle: 'Test Finished' 
		contents: 'Method: ',testMethod methodClass asString, '>>#',testMethod selector asString
		color: color! !

!NautilusUI methodsFor: 'tests' stamp: ''!
selectedCategories

	^ categoryWidget selectedCategories! !

!NautilusUI methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 4/17/2012 14:59'!
selectedCategory

	^ (self model 
			ifNil: [ ^ nil ]) selectedCategory! !

!NautilusUI methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
selectedCategory: anObject

	self okToChange
		ifTrue: [
			methodWidget resetMethodCache.
			self model package: self selectedPackage class: self selectedClass category: anObject method: nil.
			self resetMethodsListSelection.
			anObject ifNotNil: [ self giveFocusTo: categoryWidget ].
			categoryWidget changed: #selectedCategoryIndex.
			self changed: #sourceCodeFrom:.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
selectedCategoryInternally: anObject

	self okToChange
		ifTrue: [
			self resetMethodsListSelection.
			anObject ifNotNil: [ self giveFocusTo: categoryWidget ].
			self changed: #sourceCodeFrom:.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/25/2013 18:16'!
selectedClassWithoutChangingSelection: aClass 
	categoryWidget resetCategoryCache.
	commentTextArea ifNotNil: [
				aClass 
					ifNil: [ commentTextArea disable ]
					ifNotNil: [ commentTextArea enable ]].
	self okToChangeBoth
		ifTrue: [| package packageChanged cl |
			package := self selectedPackage.
			(self showPackages not or: [self showGroups ])
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			aClass 
				ifNil: [ classesSelection removeAll ].
			packageChanged := (package ~= self selectedPackage).
			self model package: package class: aClass category: nil method: nil.
			cl := aClass.
			cl ifNotNil: [ cl := cl theNonMetaClass ].
			classesSelection at: cl put: true.
			self changed: #toggleButtonEnabled.
			self setWindowTitle.
			
			packageChanged ifTrue: [
				packagesSelection removeAll.
				packagesSelection at: package put: true.
				self showGroups
					ifTrue: [ self updateClassView ]
					ifFalse: [ self updateBothView ]].

			self resetCategoriesListSelection.
			self resetMethodsListSelection.
			self update.
			self changed: #isAClassSelected.
			self changed: #getComments.
			self changed: #instanceButtonLabel.
			self changed: #sourceCodeFrom:]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
selectedClassWithoutChangingSelectionInternally: aClass 

	self okToChange
		ifTrue: [| package packageChanged |
			package := self selectedPackage.
			(self showPackages not or: [self showGroups ])
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			aClass 
				ifNil: [ classesSelection removeAll ].

			aClass ifNotNil: [ self giveFocusTo: list2 ].	
				
			packageChanged := (package ~= self selectedPackage).
			classesSelection at: aClass put: true.
			self setWindowTitle.
			
			packageChanged ifTrue: [
				packagesSelection removeAll.
				packagesSelection at: package put: true.
				self showGroups
					ifTrue: [ self updateClassView ]
					ifFalse: [ self updateBothView ]].
				
			self resetCategoriesListSelection.
			self resetMethodsListSelection.
			self update.
			self changed: #isAClassSelected.
			self changed: #getComments.
			self changed: #sourceCodeFrom:]! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
selectedMethod

	^ self model selectedMethod ! !

!NautilusUI methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 8/6/2012 19:41'!
selectedMethod: aMethod 

	self okToChange
		ifTrue: [
			self forceSelectedMethod: aMethod.
			self setWindowTitle.
			self highlightCategory: aMethod.
			aMethod ifNotNil: [ self giveFocusTo: methodWidget ].
			self changed: #sourceCodeFrom:.
			multipleMethodsEditor giveFocusToDefault.
			^ true].
	^false ! !

!NautilusUI methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 8/3/2012 18:07'!
selectedMethodWithoutAsking: aMethod 

	self okToChange
		ifTrue: [
			self forceSelectedMethod: aMethod.
			self setWindowTitle.
			self highlightCategory: aMethod.
			aMethod ifNotNil: [ self giveFocusTo: methodWidget ].
			self changed: #sourceCodeFrom:.
			^ true].
	^false ! !

!NautilusUI methodsFor: 'widget - category' stamp: ''!
selectedMethods

	^ methodWidget selectedMethods! !

!NautilusUI methodsFor: 'history behavior' stamp: 'CamilloBruni 10/4/2012 10:49'!
setHistory: anIndex

	| entry |
	
	entry := self getHistoryList at: anIndex ifAbsent: [ nil ].
	entry ifNil: [ ^ self ].
	self model adopt: entry.
	
	self changed: #currentHistoryIndex.! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 4/18/2012 19:04'!
signatureFor: aSelector

	^ (aSelector includes: $:)
		ifTrue: [ | col |
			col := aSelector subStrings: ':'.
			String streamContents: [:s |
					col doWithIndex: [:e :i |
						i == 1 
							ifTrue: [ s << e << $: << ' anObject ' ]
							ifFalse: [ s << e << $: << ' anObject'<< (i-1) printString << ' ' ]]]]
		ifFalse: [ aSelector ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/24/2013 11:41'!
toggleBreakPoint
	
	self selectedMethod 
		ifNotNil: [:meth | 
			self toggleBreakOnEntryIn: meth.
			self update ].
		! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/20/2012 12:26'!
toggleShowInstance

	self showInstance: self showInstance not.
	self changed: #instanceButtonState.
	categoryWidget label: self categoriesLabel.
	methodWidget label: self methodsLabel.! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 5/14/2012 12:18'!
update

	categoryWidget resetCategoryCache.
	methodWidget 
		resetMethodCache;
		updateList.
	self changed: #getCategoryItem:.! !

!NautilusUI methodsFor: 'history behavior' stamp: 'CamilloBruni 10/4/2012 10:43'!
wrapHistory: anEntry
	| wrapper label separator |
	separator := ' >>#'.
	wrapper := anEntry key.
	wrapper showGroups
		ifTrue: [
			label := Text streamContents: [:s | 
				wrapper selectedGroup ifNotNil: [:g |
					s 
						<< ('G: ' asText addAttribute: TextEmphasis italic from: 1 to: 3) 
						<< (g name asText addAttribute: TextEmphasis italic from: 1 to: g name size).
				wrapper selectedClass ifNotNil: [:c | 
					s << separator << c name.
					wrapper selectedMethod ifNotNil: [:m | 
						s << separator << m asString ]]]]]
		ifFalse: [
			label := String streamContents: [:s | 
				wrapper selectedPackage ifNotNil: [:p |
					wrapper selectedClass ifNotNil: [:c | 
						s << c name.
						wrapper selectedMethod ifNotNil: [:m | 
							s << separator << m asString ]]]]].

	^ GoBackStringMorph contents: label! !

MorphTreeMorph subclass: #IdentityMorphTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MorphTreeWidget-Extension'!

!IdentityMorphTreeMorph commentStamp: '<historical>' prior: 0!
An IdentityMorphTreeMorph is a MorphTreeMorph which always check for identity between items
!

!IdentityMorphTreeMorph methodsFor: 'expanding-collapsing' stamp: ''!
expandedFormForMorph: aMorph
	"Answer the form to use for expanded items."
	
	^ ((self selectedMorphList identityIncludes: aMorph) and: [self theme selectionColor luminance < 0.6])
		ifTrue: [self theme whiteTreeExpandedForm]
		ifFalse: [self theme treeExpandedForm]! !

!IdentityMorphTreeMorph methodsFor: 'accessing' stamp: ''!
listManager: aManager

	listManager := aManager! !

!IdentityMorphTreeMorph methodsFor: 'expanding-collapsing' stamp: ''!
notExpandedFormForMorph: aMorph

	^ ((self selectedMorphList identityIncludes: aMorph) and: [self theme selectionColor luminance < 0.6])
		ifTrue: [self theme whiteTreeUnexpandedForm]
		ifFalse: [self theme treeUnexpandedForm]! !

!MCPackage methodsFor: '*Nautilus' stamp: ''!
isDirty
	| modifiedPackages  |
	
	modifiedPackages := MCWorkingCopy allManagers select: [ :each | each modified ].
	^ modifiedPackages anySatisfy: [:wc | wc package = self ]! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 12/20/2012 15:06'!
createPackageNamed: aString

	| instance |
	(packages includesKey: aString asSymbol) ifTrue: [ 
			self openAlreadyExistingError.
			^ nil ].
	
	instance := self packageClass named: aString.
	self registerPackage: instance.
	^ instance! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: ''!
openAlreadyExistingError

	StandardWindow new alert: 'A package with this name already exists' title: 'Already exists'! !

!Magnitude class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:07'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #magnitude! !

!Collection class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:07'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #collection! !

!RPackage methodsFor: '*Nautilus' stamp: ''!
<= aRPackage 

	^ self name <= aRPackage name! !

!RPackage methodsFor: '*Nautilus' stamp: ''!
classesOfExtensionMethods

	^ self extendedClasses! !

!RPackage methodsFor: '*Nautilus' stamp: 'SeanDeNigris 6/18/2012 16:16'!
fileOut

	SystemOrganization fileOutCategory: self name.! !

!RPackage methodsFor: '*Nautilus' stamp: ''!
orderedClasses

	| tmp |
	tmp := self definedClasses asArray sort: [:a :b | a name <= b name].
	tmp := tmp, (self extendedClasses asArray sort: [:a :b | a name <= b name]).
	^tmp collect: [:e | e theNonMetaClass ]
! !

!PragmaMenuAndShortcutRegistration methodsFor: '*Nautilus' stamp: 'EstebanLorenzano 2/6/2013 14:35'!
keyText: aString if: aBoolean
	aBoolean ifTrue: [ 
		self keyText: aString ]! !

!Exception class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:07'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #exception! !

MorphTreeListManager subclass: #IdentityMorphTreeListManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MorphTreeWidget-Extension'!

!IdentityMorphTreeListManager commentStamp: '<historical>' prior: 0!
An IdentityMorphTreeListManager is a MorphTreeListManager which always check for identity between items
!

!IdentityMorphTreeListManager methodsFor: 'accessing' stamp: ''!
nodeMorphsWithAllNodeItems: aNodeItemList

	^ self allNodeMorphs select: [:m | aNodeItemList identityIncludes: m complexContents withoutListWrapper]! !

TestCase subclass: #AbstractNautilusUITest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Tests'!

!AbstractNautilusUITest commentStamp: '<historical>' prior: 0!
An AbstractNautilusUITest is a test class for testing the behavior of AbstractNautilusUI!

!AbstractNautilusUITest methodsFor: 'initialization' stamp: ''!
setUp
	"Setting up code for AbstractNautilusUITest"

	model := AbstractNautilusUI new.! !

!AbstractNautilusUITest methodsFor: 'initialization' stamp: ''!
tearDown
	"Tearing down code for AbstractNautilusUITest"

! !

!AbstractNautilusUITest methodsFor: 'tests' stamp: ''!
testSortClassesInCachedHierarchyB! !

TestCase subclass: #NautilusTest
	instanceVariableNames: 'nautilus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Tests'!

!NautilusTest commentStamp: '<historical>' prior: 0!
A NautilusTest is a test class for testing the behavior of Nautilus!

!NautilusTest methodsFor: 'running' stamp: ''!
setUp

	nautilus := Nautilus new.! !

!NautilusTest methodsFor: 'running' stamp: ''!
tearDown

	nautilus := nil.! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/16/2013 15:06'!
testCorrespondingMethods

	self assert: ((Dictionary>>#associations) == (DictionaryTest>>#testAssociations) correspondingMethods first).
	self assert: ((Dictionary>>#add:) == (DictionaryTest>>#testAdd) correspondingMethods first).
	self assert: ((Dictionary>>#at:put:) == (DictionaryTest>>#testAtPut) correspondingMethods first).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/16/2013 15:22'!
testCorrespondingTestClass
	self assert: (Behavior correspondingForTest == BehaviorTest).
	self assert: (BehaviorTest correspondingForTest == Behavior).! !

!NautilusTest methodsFor: 'tests' stamp: ''!
testCorrespondingTestMethod

	self assert: ((Dictionary>>#associations) correspondingTestMethod == (DictionaryTest>>#testAssociations)).
	self assert: ((Dictionary>>#add:) correspondingTestMethod == (DictionaryTest>>#testAdd)).
	self assert: ((Dictionary>>#at:put:) correspondingTestMethod == (DictionaryTest>>#testAtPut)).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/16/2013 15:24'!
testSelectedCategory

	self assert: nautilus selectedMethod isNil.
	nautilus selectedMethod: (Object>>#at:).
	nautilus selectedCategory: 'test'.
	self assert: (nautilus selectedCategory = 'test').
	self assert: (nautilus selectedMethod isNil).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 4/20/2012 00:17'!
testSelectedClass

	self assert: nautilus selectedMethod isNil.
	nautilus selectedMethod: (Object>>#at:).
	nautilus selectedCategory: 'test'.
	self assert: (nautilus selectedCategory = 'test').
	self assert: (nautilus selectedMethod isNil).
	
	nautilus selectedClass: Morph.
	self assert: (nautilus selectedClass = Morph).
	self assert: (nautilus selectedCategory isNil).
	self assert: (nautilus selectedMethod isNil).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 4/19/2012 23:47'!
testSelectedMethod

	self assert: nautilus selectedMethod isNil.
	nautilus selectedMethod: (Object>>#at:).
	self assert: (nautilus selectedMethod = (Object>>#at:))! !

TestCase subclass: #NautilusUITest
	instanceVariableNames: 'nautilusUI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Tests'!

!NautilusUITest commentStamp: '<historical>' prior: 0!
A NautilusUITest is a test class for testing the behavior of NautilusUI!

!NautilusUITest methodsFor: 'initialization' stamp: ''!
setUp
	"Setting up code for NautilusUITest"


	nautilusUI := NautilusUI on: Nautilus new.! !

!NautilusUITest methodsFor: 'initialization' stamp: ''!
tearDown
	"Tearing down code for NautilusUITest"


	nautilusUI := nil.! !

!NautilusUITest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/16/2013 14:54'!
testBuildTestSelectorFor

	| method selector |
	method := MorphicEventHandler >> #keyStroke:fromMorph:.
	selector := nautilusUI buildTestSelectorFor: method.
	self assert: selector equals: 'testKeyStrokeFromMorph'! !

Object subclass: #AbstractMethodIconAction
	instanceVariableNames: 'method browser icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractMethodIconAction commentStamp: '<historical>' prior: 0!
AbstractMethodIconAction is the common super class for all the method icon actions.

A method icon action is used to retrieve the correct icon the method in nautilus lists!

!AbstractMethodIconAction class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/2/2013 12:34'!
for: aMethod in: aBrowser

	^ self new
		method: aMethod;
		browser: aBrowser;
		yourself! !

!AbstractMethodIconAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:50'!
actionIcon
	"Return the icon for this action"
	
	^ icon := self privateActionIcon! !

!AbstractMethodIconAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:24'!
actionOrder
	"Return the priority of this action"
	
	^ self subclassResponsibility! !

!AbstractMethodIconAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:53'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	
	^ IconicButtonStateHolder forNautilus: icon! !

!AbstractMethodIconAction methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/2/2013 12:33'!
browser

	^ browser! !

!AbstractMethodIconAction methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/2/2013 12:33'!
browser: aBrowser

	browser := aBrowser! !

!AbstractMethodIconAction methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 1/2/2013 12:18'!
iconClass

	^ NautilusIcons! !

!AbstractMethodIconAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:41'!
isActionHandled
	"Return true if the provided method fits this action requirement"
	
	^ self subclassResponsibility! !

!AbstractMethodIconAction methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/2/2013 12:34'!
method

	^ method! !

!AbstractMethodIconAction methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/2/2013 12:16'!
method: aMethod

	method := aMethod! !

!AbstractMethodIconAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:50'!
privateActionIcon
	
	^ self subclassResponsibility! !

AbstractMethodIconAction subclass: #MethodContainsBreakpointAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodContainsBreakpointAction commentStamp: '<historical>' prior: 0!
A MethodContainsBreakpointAction is the action corresponding to the fact that the method contains a breakpoint!

!MethodContainsBreakpointAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:56'!
actionOrder
	"Return the priority of this action"

	^ 400! !

!MethodContainsBreakpointAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/24/2013 11:01'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	
	^ icon! !

!MethodContainsBreakpointAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/24/2013 11:02'!
isActionHandled
	"Return true if the provided method fits this action requirement"

	^ method hasBreakpoint! !

!MethodContainsBreakpointAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/24/2013 11:04'!
privateActionIcon
	"Return the icon for this action"

	^ self iconClass iconNamed: #breakpoint! !

AbstractMethodIconAction subclass: #MethodContainsFlagsAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodContainsFlagsAction commentStamp: '<historical>' prior: 0!
Action when the method contains a flag!

!MethodContainsFlagsAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/24/2013 11:03'!
actionOrder
	"Return the priority of this action"

	^ 300! !

!MethodContainsFlagsAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:52'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	
	^ icon! !

!MethodContainsFlagsAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:41'!
isActionHandled
	"Return true if the provided method fits this action requirement"

	^ method containsFlag! !

!MethodContainsFlagsAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:49'!
privateActionIcon
	"Return the icon for this action"

	^ self iconClass iconNamed: #flag! !

AbstractMethodIconAction subclass: #MethodContainsHaltAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodContainsHaltAction commentStamp: '<historical>' prior: 0!
Action when the method contains a halt!

!MethodContainsHaltAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 100! !

!MethodContainsHaltAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:52'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	
	^ icon! !

!MethodContainsHaltAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:41'!
isActionHandled

	^ method containsHalt! !

!MethodContainsHaltAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/24/2013 11:37'!
privateActionIcon
	"Return the icon for this action"

	^ self iconClass iconNamed: #haltIcon! !

AbstractMethodIconAction subclass: #MethodDefaultAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodDefaultAction commentStamp: '<historical>' prior: 0!
Action by default, empty icon!

!MethodDefaultAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 9999999999999999999999999999! !

!MethodDefaultAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 13:04'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	
	^ icon! !

!MethodDefaultAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 13:04'!
isActionHandled
	"Return true if the provided method fits this action requirement"

	^ true! !

!MethodDefaultAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 13:04'!
privateActionIcon
	"Return the icon for this action"

	^ self iconClass iconNamed: #blank! !

AbstractMethodIconAction subclass: #MethodFromTraitAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodFromTraitAction commentStamp: '<historical>' prior: 0!
Action when the method comes from a trait!

!MethodFromTraitAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 200! !

!MethodFromTraitAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:41'!
isActionHandled

	^ method isFromTrait! !

!MethodFromTraitAction methodsFor: 'order' stamp: 'EstebanLorenzano 1/15/2013 18:19'!
privateActionIcon
	"Return the icon for this action"

	^ IconicButton new 
			target: method originMethod;
			actionSelector: #browse;
			labelGraphic: (self iconClass iconNamed: #trait) ;
			color: Color transparent;
			extent: 12 @ 12;
			helpText: 'Browse the trait';
			borderWidth: 0! !

AbstractMethodIconAction subclass: #MethodIsAbstractAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodIsAbstractAction commentStamp: '<historical>' prior: 0!
Action when the method is abstract!

!MethodIsAbstractAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 700! !

!MethodIsAbstractAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:59'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	
	^ icon! !

!MethodIsAbstractAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:58'!
isActionHandled

	^ method isAbstract! !

!MethodIsAbstractAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/14/2013 08:21'!
privateActionIcon
	"Return the icon for this action"
	
	^ self iconClass iconNamed: #abstract! !

AbstractMethodIconAction subclass: #MethodIsTestAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodIsTestAction commentStamp: '<historical>' prior: 0!
Aciton when the method is a test!

!MethodIsTestAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 0! !

!MethodIsTestAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:41'!
isActionHandled

	^ method isTestMethod! !

!MethodIsTestAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:57'!
privateActionIcon
	"Return the icon for this action"
	| testIcon |
	
	testIcon := self iconClass iconNamed: #testNotRun.
	
	method hasPassedTest
		ifTrue: [ testIcon := self iconClass iconNamed: #testGreen ].
	method hasFailedTest
		ifTrue: [ testIcon := self iconClass iconNamed: #testYellow ].
	method hasErrorTest
		ifTrue: [ testIcon := self iconClass iconNamed: #testRed ].
	
	^ IconicButton new
		target: self browser;
		actionSelector: #runTestForAMethod:notifying:;
		arguments: {method. true};
		labelGraphic: testIcon;
		color: Color transparent;
		helpText: 'Run the test';
		extent: 12 @ 12;
		borderWidth: 0! !

AbstractMethodIconAction subclass: #MethodOveridesAction
	instanceVariableNames: 'isOverridden isOverride result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodOveridesAction commentStamp: '<historical>' prior: 0!
Action when the method overrides another one, or the method is overidden by another one or both!

!MethodOveridesAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 600! !

!MethodOveridesAction methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/2/2013 12:58'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	^ result 
		ifNil: [ super actionStateToCache ]
		ifNotNil: [ {(IconicButtonStateHolder forNautilus: result value first). (IconicButtonStateHolder forNautilus: result value second)} ]! !

!MethodOveridesAction methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/2/2013 13:08'!
buildUpAndDownArrowIcon: aMethod

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := IconicButton new 
				target: self browser;
				actionSelector: #arrowUp:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleUp);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriden message';
				borderWidth: 0.
				
	down :=  IconicButton new 
				target: self browser;
				actionSelector: #arrowDown:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleDown);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriding messages';
				borderWidth: 0.
				
	^ (container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself) -> {up. down}.! !

!MethodOveridesAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 13:07'!
isActionHandled

	isOverridden := method isOverridden.
	isOverride := method isOverride.
	^ isOverridden or: [ isOverride ]! !

!MethodOveridesAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 13:06'!
privateActionIcon
	"Return the icon for this action"

	| testMethod |
	isOverride
		ifTrue: [ 
			isOverridden
				ifTrue: [
					result := self buildUpAndDownArrowIcon: method.
					^ result key ]
				ifFalse: [ 
					^ IconicButton new
						target: self browser;
						actionSelector: #arrowUp:;
						arguments: {method};
						labelGraphic: (self iconClass iconNamed: #arrowUp);
						color: Color transparent;
						helpText: 'Browse overriden message';
						extent: 12 @ 12;
						borderWidth: 0 ] ]
		ifFalse: [ 
			isOverridden
				ifTrue: [ 
					^ IconicButton new
						target: self browser;
						actionSelector: #arrowDown:;
						arguments: {method};
						labelGraphic: (self iconClass iconNamed: #arrowDown);
						color: Color transparent;
						helpText: 'Browse overriding messages';
						extent: 12 @ 12;
						borderWidth: 0 ] ]! !

AbstractMethodIconAction subclass: #MethodWithCorrespondingTestAction
	instanceVariableNames: 'testMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodWithCorrespondingTestAction commentStamp: '<historical>' prior: 0!
Action when the method has a corresponding test method!

!MethodWithCorrespondingTestAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 2/20/2013 19:57'!
actionOrder
	"Return the priority of this action"
	
	^ 500! !

!MethodWithCorrespondingTestAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:41'!
isActionHandled

	^ (testMethod := method correspondingTestMethod) notNil! !

!MethodWithCorrespondingTestAction methodsFor: 'order' stamp: 'BenjaminVanRyseghem 1/2/2013 12:57'!
privateActionIcon
	"Return the icon for this action"
	| testIcon |
	
	testIcon := self iconClass iconNamed: #testNotRun.
	
	testMethod hasPassedTest
		ifTrue: [ testIcon := self iconClass iconNamed: #testGreen ].
	testMethod hasFailedTest
		ifTrue: [ testIcon := self iconClass iconNamed: #testYellow ].
	testMethod hasErrorTest
		ifTrue: [ testIcon := self iconClass iconNamed: #testRed ].
	
	^ IconicButton new
		target: self browser;
		actionSelector: #runTestForAMethod:notifying:;
		arguments:  { method. true};
		labelGraphic: testIcon;
		color: Color transparent;
		extent: 12 @ 12;
		helpText: 'Run the test';
		borderWidth: 0! !

Object subclass: #HistoryCollection
	instanceVariableNames: 'storage maxSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-History'!

!HistoryCollection commentStamp: 'BenjaminVanRyseghem 3/17/2011 13:41' prior: 0!
I'm a data structure used to store an history.

My behavior is
	- I store Associations (anElement -> anInteger), where anElement is the element to store and anInteger the number of times it has been added. (as a Dictionary)
	- I only store once each element (as a Set).
	- I have a max size. If I add an element and have reached the max size, I remove the less seen element.
	- I store element in the chronological order (as an OrderedCollection)!

!HistoryCollection class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 13:47'!
maxSize: anInteger

	^ self new maxSize: anInteger! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:37'!
add: anElement

	| count |
	count := 0.
	(self includes: anElement)
		ifTrue: [ | association |
			association := self remove: anElement.
			count := association value ].
	self size = self maxSize
		ifTrue: [	self removeLast ].

	^ storage addFirst: (anElement -> (count+1))! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:43'!
at: anElement

	^ storage detect: [:each | each key = anElement]! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:33'!
elements
	
	^ storage collect: [:each | each key ]! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:38'!
identityIncludes: anElement

	^ storage anySatisfy: [:association | association key == anElement ]! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:37'!
includes: anElement

	^ storage anySatisfy: [:association | association key = anElement ]! !

!HistoryCollection methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 13:47'!
initialize

	super initialize.
	maxSize := 5.
	storage := OrderedCollection new: maxSize.! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 14:00'!
lessSeen

	| min |
	min := storage first.
	2 to: storage size do: [:index || each |
		each := storage at: index.
		(each value < min value)
			ifTrue: [ min := each]].
	^ min key! !

!HistoryCollection methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 13:31'!
maxSize

	^ maxSize! !

!HistoryCollection methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 13:32'!
maxSize: anInteger

	maxSize := anInteger! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 14:05'!
mostSeen

	| max |
	max := storage first.
	2 to: storage size do: [:index || each |
		each := storage at: index.
		(each value > max value)
			ifTrue: [ max := each]].
	^ max key! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 9/14/2012 15:48'!
mostViewedElements
	
	^ (storage copy sort: [:a :b | a value >= b value]) collect: [:each | each key ]! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 14:03'!
oldest

	^ storage last key! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:49'!
remove: anElement

	| association |
	association := self at: anElement.
	^ storage remove: association.
	! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:54'!
removeLast
	" I remove the less seen one, in case of equality, I remove the latest one "


	| min reversedStorage |
	reversedStorage := storage reverse.
	min := reversedStorage first.
	2 to: storage size do: [:index || each |
		each := reversedStorage at: index.
		(each value < min value)
			ifTrue: [ min := each ]].
	storage remove: min! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 13:49'!
size

	^ storage size! !

!HistoryCollection methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/17/2011 14:03'!
youngest

	^ storage first key! !

Object subclass: #Nautilus
	instanceVariableNames: 'announcer browsedEnvironment browsingHistory plugins selectedCategory selectedClass selectedGroup selectedMethod selectedPackage showCategories showComment showGroups showHierarchy showInstance showPackages ui uiClass'
	classVariableNames: 'CommentPosition HistoryMaxSize OpenOnGroups PluginClasses RecentClasses ShowAnnotationPane ShowHierarchy SwitchClassesAndPackages WarningLimit'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'populateMethodList emptyCommentWarning groups cachedLastClasses maxSize useOldStyleKeys'!

!Nautilus commentStamp: '<historical>' prior: 0!
I'm a new browser based on RPackage and Announcements with fancy goodies:

	- groups ( you can create groups with your favorite classes)
	- multi-selections
	- environments
	- iconic buttons
	- hierarchy
	- pragma based menus!

Nautilus class
	instanceVariableNames: 'populateMethodList emptyCommentWarning groups cachedLastClasses maxSize useOldStyleKeys'!

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/14/2012 12:09'!
addGroupForClasses: aCollection named: aName

	self groupsManager addADynamicClassGroupSilentlyNamed: aName name block: [ aCollection ].! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/14/2012 12:09'!
addGroupForPackage: aPackage

	self groupsManager addADynamicClassGroupSilentlyNamed: aPackage name block: [ aPackage orderedClasses ].! !

!Nautilus class methodsFor: 'instance creation' stamp: ''!
browsedEnvironment: anEnvironment

	^ self new browsedEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/14/2012 15:49'!
buildGroupManagerFor: anInstance

	| holder |
	holder := GroupsHolder new.
	(holder 
		addADynamicClassGroupSilentlyNamed: 'Most Viewed Classes' 
		block: [ anInstance recentClassesElements ]) removable: false.
	(holder
		addADynamicClassGroupSilentlyNamed: 'Last Modified Classes'
		block: [ self lastModifiedClasses ]) removable: false.
		
	(holder
		addADynamicGroupSilentlyNamed: 'Work'
		block: [ {} ]) removable: true; isFillable: true.
		
	^ holder
			! !

!Nautilus class methodsFor: 'settings' stamp: ''!
commentPosition

	^ CommentPosition ifNil: [ self defaultCommentPosition ]! !

!Nautilus class methodsFor: 'settings' stamp: ''!
commentPosition: aSymbol

	(self commentPositions includes: aSymbol) ifFalse: [ ^ self ].
	CommentPosition := aSymbol! !

!Nautilus class methodsFor: 'settings' stamp: ''!
commentPositions

	^ { #right. #bottom. #left. #top }! !

!Nautilus class methodsFor: 'private' stamp: ''!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!Nautilus class methodsFor: 'private' stamp: ''!
defaultBrowsedEnvironment

	^ RBBrowserEnvironment new! !

!Nautilus class methodsFor: 'private' stamp: ''!
defaultCommentPosition

	^ #right! !

!Nautilus class methodsFor: 'private' stamp: ''!
defaultMaxSize

	^ NavigationHistory defaultMaxSize! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/5/2013 14:35'!
defaultPopulateMethodList

	^ false! !

!Nautilus class methodsFor: 'settings' stamp: 'EstebanLorenzano 2/4/2013 17:47'!
emptyCommentWarning
	^emptyCommentWarning ifNil: [ emptyCommentWarning := true ]! !

!Nautilus class methodsFor: 'settings' stamp: 'EstebanLorenzano 2/4/2013 17:53'!
emptyCommentWarning:aBoolean
	emptyCommentWarning := aBoolean.
	AbstractNautilusUI resetClassesIconsCache! !

!Nautilus class methodsFor: 'browser compatibility' stamp: ''!
fullOnClass: aClass 

	^ self openOnClass: aClass! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 5/13/2012 20:10'!
fullOnClass: aClass selector: aSelector 

	^ aSelector
		ifNil: [ self openOnClass: aClass ]
		ifNotNil: [| method |
			method := aClass methodDict at: aSelector ifAbsent: [ nil ].
			method ifNotNil: [ self openOnMethod: method ]]! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 2/15/2013 01:47'!
fullOnClass: class 	selector: selector highlight: autoSelectString
	| nautilus |
	
	nautilus := self fullOnClass: class selector: selector.
	autoSelectString ifNotNil: [ nautilus ui highlight: autoSelectString ]! !

!Nautilus class methodsFor: 'browser compatibility' stamp: ''!
fullOnEnvironment: anEnvironment

	self openInEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
groupsManager

	^ groups ifNil: [ groups := self buildGroupManager]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/14/2012 15:46'!
groupsManagerFrom: anInstance

	^ groups ifNil: [ groups := self buildGroupManagerFor: anInstance]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
historyMaxSize

	^ HistoryMaxSize ifNil: [ HistoryMaxSize := self defaultMaxSize ]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
historyMaxSize: anInteger

	(anInteger isKindOf: Integer) ifFalse: [ ^ self ].
	anInteger > 0 ifFalse: [ ^ self ].
	HistoryMaxSize := anInteger! !

!Nautilus class methodsFor: 'icon' stamp: ''!
icon 

	^ AbstractNautilusUI icon! !

!Nautilus class methodsFor: 'groups' stamp: ''!
importAGroup: aGroup

	self groupsManager addAGroup: aGroup! !

!Nautilus class methodsFor: 'class initialization' stamp: 'BenjaminVanRyseghem 9/15/2012 21:34'!
initialize

	SystemBrowser default: self! !

!Nautilus class methodsFor: 'groups' stamp: ''!
lastModifiedClasses

	^ cachedLastClasses ifNil: [ cachedLastClasses := RecentMessageList uniqueInstance lastClasses: 10 ]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'settings' stamp: 'EstebanLorenzano 2/6/2013 14:31'!
nautilusSettingsOn: aBuilder
	<systemsettings>
	
	(aBuilder group: #Nautilus)
		target: self;
		label: 'Nautilus' translated;
		description: 'Settings related to the browser' translated;
		with: [
			(aBuilder setting: #openOnGroups)
				label: 'Open the browser on groups ?' translated;
				description: 'If true, Nautilus will show groups when opened' translated.
			(aBuilder pickOne: #commentPosition)
				label: 'Position of the comment pane:' translated;
				target: self;
				default: self defaultCommentPosition;
				order: 1;
				domainValues: self commentPositions.
			(aBuilder setting: #showHierarchy)
				label: 'Show hierarchy by default ?' translated;
				description: 'If false, Nautilus will show a flat list of classes' translated.
			(aBuilder setting: #historyMaxSize)
				label: 'Set the max size of the navigation history' translated;
				description: ('By default, the value is ', self defaultMaxSize printString) translated.
			(aBuilder setting: #switchClassesAndPackages)
				label: 'Switch lists when opening on a class ?' translated;
				description: 'Default value: false' translated.
			(aBuilder setting: #warningLimit)
				label: 'Set the warning limit of source code pane' translated;
				description: 'By default, the value is 350
Put a negative value to disable' translated.
			(aBuilder setting: #emptyCommentWarning)
				label: 'Enable/disable warning for empty comments' translated;
				description: 'Enable/disable the warning for empty comments. CAUTION!! To have comments in your classes is highly recomended' translated. 
			(aBuilder setting: #populateMethodList)
				label: 'Populate the method list at opening ?' translated;
				default: self defaultPopulateMethodList;
				description: 'If true, the browser may be a bit slower to open on big classes. If false, you will need an extra click to access a method' translated.
			(aBuilder setting: #useOldStyleKeys)
				label: 'Use old style keys ?' translated;
				description: 'If true, the browser will use the old style keys (This is highly non-recommended, you will lose a lot of cool access keys)' translated.
				
				
				]! !

!Nautilus class methodsFor: 'browser compatibility' stamp: ''!
newOnClass: aClass

	^ self fullOnClass: aClass! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BernardoContreras 7/17/2012 21:20'!
newOnClass: aClass selector: aSelector 

	^ self fullOnClass: aClass selector: aSelector ! !

!Nautilus class methodsFor: 'opening' stamp: ''!
open
	^ self openInEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/19/2012 13:08'!
openBrowser
	
	self open.! !

!Nautilus class methodsFor: 'browser compatibility' stamp: ''!
openBrowserView: aNautilus label: aString 
	
	aNautilus open.
	aNautilus ui selectedMethod: aNautilus selectedMethod.
	aNautilus ui update.
	aNautilus ui title: aString! !

!Nautilus class methodsFor: 'opening' stamp: 'CamilloBruni 9/14/2012 02:10'!
openInEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance 
		browsedEnvironment: anEnvironment;
		open.
	instance ui 
		showPackages: (self switchClassesAndPackages not).
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnCategory: aCategory ofClass: aClass

	^ self openOnCategory: aCategory ofClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 5/13/2012 17:36'!
openOnCategory: aCategory ofClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: aCategory method: nil.
	instance open.
		
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnClass: aClass

	^ self openOnClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'CamilloBruni 9/14/2012 00:58'!
openOnClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance 
		browsedEnvironment: anEnvironment;
		showInstance: aClass isMeta not;
	 	showGroups: false;
	 	package: aClass package class: aClass category: nil method: nil;
	 	open.
	 instance ui 
		showPackages: (self switchClassesAndPackages not);
		giveFocusToProtocol.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnClass: aClass onGroup: aGroup
	
	^ self openOnClass: aClass onGroup: aGroup inEnvironment: self defaultBrowsedEnvironment.! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnClass: aClass onGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 6/26/2012 23:57'!
openOnClass: aClass onProtocol: aProtocol

	^ self 
		openOnClass: aClass 
		onProtocol: aProtocol 
		inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'CamilloBruni 10/4/2012 10:50'!
openOnClass: aClass onProtocol: aProtocol inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance 
		browsedEnvironment: anEnvironment;
		showInstance: aClass isMeta not;
		selectedCategory: aProtocol;
		package: aClass package class: aClass category: nil method: nil;
		open.
	instance ui 
		showPackages: (self switchClassesAndPackages not).
	instance ui 
		selectedCategory: aProtocol;
		categorySelectionChanged;
		changed: #currentHistoryIndex.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnGroup: aGroup

	^ self openOnGroup: aGroup inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
openOnGroups

	^ OpenOnGroups ifNil: [ OpenOnGroups := false ]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
openOnGroups:aBoolean

	OpenOnGroups := aBoolean! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnMethod: aMethod
	
	^ self openOnMethod: aMethod inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'CamilloBruni 9/14/2012 01:03'!
openOnMethod: aMethod inEnvironment: anEnvironment

	| instance class |
	class := aMethod methodClass.
	instance := self new.
	instance 
		browsedEnvironment: anEnvironment;
		showInstance: class isMeta not;
		showGroups: false;
		package: class package class: class category: aMethod protocol asString method: aMethod;
		open.
		
	 instance ui 
		showPackages: (self switchClassesAndPackages not);
		giveFocusToMethod.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnPackage: aPackage

	^ self openOnPackage: aPackage inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories

	^ self openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: ''!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	
	instance package: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod.
	instance selectedGroup: selectedGroup.	
	instance
		showGroups: showGroups;
		showHierarchy: showHierarchy;
		showComment: showComment;
		showInstance: showInstance;
		showCategories: showCategories.
	
	instance open.
	instance ui showPackages: showPackages.
	instance ui forceSelection: selectedCategory.
	instance ui forceSelection: selectedMethod.

	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'CamilloBruni 9/14/2012 01:06'!
openOnPackage: aPackage inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: false.
	instance selectedPackage: aPackage.
	instance open.
	instance ui showPackages: true.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
pluginClasses

	^ PluginClasses ifNil: [ PluginClasses := OrderedCollection new ].! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
pluginClasses: aCollection

	PluginClasses := aCollection! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/5/2013 14:35'!
populateMethodList

	^ populateMethodList ifNil: [ populateMethodList := self defaultPopulateMethodList ]! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/5/2013 14:34'!
populateMethodList: aBoolean

	populateMethodList := aBoolean! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus class methodsFor: 'groups' stamp: ''!
resetCachedLastClasses

	^ cachedLastClasses := nil! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
showAnnotationPane: aBoolean

	ShowAnnotationPane := aBoolean! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
showHierarchy

	^ ShowHierarchy ifNil: [ ShowHierarchy := true ]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
showHierarchy: aBoolean

	ShowHierarchy := aBoolean! !

!Nautilus class methodsFor: 'events' stamp: 'CamilleTeruel 7/29/2012 18:46'!
stopNotifications
	" self stopNotifications "
	SystemAnnouncer uniqueInstance unsubscribe: self! !

!Nautilus class methodsFor: 'settings' stamp: ''!
switchClassesAndPackages

	^ SwitchClassesAndPackages ifNil: [ SwitchClassesAndPackages := false ]! !

!Nautilus class methodsFor: 'settings' stamp: ''!
switchClassesAndPackages: aBoolean

	SwitchClassesAndPackages := aBoolean! !

!Nautilus class methodsFor: 'icon' stamp: ''!
taskbarIcon 

	^ AbstractNautilusUI icon! !

!Nautilus class methodsFor: 'settings' stamp: 'EstebanLorenzano 2/6/2013 14:03'!
useOldStyleKeys
	^useOldStyleKeys ifNil: [ useOldStyleKeys := false ]! !

!Nautilus class methodsFor: 'settings' stamp: 'EstebanLorenzano 2/6/2013 14:27'!
useOldStyleKeys: aBoolean
	useOldStyleKeys := aBoolean! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
warningLimit

	^ WarningLimit ifNil: [ WarningLimit := 350 ]! !

!Nautilus class methodsFor: 'accessing' stamp: ''!
warningLimit: anInteger

	WarningLimit := anInteger! !

!Nautilus methodsFor: 'comparing' stamp: ''!
= aNautilus

	self class = aNautilus class ifFalse: [ ^ false ].
	1 to: self class instVarNames size do: [:index |
		(self instVarAt: index) = (aNautilus instVarAt: index)
			ifFalse: [ ^ false ]].
	^ true! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 4/18/2012 19:16'!
adopt: anAssociation

	| nautilusWrapper |
	nautilusWrapper := anAssociation key.
	self ui ifNotNil: [:interface |
		interface resetSelections].
	self
		selectedPackage: nautilusWrapper selectedPackage;
		selectedClass: nautilusWrapper selectedClass;
		selectedCategory: nautilusWrapper selectedCategory.
		nautilusWrapper selectedMethod
			ifNil: [ self selectedMethod: nil ]
			ifNotNil: [:sel | self selectedMethod: (nautilusWrapper selectedClass methodDict at: sel ifAbsent: [ nil ])].

	self
		selectedGroup: nautilusWrapper selectedGroup;
		showPackages: nautilusWrapper showPackages;
		showGroups: nautilusWrapper showGroups;
		showHierarchy: nautilusWrapper showHierarchy;
		showComment: nautilusWrapper showComment;
		showInstance: nautilusWrapper showInstance;
		showCategories: nautilusWrapper showCategories.
		
	self ui ifNotNil: [:interface || cl |
		cl := nautilusWrapper selectedClass.
		interface showPackages: self showPackages.
		cl
			ifNil: [ interface showInstance: false ] 
			ifNotNil: [ 
				interface showInstance: cl isMeta not.
				cl := cl theNonMetaClass ].
		interface
			selectedPackageWithoutChangingSelectionInternally: nautilusWrapper selectedPackage;
			selectedClassWithoutChangingSelectionInternally: cl;
			selectedCategoryInternally: nautilusWrapper selectedCategory.
		nautilusWrapper selectedMethod
			ifNil: [ interface selectedMethod: nil ]
			ifNotNil: [:sel | interface selectedMethod: (nautilusWrapper selectedClass methodDict at: sel ifAbsent: [ nil ])].
		interface updateBothView.
		interface update].
	"self registerHistoryNewEntry"! !

!Nautilus methodsFor: 'events-registering' stamp: ''!
announce: anAnnouncement

	self announcer announce: anAnnouncement
! !

!Nautilus methodsFor: 'announcement' stamp: ''!
announcer

	^ announcer ifNil: [ announcer := NautilusAnnouncer new ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
browsedEnvironment

	^ browsedEnvironment ifNil: [ browsedEnvironment := RBBrowserEnvironment new ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
browsedEnvironment: anEnvironment

	browsedEnvironment := anEnvironment! !

!Nautilus methodsFor: 'accessing' stamp: ''!
browsingHistory

	^ browsingHistory ifNil: [ browsingHistory := NavigationHistory new ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
classes
	
	^ self browsedEnvironment classes! !

!Nautilus methodsFor: 'private' stamp: ''!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'displaying' stamp: 'CamilloBruni 9/21/2012 13:46'!
close

	ui close! !

!Nautilus methodsFor: 'browser compatibility' stamp: ''!
codeTextMorph

	^ self ui codeTextMorph! !

!Nautilus methodsFor: 'accessing' stamp: ''!
commentPosition

	^ self class commentPosition! !

!Nautilus methodsFor: 'browser compatibility' stamp: ''!
contents: aText

	self ui sourceCode: aText! !

!Nautilus methodsFor: 'displaying' stamp: ''!
defaultUIClass

	^ NautilusUI! !

!Nautilus methodsFor: 'private' stamp: ''!
foundExtentionsIn: aClass

	^ aClass extendingPackages.
! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/14/2012 15:45'!
groupsManager
	
	^ self class groupsManagerFrom: self! !

!Nautilus methodsFor: 'history' stamp: ''!
hasNext
	
	^self browsingHistory hasNext! !

!Nautilus methodsFor: 'history' stamp: ''!
hasPrevious
	
	^self browsingHistory hasPrevious! !

!Nautilus methodsFor: 'history' stamp: ''!
historyEntries

	^ self browsingHistory entries! !

!Nautilus methodsFor: 'private' stamp: ''!
initialize

	super initialize.
	plugins := OrderedCollection new.
	self class pluginClasses do: [:each || class position |
		class := each first.
		position := each second.
		plugins add: ((class model: self) position: position; yourself)]! !

!Nautilus methodsFor: 'browser compatibility' stamp: ''!
labelString

	^ self ui
		ifNil: [ 'Nautilus' ]
		ifNotNil: [:UI | UI title ]! !

!Nautilus methodsFor: 'history' stamp: 'CamilloBruni 10/4/2012 11:31'!
next
	self browsingHistory pauseDuring: [
		self adopt: self browsingHistory next.
		self triggerEvent: #historyChanged ].! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 9/14/2012 14:38'!
open

	ui := (self uiClass on: self) open.
	self announce: (WindowOpened new window: ui window)! !

!Nautilus methodsFor: 'browser compatibility' stamp: ''!
openEditString: aString 

	" Dunno what to do"! !

!Nautilus methodsFor: 'history' stamp: ''!
package: aPackage class: aClass category: aCategory method: aMethod

	self 
		selectedPackage: aPackage;
		selectedClass: aClass;
		selectedCategory: aCategory;
		selectedMethod: aMethod.
		
	self registerHistoryNewEntry.! !

!Nautilus methodsFor: 'accessing' stamp: ''!
packages

	^ self browsedEnvironment packages asArray! !

!Nautilus methodsFor: 'private' stamp: ''!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
plugins

	^ plugins ifNil: [ plugins := OrderedCollection new ]! !

!Nautilus methodsFor: 'history' stamp: 'CamilloBruni 10/4/2012 11:30'!
previous
	self browsingHistory pauseDuring: [
		self adopt: self browsingHistory previous.
		self triggerEvent: #historyChanged ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 9/14/2012 15:48'!
recentClassesElements
	| classes |
	classes := self browsedEnvironment classes.
	
	^ self recentClasses mostViewedElements 
		collect: [:nm | classes 
							detect: [:e | e name = nm ] 
							ifNone: [ nil ]] 
		thenSelect: [:e | e notNil ]! !

!Nautilus methodsFor: 'history' stamp: 'CamilloBruni 10/4/2012 11:32'!
registerHistoryNewEntry

	| lastEntry wrapper |
	self browsingHistory isPaused ifTrue: [ ^ self ].
	wrapper := NautilusWrapper with: self.
	self browsingHistory entries ifNotEmpty:[:entries |
		lastEntry := entries last key.
		(lastEntry selectedClass isNil 
		or: [(wrapper selectedClass notNil 
			and: [wrapper selectedMethod = lastEntry selectedMethod 
			and: [ wrapper selectedClass theNonMetaClass = lastEntry selectedClass theNonMetaClass ]])]) 
				ifTrue: [ ^ self ]].
	wrapper showGroups
			ifTrue: [ wrapper selectedGroup ifNil:[ ^ self ]]
			ifFalse: [ wrapper selectedClass ifNil:[ ^ self ]].
	
	self browsingHistory add: wrapper.
	self triggerEvent: #historyChanged.! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedCategory: anObject

	selectedCategory := anObject.
	self selectedMethod: nil.
	self announcer announce: ( NautilusProtocolSelected category: anObject )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/14/2012 15:33'!
selectedClass: aClass

	selectedClass := aClass.
	self selectedCategory: nil.
	aClass ifNotNil: [ self recentClasses add: aClass theNonMetaClass name ].
	self announcer announce: ( NautilusClassSelected class: aClass )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedGroup: anObject

	selectedGroup := anObject.
	self announcer announce: ( NautilusGroupSelected group: anObject ).! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedMethod: anObject

	selectedMethod := anObject.
	self announcer announce: ( NautilusMethodSelected method: anObject )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: ''!
selectedPackage: anObject

	selectedPackage := anObject.
	self announcer announce: ( NautilusPackageSelected package: anObject )! !

!Nautilus methodsFor: 'browser compatibility' stamp: ''!
setClass: aClass selector: aSelector 
	
	| method protocol |
	method := aClass methodDict at: aSelector ifAbsent: [ nil ].
	protocol := method 
					ifNil: [ nil ]
					ifNotNil: [ method protocol ].
	self 
		showGroups: false;
		selectedPackage: aClass package;
		selectedClass: aClass;
		showInstance: aClass isMeta not;
		selectedCategory: protocol;
		selectedMethod: method
	! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/14/2012 15:52'!
shouldOpenOnGroups

	^ self class openOnGroups and: [ (self class groupsManagerFrom: self) isEmpty not ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showCategories

	^ showCategories ifNil: [ showCategories := true ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showCategories: aBoolean

	showCategories := aBoolean.
	self announcer announce: ( NautilusShowCategoriesChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showComment

	^ showComment ifNil: [ showComment := false ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showComment: aBoolean

	showComment := aBoolean.
	self announcer announce: ( NautilusShowCommentChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showGroups

	^ showGroups ifNil: [ showGroups := self shouldOpenOnGroups ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showGroups: aBoolean

	showGroups := aBoolean.
	self announcer announce: ( NautilusShowGroupsChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showHierarchy

	^ showHierarchy ifNil: [ showHierarchy := self class showHierarchy ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showHierarchy: aBoolean

	showHierarchy := aBoolean.
	self announcer announce: ( NautilusShowHierarchyChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showInstance

	^ showInstance ifNil: [ showInstance := true ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showInstance: aBoolean

	showInstance := aBoolean.
	self announcer announce: ( NautilusShowInstanceChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showPackages

	^ showPackages ifNil: [ showPackages := true ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
showPackages: aBoolean

	showPackages := aBoolean.
	self announcer announce: ( NautilusShowPackagesChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'browser compatibility' stamp: ''!
spawnHierarchy

	self 
		showHierarchy:true;
		open.
	self ui showPackages: false! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/6/2012 17:44'!
spawnHierarchyForClass: aClass selector: aSelector

	self setClass: aClass selector: aSelector.
	self spawnHierarchy! !

!Nautilus methodsFor: 'accessing' stamp: ''!
switchClassesAndPackages

	^ self class switchClassesAndPackages! !

!Nautilus methodsFor: 'accessing' stamp: ''!
ui

	^ ui! !

!Nautilus methodsFor: 'accessing' stamp: ''!
uiClass

	^ uiClass ifNil: [ self defaultUIClass ]! !

!Nautilus methodsFor: 'accessing' stamp: ''!
uiClass: aClass

	uiClass := aClass! !

!Nautilus methodsFor: 'private' stamp: ''!
warningLimit

	^ self class warningLimit! !

Object subclass: #NautilusMCBindings
	instanceVariableNames: 'bindingsRtoMC bindingsMCtoR'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Nautilus-MCBindings'!

!NautilusMCBindings commentStamp: '<historical>' prior: 0!
A NautilusMCBindings is a class which basically kept bindings between RPackages and MCPackage!

!NautilusMCBindings class methodsFor: 'instance creation' stamp: ''!
default

	^ Default ifNil: [ Default := self basicNew initialize ]! !

!NautilusMCBindings class methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for NautilusMCBindings class"

	super initialize.
	
	RPackageOrganizer default packages do: [:p | self default mcPackageFor: p ]! !

!NautilusMCBindings class methodsFor: 'instance creation' stamp: ''!
new

	self error: 'I am a singleton'! !

!NautilusMCBindings methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for NautilusMCBindings"

	super initialize.

	bindingsRtoMC := IdentityDictionary new.
	bindingsMCtoR := IdentityDictionary new.
	self registerToMCAnnouncements.! !

!NautilusMCBindings methodsFor: 'protocol' stamp: ''!
mcPackageFor: aRPackage

	^ bindingsRtoMC 
		at: aRPackage 
		ifAbsent: [
			( self retrieveMCPackageFor: aRPackage )
				ifNotNil: [:mcPackage | 
					(bindingsMCtoR at: mcPackage ifAbsentPut: (Set new)) add: aRPackage.
					bindingsRtoMC at: aRPackage put: mcPackage ]
				ifNil: [ nil ]]! !

!NautilusMCBindings methodsFor: 'announcements' stamp: ''!
mcWorkingCopyCreated: anAnnouncement
	| package rpackage mcPackage |
	
	package := anAnnouncement package.
	package ifNil: [ ^ self ].
	rpackage := RPackageOrganizer default packageNamed: package name.
	mcPackage := bindingsRtoMC at: rpackage ifAbsent: [ ^ self ].
	(bindingsMCtoR at: mcPackage) do: [:pck | bindingsRtoMC removeKey: pck  ifAbsent: []]! !

!NautilusMCBindings methodsFor: 'announcements' stamp: ''!
mcWorkingCopyDeleted: anAnnouncement
	| package rpackages |
	
	package := anAnnouncement package.
	package ifNil: [ ^ self ].
	rpackages := bindingsMCtoR at: package ifAbsent: [ ^self ].
	rpackages do: [:rpackage | bindingsRtoMC removeKey: rpackage ifAbsent: [ ]].
	bindingsMCtoR removeKey: package ifAbsent: []! !

!NautilusMCBindings methodsFor: 'protocol' stamp: ''!
rPackagesFor: aMCPackage

	^ bindingsMCtoR 
		at: aMCPackage 
		ifAbsentPut: [ self retrieveRPackagesFor: aMCPackage ]! !

!NautilusMCBindings methodsFor: 'initialization' stamp: 'EstebanLorenzano 8/3/2012 14:12'!
registerToMCAnnouncements

	SystemAnnouncer uniqueInstance weak
		on: MCWorkingCopyCreated send: #mcWorkingCopyCreated: to: self;
		on: MCWorkingCopyDeleted send: #mcWorkingCopyDeleted: to: self! !

!NautilusMCBindings methodsFor: 'private' stamp: ''!
retrieveMCPackageFor: aRPackage
	| name mcPackages |

	mcPackages := MCWorkingCopy allManagers.
	name := aRPackage name.
	[ name isEmpty ]
		whileFalse: [| package |
			package := (mcPackages detect: [ :mc | mc package name = name ] ifNone: [ nil ]).
			package
				ifNil: [ name := (name subStrings: '-') allButLast joinUsing: '-' ]
				ifNotNil: [ ^ package package ]].
	^ nil! !

!NautilusMCBindings methodsFor: 'private' stamp: ''!
retrieveRPackagesFor: aMCPackage


	^ (RPackageOrganizer default packages select: [:e | e name beginsWith: aMCPackage name ]) asSet! !

Object subclass: #NautilusMonticello
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusMonticello commentStamp: '<historical>' prior: 0!
A NautilusMonticello is a class used to handle monticello integration into Nautilus by creating the menu entries!

!NautilusMonticello class methodsFor: 'singleton' stamp: ''!
default

	^ Default ifNil: [ Default := self basicNew initialize ]! !

!NautilusMonticello class methodsFor: 'private' stamp: ''!
iconClass

	^ NautilusIcons! !

!NautilusMonticello class methodsFor: 'instance creation' stamp: ''!
new

	self default! !

!NautilusMonticello class methodsFor: 'monticello menus' stamp: 'EstebanLorenzano 1/30/2013 15:52'!
packagesChangesMenu: aBuilder
	<nautilusGlobalPackageMenu>
	| package mcpackage target |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^ target ].
	mcpackage := (NautilusMCBindings default mcPackageFor: package).
	mcpackage ifNil: [ ^ self ].
	
	mcpackage isDirty
		ifTrue: [ 
			(aBuilder item: #('Changes with ',package name))
				label: 'Changes with...';
				order: 1295;
				help: 'Changes';
				icon: (self iconClass iconNamed: #monticelloPackage);
				enabledBlock: [ target selectedPackages size < 2 ].
				
	mcpackage workingCopy repositoryGroup repositories doWithIndex: [:repo : index |
		(aBuilder item: ('Repo',index printString))
					label: repo description;
					parent: #('Changes with ',package name);
					order: index;
					action: [ self default viewChangesFor: mcpackage in: repo ]]]! !

!NautilusMonticello class methodsFor: 'monticello menus' stamp: 'EstebanLorenzano 1/30/2013 15:52'!
packagesCommitsMenu: aBuilder
	<nautilusGlobalPackageMenu>
	| package mcpackage target |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^ target ].
	mcpackage := (NautilusMCBindings default mcPackageFor: package).
	mcpackage ifNil: [ ^self ].
	
	mcpackage isDirty
		ifTrue: [ | last group |
			(aBuilder item: #('Commit in ',package name))
				label: 'Commit in...';
				order: 1296;
				help: 'Commit';
				icon: (self iconClass iconNamed: #monticelloPackage);
				enabledBlock: [ target selectedPackages size < 2 ].
	(group := mcpackage workingCopy repositoryGroup) repositories doWithIndex: [:repo : index |
		last := ((aBuilder item: ('Repo',index printString))
					label: repo description;
					parent: #('Commit in ',package name);
					order: index;
					action: [ self default commit: mcpackage workingCopy in: repo ])].
		last withSeparatorAfter.
		(aBuilder item: 'Add a repository')
						parent: #('Commit in ',package name);
						order: 99;
						action: [ self default addRepositoryTo: group ]]! !

!NautilusMonticello class methodsFor: 'monticello menus' stamp: 'EstebanLorenzano 1/30/2013 15:52'!
packagesCreateMenu: aBuilder
	<nautilusGlobalPackageMenu>
	| package mcpackage target |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^ target ].
	mcpackage := NautilusMCBindings default mcPackageFor: package.
	mcpackage ifNotNil: [ ^ self ].
	
	(aBuilder item: #'Create a MC package')
		order: 1297;
		help: 'Create a MC package corresponding to my name';
		icon: (self iconClass iconNamed: #monticelloPackage);
		action: [ self default createMCPackageFor: target selectedPackage ];
		enabledBlock: [ target selectedPackages size < 2 ].! !

!NautilusMonticello class methodsFor: 'monticello menus' stamp: 'EstebanLorenzano 1/30/2013 15:52'!
packagesOpenMenu: aBuilder
	<nautilusGlobalPackageMenu>
	| package mcpackage target last group |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^ target ].
	mcpackage := NautilusMCBindings default mcPackageFor: package.
	mcpackage ifNil: [ ^ self ].
	
	(aBuilder item: #('Open ',package name))
		label: 'Open...';
		order: 1297;
		help: 'Open';
		icon: (self iconClass iconNamed: #monticelloPackage);
		enabledBlock: [ target selectedPackages size < 2 ].

	(group := mcpackage workingCopy repositoryGroup) repositories doWithIndex: [:repo : index |
		last := (aBuilder item: ('Repo',index printString))
					label: repo description;
					parent: #('Open ',package name);
					order: index;
					action: [ self default open: mcpackage in: repo ]].
	last withSeparatorAfter.
		(aBuilder item: 'Add a repository')
						parent: #('Open ',package name);
						order: 99;
						action: [ self default addRepositoryTo: group ]! !

!NautilusMonticello class methodsFor: 'monticello menus' stamp: 'EstebanLorenzano 1/30/2013 15:52'!
packagesSliceMenu: aBuilder
	<nautilusGlobalPackageMenu>
	| target |
	target := aBuilder model.
	(aBuilder item: #'Create Slice and commit it')
		order: 1298;
		help: 'Create a slice and commit it into PharoInbox';
		action: [ self default postNewSliceFor: target window ];
		icon: (self iconClass iconNamed: #monticelloPackage).
		
	(aBuilder item: #'Create Slice')
		order: 1299;
		help: 'Create a slice';
		action: [ self default addSliceFor: target window ];
		icon: (self iconClass iconNamed: #monticelloPackage);
		withSeparatorAfter.! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
addRepositoryTo: aGroup
	| repo |
	(repo := self newRepository) ifNil: [ ^ self ].
	aGroup addRepository: repo.! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
addSliceFor: aWindow

	(MCSliceMaker openFor: aWindow)
		ifNotNil: [:sliceInfo || workingCopy |
			 workingCopy := sliceInfo makeSlice.
			workingCopy ifNotNil: [
					workingCopy repositoryGroup addRepository: MCHttpRepository inboxRepository.
					^ workingCopy ]].
	^ nil! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
commit: workingCopy in: repo
	| newVersion |

	newVersion := workingCopy newVersion.
	newVersion ifNil: [ ^ self ].
	Cursor wait showWhile: [
		[ 	repo storeVersion: newVersion.
			repo storeDependencies: newVersion ] 
		ensure: [ (MCVersionInspector new version: newVersion) show ]]! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
createMCPackageFor: aPackage
	| name |
	name := aPackage name.
	name isEmptyOrNil ifFalse: [ MCWorkingCopy forPackage: (MCPackage new name: name) ]! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
newRepository
	| types index |
	types := MCRepository allConcreteSubclasses asArray.
	index := UIManager default chooseFrom: (types collect: [:ea | ea description])
				title: 'Repository type:'.
	^ index = 0 ifFalse: [(types at: index) morphicConfigure]! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
open: mcpackage in: repo 
	| workingCopy |

	repo ifNil: [ ^ self ].
	workingCopy := mcpackage workingCopy.
	repo morphicOpen: workingCopy! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: ''!
postNewSliceFor: aWindow
	| workingCopy |
	(workingCopy := self addSliceFor: aWindow) ifNil: [ ^ self ].
	self commit: workingCopy in: MCHttpRepository inboxRepository! !

!NautilusMonticello methodsFor: 'display' stamp: ''!
viewChanges: patch from: fromDescription to: toDescription in: workingCopy
	"Open a browser on the given patch."

	PSMCPatchMorph usedByDefault
		ifTrue: [((PSMCPatchMorph forPatch: patch)
						fromDescription: fromDescription;
						toDescription: toDescription;
						newWindow)
					title: ('Changes to {1}' translated format: {fromDescription});
					open]
		ifFalse: [(MCPatchBrowser forPatch: patch)
					label: 'Patch Browser: ', workingCopy description;
					show]! !

!NautilusMonticello methodsFor: 'monticello menus behavior' stamp: 'SeanDeNigris 6/21/2012 09:10'!
viewChangesFor: mcpackage in: repo
	| workingCopy patch |

	workingCopy := mcpackage workingCopy.
	'Finding changes' displayProgressFrom: 0 to: 10 during:[:bar|
		bar current: 1.
		patch := workingCopy changesRelativeToRepository: repo.
		bar current: 3.
		patch isEmpty
			ifTrue: [
				workingCopy modified: false.
				bar current: 10.
				self inform: 'No changes' ]
			ifFalse: [
				workingCopy modified: true.
				bar current: 5.
				self
					viewChanges: patch
					from: workingCopy  packageName, ' (', workingCopy ancestry ancestorString, ')'
					to: ('Modified {1}' translated format: {workingCopy description})
					in: workingCopy ]]! !

Object subclass: #NavigationHistory
	instanceVariableNames: 'storage index maxSize paused'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-History'!

!NavigationHistory commentStamp: '<historical>' prior: 0!
I act as a web browser history!

!NavigationHistory class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/13/2012 16:37'!
defaultMaxSize

	^ 15! !

!NavigationHistory methodsFor: 'collection compatibility' stamp: 'BenjaminVanRyseghem 3/13/2012 16:13'!
add: anEntry

	self addEntry: anEntry! !

!NavigationHistory methodsFor: 'protocol' stamp: 'CamilloBruni 10/4/2012 11:29'!
addEntry: anEntry
	
	self isPaused ifTrue: [ ^ self ].
	
	( storage isEmpty not  and: [ storage last = anEntry ] ) ifTrue: [ ^ self ].
	anEntry = self current key ifTrue: [ ^ self ].
	self checkSize.
	index := index +1.
	index > storage size
		ifTrue: [ storage addLast:  (anEntry -> TimeStamp now)]
		ifFalse: [ 
			storage := storage copyFrom: 1 to: index.
			storage at: index put: (anEntry -> TimeStamp now)]! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/11/2011 15:09'!
back

	index := ((index - 1) max: 0)! !

!NavigationHistory methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 13:42'!
checkSize
	
	[ storage size >= self maxSize ]
		whileTrue: [ 
			storage removeFirst.
			index := index -1].! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/11/2011 16:11'!
current

	^ storage at: index ifAbsent: [ nil -> nil ]! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/13/2012 04:03'!
entries

	^ storage! !

!NavigationHistory methodsFor: 'testing' stamp: 'CamilloBruni 10/4/2012 11:17'!
hasNext

	^ index < storage size! !

!NavigationHistory methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 5/12/2011 13:01'!
hasPrevious

	^ index > 1! !

!NavigationHistory methodsFor: 'initialize-release' stamp: 'CamilloBruni 10/4/2012 11:29'!
initialize

	storage := OrderedCollection new.
	index := 0.
	paused := false.! !

!NavigationHistory methodsFor: 'testing' stamp: 'CamilloBruni 10/4/2012 11:30'!
isPaused
	^ paused! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/11/2011 15:09'!
last

	^ storage last! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/19/2011 11:05'!
maxSize

	^ maxSize ifNil: [ maxSize := self class defaultMaxSize ].! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 22:53'!
maxSize: anInteger

	maxSize := anInteger! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/12/2011 12:25'!
next

	index := ((index + 1) min: storage size).
	^ storage at: index! !

!NavigationHistory methodsFor: 'protocol' stamp: 'CamilloBruni 10/4/2012 11:32'!
pauseDuring: aBlock
	| previousPausedValue |
	"Don't accept any new entries while executing aBlock"
	previousPausedValue := paused.
	paused := true.
	aBlock ensure: [ paused := previousPausedValue ]! !

!NavigationHistory methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/12/2011 12:25'!
previous

	index := index-1 max: 1.
	^ storage at: index! !

!Object methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 12:00'!
nautilusIcon

	^ self nautilusIconClass iconNamed: #blank! !

!Object methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/2/2013 11:57'!
nautilusIconClass

	^ NautilusIcons! !
Nautilus initialize!
NautilusMCBindings initialize!
AbstractNautilusUI initialize!
